GNU bug report logs - #35383
27.0.50; Complete process of decoding Gnus group names

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: Eric Abrahamsen <eric@HIDDEN>; Keywords: fixed; Done: Lars Ingebrigtsen <larsi@HIDDEN>; Maintainer for emacs is bug-gnu-emacs@HIDDEN.
bug marked as fixed in version 27.1, send any further explanations to 35383 <at> debbugs.gnu.org and Eric Abrahamsen <eric@HIDDEN> Request was from Lars Ingebrigtsen <larsi@HIDDEN> to control <at> debbugs.gnu.org. Full text available.
Added tag(s) fixed. Request was from Lars Ingebrigtsen <larsi@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 27 Sep 2019 14:58:29 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Sep 27 10:58:29 2019
Received: from localhost ([127.0.0.1]:48374 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iDrhU-00067f-BS
	for submit <at> debbugs.gnu.org; Fri, 27 Sep 2019 10:58:28 -0400
Received: from quimby.gnus.org ([80.91.231.51]:33034)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1iDrhQ-00067V-1A
 for 35383 <at> debbugs.gnu.org; Fri, 27 Sep 2019 10:58:24 -0400
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=marnie)
 by quimby.gnus.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.89) (envelope-from <larsi@HIDDEN>)
 id 1iDrhM-0002l5-OV; Fri, 27 Sep 2019 16:58:23 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eric Abrahamsen <eric@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN>
 <87lfy0bv9e.fsf@HIDDEN> <87sgs8z9zv.fsf@HIDDEN>
 <874l4ob2qm.fsf@HIDDEN> <87zhmdthjx.fsf@HIDDEN>
 <87imt18d9n.fsf@HIDDEN>
 <trinity-810a86e0-9451-49b2-817f-5420e9ce1adb-1561035623205@3c-app-mailcom-bs02>
 <874l4k5ifs.fsf@HIDDEN> <877e9g9j48.fsf@HIDDEN>
 <87a7ec3w4j.fsf@HIDDEN>
 <87o92qzmc5.fsf@HIDDEN> <87y31t8yso.fsf@HIDDEN>
 <87v9wxy53y.fsf@HIDDEN> <87r27klhpv.fsf@HIDDEN>
 <87o925z0h2.fsf@HIDDEN> <87k1cscns2.fsf@HIDDEN>
 <87imrjm8kx.fsf@HIDDEN> <87y30dm6m3.fsf@HIDDEN>
 <87lfw9x6dl.fsf@HIDDEN>
Date: Fri, 27 Sep 2019 16:58:20 +0200
In-Reply-To: <87lfw9x6dl.fsf@HIDDEN> (Eric Abrahamsen's message of
 "Sat, 03 Aug 2019 14:53:58 -0700")
Message-ID: <87v9tdlrar.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Eric Abrahamsen <eric@HIDDEN> writes: >> I've
 only... skimmed it (if you can call it that), but the main idea is >> sound.
 As there isn't any test harness for this, really, I guess the >> only way
 to find out whether there's any fallout f [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 35383
Cc: 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eric Abrahamsen <eric@HIDDEN> writes:

>> I've only...  skimmed it (if you can call it that), but the main idea is
>> sound.  As there isn't any test harness for this, really, I guess the
>> only way to find out whether there's any fallout from this change is to
>> apply it and see what breaks, and then fix that.  So when it's applied
>> you should be on hand to quickly fix breakages over the next week or
>> so.  :-)
>
> Bombs away...

It seemed like everything worked fine.  :-) So I'm closing this bug
report.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 3 Aug 2019 21:54:10 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Aug 03 17:54:10 2019
Received: from localhost ([127.0.0.1]:60163 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hu1yb-0002es-JQ
	for submit <at> debbugs.gnu.org; Sat, 03 Aug 2019 17:54:10 -0400
Received: from ericabrahamsen.net ([52.70.2.18]:52182
 helo=mail.ericabrahamsen.net)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eric@HIDDEN>) id 1hu1yZ-0002eN-Cp
 for 35383 <at> debbugs.gnu.org; Sat, 03 Aug 2019 17:54:08 -0400
Received: from localhost (c-73-254-86-141.hsd1.wa.comcast.net [73.254.86.141])
 (Authenticated sender: eric@HIDDEN)
 by mail.ericabrahamsen.net (Postfix) with ESMTPSA id 4B9AEFA0A3;
 Sat,  3 Aug 2019 21:54:00 +0000 (UTC)
From: Eric Abrahamsen <eric@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN>
 <87lfy0bv9e.fsf@HIDDEN> <87sgs8z9zv.fsf@HIDDEN>
 <874l4ob2qm.fsf@HIDDEN> <87zhmdthjx.fsf@HIDDEN>
 <87imt18d9n.fsf@HIDDEN>
 <trinity-810a86e0-9451-49b2-817f-5420e9ce1adb-1561035623205@3c-app-mailcom-bs02>
 <874l4k5ifs.fsf@HIDDEN> <877e9g9j48.fsf@HIDDEN>
 <87a7ec3w4j.fsf@HIDDEN>
 <87o92qzmc5.fsf@HIDDEN> <87y31t8yso.fsf@HIDDEN>
 <87v9wxy53y.fsf@HIDDEN> <87r27klhpv.fsf@HIDDEN>
 <87o925z0h2.fsf@HIDDEN> <87k1cscns2.fsf@HIDDEN>
 <87imrjm8kx.fsf@HIDDEN> <87y30dm6m3.fsf@HIDDEN>
Date: Sat, 03 Aug 2019 14:53:58 -0700
In-Reply-To: <87y30dm6m3.fsf@HIDDEN> (Lars Ingebrigtsen's message of
 "Thu, 01 Aug 2019 14:07:32 +0200")
Message-ID: <87lfw9x6dl.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 35383
Cc: 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)


On 08/01/19 14:07 PM, Lars Ingebrigtsen wrote:
> Eric Abrahamsen <eric@HIDDEN> writes:
>
>> Okay, I decided to squash into two commits: the first holding the vast
>> majority of the changes (but still fairly atomic), and the second
>> holding some temporary backward compatibility tomfoolery, which should
>> be replaced by a proper upgrade (including an uptick to Gnus' version)
>> before 27 is released.
>>
>> Speak now! Or... file bug reports later.
>
> Wow.  That's a huge patch.  :-)
>
> I've only...  skimmed it (if you can call it that), but the main idea is
> sound.  As there isn't any test harness for this, really, I guess the
> only way to find out whether there's any fallout from this change is to
> apply it and see what breaks, and then fix that.  So when it's applied
> you should be on hand to quickly fix breakages over the next week or
> so.  :-)

Bombs away...




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 1 Aug 2019 16:22:28 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Aug 01 12:22:28 2019
Received: from localhost ([127.0.0.1]:54976 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1htDqW-0007zz-5J
	for submit <at> debbugs.gnu.org; Thu, 01 Aug 2019 12:22:28 -0400
Received: from lists.gnu.org ([209.51.188.17]:47787)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1htDqU-0007zs-GM
 for submit <at> debbugs.gnu.org; Thu, 01 Aug 2019 12:22:26 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:53185)
 by lists.gnu.org with esmtp (Exim 4.86_2)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1htDqM-0008QN-TJ
 for bug-gnu-emacs@HIDDEN; Thu, 01 Aug 2019 12:22:23 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: *
X-Spam-Status: No, score=1.8 required=5.0 tests=BAYES_50,RDNS_DYNAMIC,
 URIBL_BLOCKED autolearn=disabled version=3.3.2
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1htDqL-0007Pp-1r
 for bug-gnu-emacs@HIDDEN; Thu, 01 Aug 2019 12:22:18 -0400
Received: from 195-159-176-226.customer.powertech.no ([195.159.176.226]:34848
 helo=blaine.gmane.org)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1htDqK-000778-4G
 for bug-gnu-emacs@HIDDEN; Thu, 01 Aug 2019 12:22:17 -0400
Received: from list by blaine.gmane.org with local (Exim 4.89)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1htDqF-000Hx9-CB
 for bug-gnu-emacs@HIDDEN; Thu, 01 Aug 2019 18:22:11 +0200
X-Injected-Via-Gmane: http://gmane.org/
To: bug-gnu-emacs@HIDDEN
From: Eric Abrahamsen <eric@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
Date: Thu, 01 Aug 2019 09:22:03 -0700
Message-ID: <871ry4hn4k.fsf@HIDDEN>
References: <878sw1995f.fsf@HIDDEN>
 <87lfy0bv9e.fsf@HIDDEN> <87sgs8z9zv.fsf@HIDDEN>
 <874l4ob2qm.fsf@HIDDEN> <87zhmdthjx.fsf@HIDDEN>
 <87imt18d9n.fsf@HIDDEN>
 <trinity-810a86e0-9451-49b2-817f-5420e9ce1adb-1561035623205@3c-app-mailcom-bs02>
 <874l4k5ifs.fsf@HIDDEN> <877e9g9j48.fsf@HIDDEN>
 <87a7ec3w4j.fsf@HIDDEN>
 <87o92qzmc5.fsf@HIDDEN> <87y31t8yso.fsf@HIDDEN>
 <87v9wxy53y.fsf@HIDDEN> <87r27klhpv.fsf@HIDDEN>
 <87o925z0h2.fsf@HIDDEN> <87k1cscns2.fsf@HIDDEN>
 <87imrjm8kx.fsf@HIDDEN> <87y30dm6m3.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
Cancel-Lock: sha1:60FOyfx/FZe2FxnAVfxKAjc5VgU=
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 195.159.176.226
X-Spam-Score: -2.1 (--)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.1 (---)

Lars Ingebrigtsen <larsi@HIDDEN> writes:

> Eric Abrahamsen <eric@HIDDEN> writes:
>
>> Okay, I decided to squash into two commits: the first holding the vast
>> majority of the changes (but still fairly atomic), and the second
>> holding some temporary backward compatibility tomfoolery, which should
>> be replaced by a proper upgrade (including an uptick to Gnus' version)
>> before 27 is released.
>>
>> Speak now! Or... file bug reports later.
>
> Wow.  That's a huge patch.  :-)

Yes it is! Though most of it is just removing calls to
`gnus-group-decoded-name' and associated let bindings. The part I'm
least confident about is the removal of
`nnmail-group-names-not-encoded-p', since there's more filesystem
interaction.

> I've only... skimmed it (if you can call it that), but the main idea is
> sound.  As there isn't any test harness for this, really, I guess the
> only way to find out whether there's any fallout from this change is to
> apply it and see what breaks, and then fix that.  So when it's applied
> you should be on hand to quickly fix breakages over the next week or
> so.  :-)

I haven't come up with any good method of automated testing. I've
started putting "interactive" tests in the gnus-mock package, where you
start up a Gnus instance and then run the tests and watch them go. I
can't think of any better approach right now.

I will definitely be on call for the next few weeks!

Eric





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 1 Aug 2019 12:07:38 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Aug 01 08:07:38 2019
Received: from localhost ([127.0.0.1]:53619 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ht9ru-0000zE-Cm
	for submit <at> debbugs.gnu.org; Thu, 01 Aug 2019 08:07:38 -0400
Received: from quimby.gnus.org ([80.91.231.51]:38698)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1ht9rt-0000z5-7I
 for 35383 <at> debbugs.gnu.org; Thu, 01 Aug 2019 08:07:37 -0400
Received: from 77.18.62.220.tmi.telenormobil.no ([77.18.62.220] helo=sandy)
 by quimby.gnus.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.89) (envelope-from <larsi@HIDDEN>)
 id 1ht9rp-0006YD-3l; Thu, 01 Aug 2019 14:07:35 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eric Abrahamsen <eric@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN>
 <87lfy0bv9e.fsf@HIDDEN> <87sgs8z9zv.fsf@HIDDEN>
 <874l4ob2qm.fsf@HIDDEN> <87zhmdthjx.fsf@HIDDEN>
 <87imt18d9n.fsf@HIDDEN>
 <trinity-810a86e0-9451-49b2-817f-5420e9ce1adb-1561035623205@3c-app-mailcom-bs02>
 <874l4k5ifs.fsf@HIDDEN> <877e9g9j48.fsf@HIDDEN>
 <87a7ec3w4j.fsf@HIDDEN>
 <87o92qzmc5.fsf@HIDDEN> <87y31t8yso.fsf@HIDDEN>
 <87v9wxy53y.fsf@HIDDEN> <87r27klhpv.fsf@HIDDEN>
 <87o925z0h2.fsf@HIDDEN> <87k1cscns2.fsf@HIDDEN>
 <87imrjm8kx.fsf@HIDDEN>
Date: Thu, 01 Aug 2019 14:07:32 +0200
In-Reply-To: <87imrjm8kx.fsf@HIDDEN> (Eric Abrahamsen's message of
 "Tue, 30 Jul 2019 16:00:30 -0700")
Message-ID: <87y30dm6m3.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Eric Abrahamsen <eric@HIDDEN> writes: > Okay,
 I decided to squash into two commits: the first holding the vast > majority
 of the changes (but still fairly atomic),
 and the second > holding some temporary
 backward compatibility tomfoolery, [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 0.0 TVD_RCVD_IP            Message was received from an IP address
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 35383
Cc: 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eric Abrahamsen <eric@HIDDEN> writes:

> Okay, I decided to squash into two commits: the first holding the vast
> majority of the changes (but still fairly atomic), and the second
> holding some temporary backward compatibility tomfoolery, which should
> be replaced by a proper upgrade (including an uptick to Gnus' version)
> before 27 is released.
>
> Speak now! Or... file bug reports later.

Wow.  That's a huge patch.  :-)

I've only...  skimmed it (if you can call it that), but the main idea is
sound.  As there isn't any test harness for this, really, I guess the
only way to find out whether there's any fallout from this change is to
apply it and see what breaks, and then fix that.  So when it's applied
you should be on hand to quickly fix breakages over the next week or
so.  :-)

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 30 Jul 2019 23:00:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jul 30 19:00:49 2019
Received: from localhost ([127.0.0.1]:51356 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hsb6q-0008Uc-1B
	for submit <at> debbugs.gnu.org; Tue, 30 Jul 2019 19:00:49 -0400
Received: from ericabrahamsen.net ([52.70.2.18]:33102
 helo=mail.ericabrahamsen.net)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eric@HIDDEN>) id 1hsb6k-0008Tg-7C
 for 35383 <at> debbugs.gnu.org; Tue, 30 Jul 2019 19:00:41 -0400
Received: from localhost (c-73-254-86-141.hsd1.wa.comcast.net [73.254.86.141])
 (Authenticated sender: eric@HIDDEN)
 by mail.ericabrahamsen.net (Postfix) with ESMTPSA id C8150FA0A3
 for <35383 <at> debbugs.gnu.org>; Tue, 30 Jul 2019 23:00:31 +0000 (UTC)
From: Eric Abrahamsen <eric@HIDDEN>
To: 35383 <at> debbugs.gnu.org 
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN>
 <87lfy0bv9e.fsf@HIDDEN> <87sgs8z9zv.fsf@HIDDEN>
 <874l4ob2qm.fsf@HIDDEN> <87zhmdthjx.fsf@HIDDEN>
 <87imt18d9n.fsf@HIDDEN>
 <trinity-810a86e0-9451-49b2-817f-5420e9ce1adb-1561035623205@3c-app-mailcom-bs02>
 <874l4k5ifs.fsf@HIDDEN> <877e9g9j48.fsf@HIDDEN>
 <87a7ec3w4j.fsf@HIDDEN>
 <87o92qzmc5.fsf@HIDDEN> <87y31t8yso.fsf@HIDDEN>
 <87v9wxy53y.fsf@HIDDEN> <87r27klhpv.fsf@HIDDEN>
 <87o925z0h2.fsf@HIDDEN> <87k1cscns2.fsf@HIDDEN>
Date: Tue, 30 Jul 2019 16:00:30 -0700
In-Reply-To: <87k1cscns2.fsf@HIDDEN> (Deus Max's message of "Mon, 08
 Jul 2019 22:46:37 +0300")
Message-ID: <87imrjm8kx.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 35383
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

--=-=-=
Content-Type: text/plain

Okay, I decided to squash into two commits: the first holding the vast
majority of the changes (but still fairly atomic), and the second
holding some temporary backward compatibility tomfoolery, which should
be replaced by a proper upgrade (including an uptick to Gnus' version)
before 27 is released.

Speak now! Or... file bug reports later.


--=-=-=
Content-Type: text/x-patch
Content-Disposition: attachment;
 filename=0002-Temporarily-preserve-encoded-Gnus-group-names-in-Gnu.patch

From 2b8ba00dc88398d44f606451980e5ceed56ddb3d Mon Sep 17 00:00:00 2001
From: Eric Abrahamsen <eric@HIDDEN>
Date: Thu, 6 Jun 2019 20:43:27 -0700
Subject: [PATCH 2/2] Temporarily preserve encoded Gnus group names in Gnus
 files

Non-ascii Gnus groups should be written to files in their encoded
version until we're ready to bump Gnus' version and add an upgrade
routine.

* lisp/gnus/gnus-start.el (gnus-gnus-to-quick-newsrc-format):
* lisp/gnus/gnus-agent.el (gnus-category-read):
  (gnus-category-write): Handle non-ascii group names appropriately.
* lisp/gnus/gnus-registry.el (gnus-registry--munge-group-names): New
  function to encode/decode group names.
  (gnus-registry-fixup-registry):
  (gnus-registry-save): Use function.
---
 lisp/gnus/gnus-agent.el    | 102 ++++++++++++++++++++++---------------
 lisp/gnus/gnus-registry.el |  59 +++++++++++++++++++--
 lisp/gnus/gnus-start.el    |  39 +++++++++-----
 3 files changed, 144 insertions(+), 56 deletions(-)

diff --git a/lisp/gnus/gnus-agent.el b/lisp/gnus/gnus-agent.el
index d9c9e94070..dd30dda2a1 100644
--- a/lisp/gnus/gnus-agent.el
+++ b/lisp/gnus/gnus-agent.el
@@ -2693,52 +2693,74 @@ gnus-category-read
   "Read the category alist."
   (setq gnus-category-alist
         (or
-         (with-temp-buffer
-           (ignore-errors
-            (nnheader-insert-file-contents (nnheader-concat gnus-agent-directory "lib/categories"))
-            (goto-char (point-min))
-            ;; This code isn't temp, it will be needed so long as
-            ;; anyone may be migrating from an older version.
-
-            ;; Once we're certain that people will not revert to an
-            ;; earlier version, we can take out the old-list code in
-            ;; gnus-category-write.
-            (let* ((old-list (read (current-buffer)))
-                   (new-list (ignore-errors (read (current-buffer)))))
-              (if new-list
-                  new-list
-                ;; Convert from a positional list to an alist.
-                (mapcar
-                 (lambda (c)
-                   (setcdr c
-                           (delq nil
-                                 (gnus-mapcar
-                                  (lambda (valu symb)
-                                    (if valu
-                                        (cons symb valu)))
-                                  (cdr c)
-                                  '(agent-predicate agent-score-file agent-groups))))
-                   c)
-                 old-list)))))
+	 (let ((list
+		(with-temp-buffer
+		  (ignore-errors
+		    (nnheader-insert-file-contents (nnheader-concat gnus-agent-directory "lib/categories"))
+		    (goto-char (point-min))
+		    ;; This code isn't temp, it will be needed so long as
+		    ;; anyone may be migrating from an older version.
+
+		    ;; Once we're certain that people will not revert to an
+		    ;; earlier version, we can take out the old-list code in
+		    ;; gnus-category-write.
+		    (let* ((old-list (read (current-buffer)))
+			   (new-list (ignore-errors (read (current-buffer)))))
+		      (if new-list
+			  new-list
+			;; Convert from a positional list to an alist.
+			(mapcar
+			 (lambda (c)
+			   (setcdr c
+				   (delq nil
+					 (gnus-mapcar
+					  (lambda (valu symb)
+					    (if valu
+						(cons symb valu)))
+					  (cdr c)
+					  '(agent-predicate agent-score-file agent-groups))))
+			   c)
+			 old-list)))))))
+	   ;; Possibly decode group names.
+	   (dolist (cat list)
+	     (setf (alist-get 'agent-groups cat)
+		   (mapcar (lambda (g)
+			     (if (string-match-p "[^[:ascii:]]" g)
+				 (decode-coding-string g 'utf-8-emacs)
+			       g))
+			   (alist-get 'agent-groups cat))))
+	   list)
          (list (gnus-agent-cat-make 'default 'short)))))
 
 (defun gnus-category-write ()
   "Write the category alist."
   (setq gnus-category-predicate-cache nil
 	gnus-category-group-cache nil)
-  (gnus-make-directory (nnheader-concat gnus-agent-directory "lib"))
-  (with-temp-file (nnheader-concat gnus-agent-directory "lib/categories")
-    ;; This prin1 is temporary.  It exists so that people can revert
-    ;; to an earlier version of gnus-agent.
-    (prin1 (mapcar (lambda (c)
-              (list (car c)
-                    (cdr (assoc 'agent-predicate c))
-                    (cdr (assoc 'agent-score-file c))
-                    (cdr (assoc 'agent-groups c))))
-                   gnus-category-alist)
-           (current-buffer))
-    (newline)
-    (prin1 gnus-category-alist (current-buffer))))
+  ;; Temporarily encode non-ascii group names when saving to file,
+  ;; pending an upgrade of Gnus' file formats.
+  (let ((gnus-category-alist
+	 (mapcar (lambda (cat)
+		   (setf (alist-get 'agent-groups cat)
+			 (mapcar (lambda (g)
+				   (if (multibyte-string-p g)
+				       (encode-coding-string g 'utf-8-emacs)
+				     g))
+				 (alist-get 'agent-groups cat)))
+		   cat)
+		 (copy-tree gnus-category-alist))))
+   (gnus-make-directory (nnheader-concat gnus-agent-directory "lib"))
+   (with-temp-file (nnheader-concat gnus-agent-directory "lib/categories")
+     ;; This prin1 is temporary.  It exists so that people can revert
+     ;; to an earlier version of gnus-agent.
+     (prin1 (mapcar (lambda (c)
+		      (list (car c)
+			    (cdr (assoc 'agent-predicate c))
+			    (cdr (assoc 'agent-score-file c))
+			    (cdr (assoc 'agent-groups c))))
+                    gnus-category-alist)
+            (current-buffer))
+     (newline)
+     (prin1 gnus-category-alist (current-buffer)))))
 
 (defun gnus-category-edit-predicate (category)
   "Edit the predicate for CATEGORY."
diff --git a/lisp/gnus/gnus-registry.el b/lisp/gnus/gnus-registry.el
index e488858ebe..e949179b3c 100644
--- a/lisp/gnus/gnus-registry.el
+++ b/lisp/gnus/gnus-registry.el
@@ -264,6 +264,50 @@ gnus-registry-sort-by-creation-time
    (cadr (assq 'creation-time r))
    (cadr (assq 'creation-time l))))
 
+;; Remove this from the save routine (and fix it to only decode) at
+;; next Gnus version bump.
+(defun gnus-registry--munge-group-names (db &optional encode)
+  "Encode/decode group names in DB, before saving or after loading.
+Encode names if ENCODE is non-nil, otherwise decode."
+  (let ((datahash (slot-value db 'data))
+	(grouphash (registry-lookup-secondary db 'group))
+	reset-pairs)
+    (when (hash-table-p grouphash)
+      (maphash
+       (lambda (group-name val)
+	 (if encode
+	     (when (multibyte-string-p group-name)
+	       (remhash group-name grouphash)
+	       (puthash (encode-coding-string group-name 'utf-8-emacs)
+			val grouphash))
+	   (when (string-match-p "[^[:ascii:]]" group-name)
+	     (remhash group-name grouphash)
+	     (puthash (decode-coding-string group-name 'utf-8-emacs) val grouphash))))
+       grouphash))
+    (maphash
+     (lambda (id data)
+       (let ((groups (cdr-safe (assq 'group data))))
+	 (when (seq-some (lambda (g)
+			   (if encode
+			       (multibyte-string-p g)
+			     (string-match-p "[^[:ascii:]]" g)))
+			 groups)
+	   ;; Create a replacement DATA.
+	   (push (list id (cons (cons 'group (mapcar
+			   (lambda (g)
+			     (funcall
+			      (if encode
+				  #'encode-coding-string
+				#'decode-coding-string)
+			      g 'utf-8-emacs))
+			   groups))
+				(assq-delete-all 'group data)))
+		 reset-pairs))))
+     datahash)
+    (pcase-dolist (`(,id ,data) reset-pairs)
+      (remhash id datahash)
+      (puthash id data datahash))))
+
 (defun gnus-registry-fixup-registry (db)
   (when db
     (let ((old (oref db tracked)))
@@ -281,7 +325,8 @@ gnus-registry-fixup-registry
                     '(mark group keyword)))
       (when (not (equal old (oref db tracked)))
         (gnus-message 9 "Reindexing the Gnus registry (tracked change)")
-        (registry-reindex db))))
+        (registry-reindex db))
+      (gnus-registry--munge-group-names db)))
   db)
 
 (defun gnus-registry-make-db (&optional file)
@@ -358,14 +403,20 @@ gnus-registry-read
 (defun gnus-registry-save (&optional file db)
   "Save the registry cache file."
   (interactive)
-  (let ((file (or file gnus-registry-cache-file))
-        (db (or db gnus-registry-db)))
+  (let* ((file (or file gnus-registry-cache-file))
+         (db (or db gnus-registry-db))
+	 (clone (clone db)))
     (gnus-message 5 "Saving Gnus registry (%d entries) to %s..."
                   (registry-size db) file)
     (registry-prune
      db gnus-registry-default-sort-function)
+    ;; Write a clone of the database with non-ascii group names
+    ;; encoded as 'utf-8.  Let-bind `gnus-registry-db' so that
+    ;; functions in the munging process work on our clone.
+    (let ((gnus-registry-db clone))
+     (gnus-registry--munge-group-names clone 'encode))
     ;; TODO: call (gnus-string-remove-all-properties v) on all elements?
-    (eieio-persistent-save db file)
+    (eieio-persistent-save clone file)
     (gnus-message 5 "Saving Gnus registry (size %d) to %s...done"
                   (registry-size db) file)))
 
diff --git a/lisp/gnus/gnus-start.el b/lisp/gnus/gnus-start.el
index cb585472af..9b620edbec 100644
--- a/lisp/gnus/gnus-start.el
+++ b/lisp/gnus/gnus-start.el
@@ -42,6 +42,7 @@
 (defvar gnus-agent-covered-methods)
 (defvar gnus-agent-file-loading-local)
 (defvar gnus-agent-file-loading-cache)
+(defvar gnus-topic-alist)
 
 (defcustom gnus-startup-file (nnheader-concat gnus-home-directory ".newsrc")
   "Your `.newsrc' file.
@@ -2871,7 +2872,12 @@ gnus-gnus-to-quick-newsrc-format
       (princ "(setq gnus-newsrc-file-version ")
       (princ (gnus-prin1-to-string gnus-version))
       (princ ")\n"))
-
+    ;; Sort `gnus-newsrc-alist' according to order in
+    ;; `gnus-group-list'.
+    (setq gnus-newsrc-alist
+	  (mapcar (lambda (g)
+		    (nth 1 (gethash g gnus-newsrc-hashtb)))
+		  (delete "dummy.group" gnus-group-list)))
     (let* ((print-quoted t)
            (print-readably t)
            (print-escape-multibyte nil)
@@ -2891,18 +2897,27 @@ gnus-gnus-to-quick-newsrc-format
 		  ;; Remove the `gnus-killed-list' from the list of variables
 		  ;; to be saved, if required.
 		  (delq 'gnus-killed-list (copy-sequence gnus-variable-list)))))
+	   ;; Encode group names in `gnus-newsrc-alist' and
+	   ;; `gnus-topic-alist' in order to keep newsrc.eld files
+	   ;; compatible with older versions of Gnus.  At some point,
+	   ;; if/when a new version of Gnus is released, stop doing
+	   ;; this and move the corresponding decode in
+	   ;; `gnus-read-newsrc-el-file' into a conversion routine.
+	   (gnus-newsrc-alist
+	    (mapcar (lambda (info)
+		      (cons (encode-coding-string (car info) 'utf-8-emacs)
+			    (cdr info)))
+		    gnus-newsrc-alist))
+	   (gnus-topic-alist
+	    (when (memq 'gnus-topic-alist variables)
+	     (mapcar (lambda (elt)
+		       (cons (car elt) ; Topic name
+			     (mapcar (lambda (g)
+				       (encode-coding-string
+					g 'utf-8-emacs))
+				     (cdr elt))))
+		     gnus-topic-alist)))
 	   variable)
-      ;; A bit of a fake-out here: the original value of
-      ;; `gnus-newsrc-alist' isn't written to file, instead it is
-      ;; constructed at the last minute by combining the group
-      ;; ordering in `gnus-group-list' with the group infos from
-      ;; `gnus-newsrc-hashtb'.
-      (set (nth (seq-position gnus-variable-list 'gnus-newsrc-alist)
-		gnus-variable-list)
-	   (mapcar (lambda (g)
-		     (nth 1 (gethash g gnus-newsrc-hashtb)))
-		   (delete "dummy.group" gnus-group-list)))
-
       ;; Insert the variables into the file.
       (while variables
 	(when (and (boundp (setq variable (pop variables)))
-- 
2.22.0


--=-=-=
Content-Type: text/x-patch
Content-Disposition: attachment;
 filename=0001-Remove-Gnus-group-name-encoding-decoding.patch

From f2d325fbf5634189018238e2f4b2fc4f536e6b3c Mon Sep 17 00:00:00 2001
From: Eric Abrahamsen <eric@HIDDEN>
Date: Fri, 16 Nov 2018 12:53:56 -0800
Subject: [PATCH 1/2] Remove Gnus group name encoding/decoding

This completes the process started in c1b63af445. Gnus group names are
now fully decoded inside the Gnus system.

* lisp/gnus/gnus-agent.el (gnus-agent-file-coding-system): Change
  default to utf-8-emacs.
  (gnus-agent-decoded-group-names, gnus-agent-decoded-group-name):
  Remove variable and function. Remove all usage in this file.
* lisp/gnus/gnus-cache.el (gnus-cache-decoded-group-names,
  gnus-cache-unified-group-names, gnus-cache-decoded-group-name):
  Remove these variables and function. Remove all usage in this file.
* lisp/gnus/gnus-group.el (gnus-tmp-decoded-group): Remove this
  variable, gnus-tmp-group is now decoded.
  (gnus-group-completing-read): Don't encode or decode group names
  here.
  (gnus-group-make-group): Remove ENCODED argument.
* lisp/gnus/gnus-srvr.el (gnus-browse-foreign-server): Decode group
  names here.
* lisp/gnus/gnus-start.el (gnus-make-hashtable-from-newsrc-alist):
  check for encoded group names and decode.
  (gnus-active-to-gnus-format): Make sure incoming group names are
  decoded.
  (gnus-read-newsrc-el-file): Check for encoded group names in
  gnus-topic-alist.
* lisp/gnus/nnagent.el: Don't use a unibyte buffer.
* lisp/gnus/nnheader.el (nnheader-file-coding-system): Switch default
  from 'raw-text to 'undecided, on the assumption that 'undecided will
  probably write 'utf-8-emacs unless the user has arranged things
  otherwise.
* lisp/gnus/nnimap.el (nnimap-decode-gnus-group,
  nnimap-encode-gnus-group): Remove functions and their use.
* lisp/gnus/nnmail.el (nnmail-parse-active): Remove encoding.
  (nnmail-active-file-coding-system): Default to 'utf-8-emacs instead
  of 'raw-text.
  (nnmail-group-names-not-encoded-p): Obsolete this variable; stop
  using it.
* lisp/gnus/gnus-art.el:
* lisp/gnus/gnus-cus.el:
* lisp/gnus/gnus-msg.el:
* lisp/gnus/gnus-start.el:
* lisp/gnus/gnus-sum.el:
* lisp/gnus/gnus.el:
* lisp/gnus/nnml.el:
* lisp/gnus/message.el:
* lisp/gnus/nnrss.el: Stop using gnus-group-decoded-name in all these
  files.
---
 lisp/gnus/gnus-agent.el |  58 ++++-------
 lisp/gnus/gnus-art.el   |   4 +-
 lisp/gnus/gnus-cache.el |  41 +-------
 lisp/gnus/gnus-cus.el   |   5 +-
 lisp/gnus/gnus-group.el | 209 +++++++++++++++-------------------------
 lisp/gnus/gnus-msg.el   |   3 +-
 lisp/gnus/gnus-srvr.el  |  45 +++++----
 lisp/gnus/gnus-start.el |  43 ++++++---
 lisp/gnus/gnus-sum.el   | 113 +++++++++-------------
 lisp/gnus/gnus-util.el  |   7 --
 lisp/gnus/gnus.el       |   4 +-
 lisp/gnus/message.el    |  21 ++--
 lisp/gnus/nnagent.el    |  23 +++--
 lisp/gnus/nnheader.el   |   7 +-
 lisp/gnus/nnimap.el     |  62 +++---------
 lisp/gnus/nnmail.el     |  28 +++---
 lisp/gnus/nnmaildir.el  |   2 +-
 lisp/gnus/nnml.el       |  92 ++++--------------
 lisp/gnus/nnrss.el      |   2 +-
 19 files changed, 276 insertions(+), 493 deletions(-)

diff --git a/lisp/gnus/gnus-agent.el b/lisp/gnus/gnus-agent.el
index 40d0d24605..d9c9e94070 100644
--- a/lisp/gnus/gnus-agent.el
+++ b/lisp/gnus/gnus-agent.el
@@ -229,7 +229,7 @@ gnus-agent-spam-hashtb
   "Cache of message subjects for spam messages.
 Actually a hash table holding subjects mapped to t.")
 (defvar gnus-agent-file-name nil)
-(defvar gnus-agent-file-coding-system 'raw-text)
+(defvar gnus-agent-file-coding-system 'utf-8-emacs)
 (defvar gnus-agent-file-loading-cache nil)
 (defvar gnus-agent-total-fetched-hashtb nil)
 (defvar gnus-agent-inhibit-update-total-fetched-for nil)
@@ -406,8 +406,6 @@ gnus-agent-cat-make
 (defun gnus-agent-read-group ()
   "Read a group name in the minibuffer, with completion."
   (let ((def (or (gnus-group-group-name) gnus-newsgroup-name)))
-    (when def
-      (setq def (gnus-group-decoded-name def)))
     (gnus-group-completing-read nil nil t nil nil def)))
 
 ;;; Fetching setup functions.
@@ -1330,7 +1328,10 @@ gnus-agent-save-group-info
       (gnus-make-directory (file-name-directory file))
       (with-temp-file file
 	;; Emacs got problem to match non-ASCII group in multibyte buffer.
-	(mm-disable-multibyte)
+
+	;; FIXME: Is this still an issue now that group names are
+	;; always strings?
+	;(mm-disable-multibyte)
 	(when (file-exists-p file)
 	  (nnheader-insert-file-contents file)
 
@@ -1360,7 +1361,7 @@ gnus-agent-get-group-info
       (gnus-make-directory (file-name-directory file))
       (with-temp-buffer
 	;; Emacs got problem to match non-ASCII group in multibyte buffer.
-	(mm-disable-multibyte)
+	;(mm-disable-multibyte)
 	(when (file-exists-p file)
 	  (nnheader-insert-file-contents file)
 
@@ -1372,18 +1373,6 @@ gnus-agent-get-group-info
                     oactive-min (read (current-buffer))) ;; min
 	      (cons oactive-min oactive-max))))))))
 
-(defvar gnus-agent-decoded-group-names nil
-  "Alist of non-ASCII group names and decoded ones.")
-
-(defun gnus-agent-decoded-group-name (group)
-  "Return a decoded group name of GROUP."
-  (or (cdr (assoc group gnus-agent-decoded-group-names))
-      (if (string-match "[^\000-\177]" group)
-	  (let ((decoded (gnus-group-decoded-name group)))
-	    (push (cons group decoded) gnus-agent-decoded-group-names)
-	    decoded)
-	group)))
-
 (defun gnus-agent-group-path (group)
   "Translate GROUP into a file name."
 
@@ -1395,7 +1384,7 @@ gnus-agent-group-path
         (nnheader-translate-file-chars
          (nnheader-replace-duplicate-chars-in-string
           (nnheader-replace-chars-in-string
-           (gnus-group-real-name (gnus-agent-decoded-group-name group))
+           (gnus-group-real-name group)
            ?/ ?_)
           ?. ?_)))
   (if (or nnmail-use-long-file-names
@@ -1409,7 +1398,7 @@ gnus-agent-group-pathname
   ;; unplugged.  The agent must, therefore, use the same directory
   ;; while plugged.
   (nnmail-group-pathname
-   (gnus-group-real-name (gnus-agent-decoded-group-name group))
+   (gnus-group-real-name group)
    (if gnus-command-method
        (gnus-agent-directory)
      (let ((gnus-command-method (gnus-find-method-for-group group)))
@@ -1437,7 +1426,7 @@ gnus-agent-open-history
 			     (format " *Gnus agent %s history*"
 				     (gnus-agent-method)))))
 	  gnus-agent-history-buffers)
-    (mm-disable-multibyte) ;; everything is binary
+    ;(mm-disable-multibyte) ;; everything is binary
     (erase-buffer)
     (insert "\n")
     (let ((file (gnus-agent-lib-file "history")))
@@ -1525,8 +1514,7 @@ gnus-agent-fetch-articles
           (setq selected-sets (nreverse selected-sets))
 
           (gnus-make-directory dir)
-	  (gnus-message 7 "Fetching articles for %s..."
-			(gnus-agent-decoded-group-name group))
+	  (gnus-message 7 "Fetching articles for %s..." group)
 
           (unwind-protect
               (while (setq articles (pop selected-sets))
@@ -1537,8 +1525,7 @@ gnus-agent-fetch-articles
                     (let (article)
                       (while (setq article (pop articles))
                         (gnus-message 10 "Fetching article %s for %s..."
-				      article
-				      (gnus-agent-decoded-group-name group))
+				      article group)
                         (when (or
                                (gnus-backlog-request-article group article
                                                              nntp-server-buffer)
@@ -1875,8 +1862,7 @@ gnus-agent-fetch-headers
       (with-current-buffer nntp-server-buffer
         (if articles
             (progn
-	      (gnus-message 8 "Fetching headers for %s..."
-			    (gnus-agent-decoded-group-name group))
+	      (gnus-message 8 "Fetching headers for %s..." group)
 
               ;; Fetch them.
               (gnus-make-directory (nnheader-translate-file-chars
@@ -3058,8 +3044,7 @@ gnus-agent-expire-group-1
   ;; provided a non-nil active
 
   (let ((dir (gnus-agent-group-pathname group))
-	(file-name-coding-system nnmail-pathname-coding-system)
-	(decoded (gnus-agent-decoded-group-name group)))
+	(file-name-coding-system nnmail-pathname-coding-system))
     (gnus-agent-with-refreshed-group
      group
      (when (boundp 'gnus-agent-expire-current-dirs)
@@ -3068,8 +3053,8 @@ gnus-agent-expire-group-1
      (if (and (not force)
 	      (eq 'DISABLE (gnus-agent-find-parameter group
 						      'agent-enable-expiration)))
-	 (gnus-message 5 "Expiry skipping over %s" decoded)
-       (gnus-message 5 "Expiring articles in %s" decoded)
+	 (gnus-message 5 "Expiry skipping over %s" group)
+       (gnus-message 5 "Expiring articles in %s" group)
        (gnus-agent-load-alist group)
        (let* ((bytes-freed 0)
 	      (size-files-deleted 0.0)
@@ -3293,7 +3278,7 @@ gnus-agent-expire-group-1
 		(keep
 		 (gnus-agent-message 10
 				     "gnus-agent-expire: %s:%d: Kept %s article%s."
-				     decoded article-number keep (if fetch-date " and file" ""))
+				     group article-number keep (if fetch-date " and file" ""))
 		 (when fetch-date
 		   (unless (file-exists-p
 			    (concat dir (number-to-string
@@ -3301,7 +3286,7 @@ gnus-agent-expire-group-1
 		     (setf (nth 1 entry) nil)
 		     (gnus-agent-message 3 "gnus-agent-expire cleared \
 download flag on %s:%d as the cached article file is missing."
-					 decoded (caar dlist)))
+					 group (caar dlist)))
 		   (unless marker
 		     (gnus-message 1 "gnus-agent-expire detected a \
 missing NOV entry.  Run gnus-agent-regenerate-group to restore it.")))
@@ -3379,12 +3364,12 @@ gnus-agent-expire-group-1
 
 		   (when actions
 		     (gnus-agent-message 8 "gnus-agent-expire: %s:%d: %s"
-					 decoded article-number
+					 group article-number
 					 (mapconcat #'identity actions ", ")))))
 		(t
 		 (gnus-agent-message
 		  10 "gnus-agent-expire: %s:%d: Article kept as \
-expiration tests failed." decoded article-number)
+expiration tests failed." group article-number)
 		 (gnus-agent-append-to-list
 		  tail-alist (cons article-number fetch-date)))
 		)
@@ -3835,7 +3820,7 @@ gnus-agent-regenerate-group
                     (sit-for 1)
                     t)))))
   (when group
-    (gnus-message 5 "Regenerating in %s" (gnus-agent-decoded-group-name group))
+    (gnus-message 5 "Regenerating in %s" group)
     (let* ((gnus-command-method (or gnus-command-method
 				    (gnus-find-method-for-group group)))
 	   (file (gnus-agent-article-name ".overview" group))
@@ -3912,8 +3897,7 @@ gnus-agent-regenerate-group
 			  (> (car downloaded) (car nov-arts))))
 		 ;; This entry is missing from the overview file
 		 (gnus-message 3 "Regenerating NOV %s %d..."
-			       (gnus-agent-decoded-group-name group)
-			       (car downloaded))
+			       group (car downloaded))
 		 (let ((file (concat dir (number-to-string (car downloaded)))))
 		   (mm-with-unibyte-buffer
 		     (nnheader-insert-file-contents file)
diff --git a/lisp/gnus/gnus-art.el b/lisp/gnus/gnus-art.el
index 8f5a313c61..af8ec68ddd 100644
--- a/lisp/gnus/gnus-art.el
+++ b/lisp/gnus/gnus-art.el
@@ -4506,9 +4506,7 @@ gnus-article-mode
 (defun gnus-article-setup-buffer ()
   "Initialize the article buffer."
   (let* ((name (if gnus-single-article-buffer "*Article*"
-		 (concat "*Article "
-			 (gnus-group-decoded-name gnus-newsgroup-name)
-			 "*")))
+		 (concat "*Article " gnus-newsgroup-name "*")))
 	 (original
 	  (progn (string-match "\\*Article" name)
 		 (concat " *Original Article"
diff --git a/lisp/gnus/gnus-cache.el b/lisp/gnus/gnus-cache.el
index afe8a8a416..f43c4344dc 100644
--- a/lisp/gnus/gnus-cache.el
+++ b/lisp/gnus/gnus-cache.el
@@ -430,41 +430,7 @@ gnus-cache-member-of-class
       (and unread (memq 'unread class))
       (and (not unread) (not ticked) (not dormant) (memq 'read class))))
 
-(defvar gnus-cache-decoded-group-names nil
-  "Alist of original group names and decoded group names.
-Decoding is done according to `gnus-group-name-charset-method-alist'
-or `gnus-group-name-charset-group-alist'.")
-
-(defvar gnus-cache-unified-group-names nil
-  "Alist of unified decoded group names and original group names.
-A group name is decoded according to
-`gnus-group-name-charset-method-alist' or
-`gnus-group-name-charset-group-alist' first, and is encoded and
-decoded again according to `nnmail-pathname-coding-system',
-`file-name-coding-system', or `default-file-name-coding-system'.
-
-It is used when asking for an original group name from a cache
-directory name, in which non-ASCII characters might have been unified
-into the ones of a certain charset particularly if the `utf-8' coding
-system for example was used.")
-
-(defun gnus-cache-decoded-group-name (group)
-  "Return a decoded group name of GROUP."
-  (or (cdr (assoc group gnus-cache-decoded-group-names))
-      (let ((decoded (gnus-group-decoded-name group))
-	    (coding (or nnmail-pathname-coding-system
-			file-name-coding-system
-			default-file-name-coding-system)))
-	(push (cons group decoded) gnus-cache-decoded-group-names)
-	(push (cons (decode-coding-string
-		     (encode-coding-string decoded coding)
-		     coding)
-		    group)
-	      gnus-cache-unified-group-names)
-	decoded)))
-
 (defun gnus-cache-file-name (group article)
-  (setq group (gnus-cache-decoded-group-name group))
   (expand-file-name
    (if (stringp article) article (int-to-string article))
    (file-name-as-directory
@@ -733,12 +699,7 @@ gnus-cache-generate-active
 	(push (pop files) alphs)))
     ;; If we have nums, then this is probably a valid group.
     (when (setq nums (sort nums '<))
-      ;; Use non-decoded group name.
-      ;; FIXME: this is kind of a workaround.  The active file should
-      ;; be updated at the time articles are cached.  It will make
-      ;; `gnus-cache-unified-group-names' needless.
-      (puthash (or (cdr (assoc group gnus-cache-unified-group-names))
-		   group)
+      (puthash group
 	       (cons (car nums) (car (last nums)))
 	       gnus-cache-active-hashtb))
     ;; Go through all the other files.
diff --git a/lisp/gnus/gnus-cus.el b/lisp/gnus/gnus-cus.el
index fb8b300e35..3598ead761 100644
--- a/lisp/gnus/gnus-cus.el
+++ b/lisp/gnus/gnus-cus.el
@@ -396,7 +396,7 @@ gnus-group-customize
 		     :tag  "topic parameters"
 		     "(gnus)Topic Parameters"))
     (widget-insert " for <")
-    (widget-insert (gnus-group-decoded-name (or group topic)))
+    (widget-insert (or group topic))
     (widget-insert "> and press ")
     (widget-create 'push-button
 		   :tag "done"
@@ -845,8 +845,7 @@ gnus-score-customize
 This can be changed using the `\\[gnus-score-change-score-file]' command."
   (interactive (list gnus-current-score-file))
   (unless file
-    (error "No score file for %s"
-           (gnus-group-decoded-name gnus-newsgroup-name)))
+    (error "No score file for %s" gnus-newsgroup-name))
   (let ((scores (gnus-score-load file))
 	(types (mapcar (lambda (entry)
 			 `(group :format "%v%h\n"
diff --git a/lisp/gnus/gnus-group.el b/lisp/gnus/gnus-group.el
index 299ebdec50..7e0ceec17b 100644
--- a/lisp/gnus/gnus-group.el
+++ b/lisp/gnus/gnus-group.el
@@ -479,7 +479,6 @@ gnus-group-edit-buffer
 (defvar gnus-tmp-news-method)
 (defvar gnus-tmp-colon)
 (defvar gnus-tmp-news-server)
-(defvar gnus-tmp-decoded-group)
 (defvar gnus-tmp-header)
 (defvar gnus-tmp-process-marked)
 (defvar gnus-tmp-summary-live)
@@ -518,14 +517,9 @@ gnus-group-line-format-alist
     (?T (gnus-range-length (cdr (assq 'tick gnus-tmp-marked))) ?d)
     (?i (+ (gnus-range-length (cdr (assq 'dormant gnus-tmp-marked)))
 	   (gnus-range-length (cdr (assq 'tick gnus-tmp-marked)))) ?d)
-    (?g (if (boundp 'gnus-tmp-decoded-group)
-	    gnus-tmp-decoded-group
-	  gnus-tmp-group)
-	?s)
+    (?g gnus-tmp-group ?s)
     (?G gnus-tmp-qualified-group ?s)
-    (?c (gnus-short-group-name (if (boundp 'gnus-tmp-decoded-group)
-				   gnus-tmp-decoded-group
-				 gnus-tmp-group))
+    (?c (gnus-short-group-name gnus-tmp-group)
 	?s)
     (?C gnus-tmp-comment ?s)
     (?D gnus-tmp-newsgroup-description ?s)
@@ -1398,8 +1392,7 @@ gnus-group-prepare-flat-list-dead
                      ((functionp regexp) (funcall regexp group))))
           (add-text-properties
            (point) (prog1 (1+ (point))
-                     (insert " " mark "     *: "
-                             (gnus-group-decoded-name group)
+                     (insert " " mark " *: " group
                              "\n"))
            (list 'gnus-group group
                  'gnus-unread t
@@ -1508,8 +1501,6 @@ gnus-group-insert-group-line
   "Insert a group line in the group buffer."
   (let* ((gnus-tmp-method
 	  (gnus-server-get-method gnus-tmp-group gnus-tmp-method))
-	 (group-name-charset (gnus-group-name-charset gnus-tmp-method
-						      gnus-tmp-group))
 	 (gnus-tmp-active (gnus-active gnus-tmp-group))
 	 (gnus-tmp-number-total
 	  (if gnus-tmp-active
@@ -1528,16 +1519,13 @@ gnus-group-insert-group-line
 		((= gnus-tmp-level gnus-level-zombie) ?Z)
 		(t ?K)))
 	 (gnus-tmp-qualified-group
-	  (gnus-group-name-decode (gnus-group-real-name gnus-tmp-group)
-				  group-name-charset))
+	  (gnus-group-real-name gnus-tmp-group))
 	 (gnus-tmp-comment
 	  (or (gnus-group-get-parameter gnus-tmp-group 'comment t)
 	      gnus-tmp-group))
 	 (gnus-tmp-newsgroup-description
 	  (if gnus-description-hashtb
-	      (or (gnus-group-name-decode
-		   (gethash gnus-tmp-group gnus-description-hashtb)
-		   group-name-charset) "")
+	      (or (gethash gnus-tmp-group gnus-description-hashtb) "")
 	    ""))
 	 (gnus-tmp-moderated
 	  (if (and gnus-moderated-hashtb
@@ -1574,9 +1562,7 @@ gnus-group-insert-group-line
      (point)
      (prog1 (1+ (point))
        ;; Insert the text.
-       (let ((gnus-tmp-decoded-group (gnus-group-name-decode
-				      gnus-tmp-group group-name-charset)))
-	 (eval gnus-group-line-format-spec)))
+       (eval gnus-group-line-format-spec))
      `(gnus-group ,gnus-tmp-group
 		  gnus-unread ,(if (numberp number)
 				   (string-to-number gnus-tmp-number-of-unread)
@@ -2117,9 +2103,7 @@ gnus-group-select-group-ephemerally
 (defun gnus-group-name-at-point ()
   "Return a group name from around point if it exists, or nil."
   (if (derived-mode-p 'gnus-group-mode)
-      (let ((group (gnus-group-group-name)))
-	(when group
-	  (gnus-group-decoded-name group)))
+      (gnus-group-group-name)
     ;; FIXME: Use rx.
     (let ((regexp "[][\C-@-\t\v-*,/:-@\\^`{-\C-?]*\
 \\(nn[a-z]+\\(?:\\+[^][\C-@-*,/:-@\\^`{-\C-?]+\\)?:\
@@ -2160,41 +2144,25 @@ gnus-group-completing-read
 					     require-match initial-input hist
 					     def)
   "Read a group name with completion.
-Non-ASCII group names are allowed.  The arguments are the same as
-`completing-read' except that COLLECTION and HIST default to
-`gnus-active-hashtb' and `gnus-group-history' respectively if
-they are omitted.  Can handle COLLECTION as a list, hash table,
-or vector."
+The arguments are the same as `completing-read' except that
+COLLECTION and HIST default to `gnus-active-hashtb' and
+`gnus-group-history' respectively if they are omitted.  Can
+handle COLLECTION as a list, hash table, or vector."
+  ;; This function handles vectors for backwards compatibility.  In
+  ;; theory, `collection' will only ever be a list or a hash table.
   (or collection (setq collection gnus-active-hashtb))
   (let* ((choices
-	  (mapcar
-	   (lambda (g)
-	     (if (string-match "[^\000-\177]" g)
-		 (gnus-group-decoded-name g)
-	       g))
 	   (cond ((listp collection)
 		  collection)
 		 ((vectorp collection)
 		  (mapatoms #'symbol-name collection))
 		 ((hash-table-p collection)
-		  (hash-table-keys collection)))))
+		  (hash-table-keys collection))))
 	 (group
 	  (gnus-completing-read (or prompt "Group") (reverse choices)
 				require-match initial-input
 				(or hist 'gnus-group-history)
 				def)))
-    (unless (cond ((and (listp collection)
-			(symbolp (car collection)))
-		   (member group (mapcar 'symbol-name collection)))
-		  ((listp collection)
-		   (member group collection))
-		  ((vectorp collection)
-		   (symbol-value (intern-soft group collection)))
-		  ((hash-table-p collection)
-		   (gethash group collection)))
-      (setq group
-	    (encode-coding-string
-	     group (gnus-group-name-charset nil group))))
     (replace-regexp-in-string "\n" "" group)))
 
 ;;;###autoload
@@ -2755,13 +2723,13 @@ gnus-group-make-group-simple
   (interactive (list (gnus-group-completing-read)))
   (gnus-group-make-group (gnus-group-real-name group)
 			 (gnus-group-server group)
-			 nil nil t))
+			 nil nil))
 
-(defun gnus-group-make-group (name &optional method address args encoded)
+(defun gnus-group-make-group (name &optional method address args)
   "Add a new newsgroup.
 The user will be prompted for a NAME, for a select METHOD, and an
 ADDRESS.  NAME should be a human-readable string (i.e., not be encoded
-even if it contains non-ASCII characters) unless ENCODED is non-nil.
+even if it contains non-ASCII characters).
 
 If the backend supports it, the group will also be created on the
 server."
@@ -2772,10 +2740,6 @@ gnus-group-make-group
 
   (when (stringp method)
     (setq method (or (gnus-server-to-method method) method)))
-  (unless encoded
-    (setq name (encode-coding-string
-		name
-		(gnus-group-name-charset method name))))
   (let* ((meth (gnus-method-simplify
 		(when (and method
 			   (not (gnus-server-equal method gnus-select-method)))
@@ -2784,7 +2748,7 @@ gnus-group-make-group
 	 (nname (if method (gnus-group-prefixed-name name meth) name))
 	 backend info)
     (when (gnus-group-entry nname)
-      (error "Group %s already exists" (gnus-group-decoded-name nname)))
+      (error "Group %s already exists" nname))
     ;; Subscribe to the new group.
     (gnus-group-change-level
      (setq info (list t nname gnus-level-default-subscribed nil nil meth))
@@ -2860,20 +2824,19 @@ gnus-group-delete-group
   (unless (gnus-check-backend-function 'request-delete-group group)
     (error "This back end does not support group deletion"))
   (prog1
-      (let ((group-decoded (gnus-group-decoded-name group)))
-	(when (or no-prompt
-		  (gnus-yes-or-no-p
-		   (format
-		    "Do you really want to delete %s%s? "
-		    group-decoded (if force " and all its contents" ""))))
-	  (gnus-message 6 "Deleting group %s..." group-decoded)
-	  (if (not (gnus-request-delete-group group force))
-	      (gnus-error 3 "Couldn't delete group %s" group-decoded)
-	    (gnus-message 6 "Deleting group %s...done" group-decoded)
-	    (gnus-group-goto-group group)
-	    (gnus-group-kill-group 1 t)
-	    (gnus-set-active group nil)
-	    t)))
+      (when (or no-prompt
+		(gnus-yes-or-no-p
+		 (format
+		  "Do you really want to delete %s%s? "
+		  group (if force " and all its contents" ""))))
+	(gnus-message 6 "Deleting group %s..." group)
+	(if (not (gnus-request-delete-group group force))
+	    (gnus-error 3 "Couldn't delete group %s" group)
+	  (gnus-message 6 "Deleting group %s...done" group)
+	  (gnus-group-goto-group group)
+	  (gnus-group-kill-group 1 t)
+	  (gnus-set-active group nil)
+	  t))
     (gnus-group-position-point)))
 
 (defun gnus-group-rename-group (group new-name)
@@ -2887,13 +2850,9 @@ gnus-group-rename-group
        (error "This back end does not support renaming groups"))
      (setq new-name (gnus-read-group
 		     "Rename group to: "
-		     (gnus-group-real-name (gnus-group-decoded-name group)))
+		     (gnus-group-real-name group))
 	   method (gnus-info-method (gnus-get-info group)))
-     (list group (encode-coding-string
-		  new-name
-		  (gnus-group-name-charset
-		   method
-		   (gnus-group-prefixed-name new-name method))))))
+     (list group (gnus-group-prefixed-name new-name method))))
 
   (unless (gnus-check-backend-function 'request-rename-group group)
     (error "This back end does not support renaming groups"))
@@ -2912,34 +2871,30 @@ gnus-group-rename-group
 	   (gnus-group-real-name new-name)
 	   (gnus-info-method (gnus-get-info group)))))
 
-  (let ((decoded-group (gnus-group-decoded-name group))
-	(decoded-new-name (gnus-group-decoded-name new-name)))
-    (when (gnus-active new-name)
-      (error "The group %s already exists" decoded-new-name))
+  (when (gnus-active new-name)
+    (error "The group %s already exists" new-name))
 
-    (gnus-message 6 "Renaming group %s to %s..."
-		  decoded-group decoded-new-name)
-    (prog1
-	(if (progn
-	      (gnus-group-goto-group group)
-	      (not (when (< (gnus-group-group-level) gnus-level-zombie)
-		     (gnus-request-rename-group group new-name))))
-	    (gnus-error 3 "Couldn't rename group %s to %s"
-			decoded-group decoded-new-name)
-	  ;; We rename the group internally by killing it...
-	  (gnus-group-kill-group)
-	  ;; ... changing its name ...
-	  (setcar (cdar gnus-list-of-killed-groups) new-name)
-	  ;; ... and then yanking it.  Magic!
-	  (gnus-group-yank-group)
-	  (gnus-set-active new-name (gnus-active group))
-	  (gnus-message 6 "Renaming group %s to %s...done"
-			decoded-group decoded-new-name)
-	  new-name)
-      (setq gnus-killed-list (delete group gnus-killed-list))
-      (gnus-set-active group nil)
-      (gnus-dribble-touch)
-      (gnus-group-position-point))))
+  (gnus-message 6 "Renaming group %s to %s..." group new-name)
+  (prog1
+      (if (progn
+	    (gnus-group-goto-group group)
+	    (not (when (< (gnus-group-group-level) gnus-level-zombie)
+		   (gnus-request-rename-group group new-name))))
+	  (gnus-error 3 "Couldn't rename group %s to %s"
+		      group new-name)
+	;; We rename the group internally by killing it...
+	(gnus-group-kill-group)
+	;; ... changing its name ...
+	(setcar (cdar gnus-list-of-killed-groups) new-name)
+	;; ... and then yanking it.  Magic!
+	(gnus-group-yank-group)
+	(gnus-set-active new-name (gnus-active group))
+	(gnus-message 6 "Renaming group %s to %s...done" group new-name)
+	new-name)
+    (setq gnus-killed-list (delete group gnus-killed-list))
+    (gnus-set-active group nil)
+    (gnus-dribble-touch)
+    (gnus-group-position-point)))
 
 (defun gnus-group-edit-group (group &optional part)
   "Edit the group on the current line."
@@ -2966,7 +2921,7 @@ gnus-group-edit-group
        ((eq part 'method) "select method")
        ((eq part 'params) "group parameters")
        (t "group info"))
-      (gnus-group-decoded-name group))
+      group)
      `(lambda (form)
 	(gnus-group-edit-group-done ',part ,group form)))
     (local-set-key
@@ -3105,8 +3060,7 @@ gnus-group-make-doc-group
 	 (coding (gnus-group-name-charset method name)))
     (setcar (cdr method) (encode-coding-string file coding))
     (gnus-group-make-group
-     (encode-coding-string (gnus-group-real-name name) coding)
-     method nil nil t)))
+     (gnus-group-real-name name) method nil nil)))
 
 (defvar nnweb-type-definition)
 (defvar gnus-group-web-type-history nil)
@@ -3611,7 +3565,7 @@ gnus-group-catchup-current
 		   "Do you really want to mark all articles in %s as read? "
 		 "Mark all unread articles in %s as read? ")
 	       (if (= (length groups) 1)
-		   (gnus-group-decoded-name (car groups))
+		   (car groups)
 		 (format "these %d groups" (length groups)))))))
 	n
       (while (setq group (pop groups))
@@ -3696,8 +3650,7 @@ gnus-group-expire-articles
 
 (defun gnus-group-expire-articles-1 (group)
   (when (gnus-check-backend-function 'request-expire-articles group)
-    (gnus-message 6 "Expiring articles in %s..."
-		  (gnus-group-decoded-name group))
+    (gnus-message 6 "Expiring articles in %s..." group)
     (let* ((info (gnus-get-info group))
 	   (expirable (if (gnus-group-total-expirable-p group)
 			  (cons nil (gnus-list-of-read-articles group))
@@ -3724,8 +3677,7 @@ gnus-group-expire-articles-1
 	    ;; Just expire using the normal expiry values.
 	    (gnus-request-expire-articles articles-to-expire group))))
 	(gnus-close-group group))
-      (gnus-message 6 "Expiring articles in %s...done"
-		    (gnus-group-decoded-name group))
+      (gnus-message 6 "Expiring articles in %s...done" group)
       ;; Return the list of un-expired articles.
       (cdr expirable))))
 
@@ -3762,7 +3714,7 @@ gnus-group-set-current-level
   (dolist (group (gnus-group-process-prefix n))
     (gnus-group-remove-mark group)
     (gnus-message 6 "Changed level of %s from %d to %d"
-		  (gnus-group-decoded-name group)
+		  group
 		  (or (gnus-group-group-level) gnus-level-killed)
 		  level)
     (gnus-group-change-level
@@ -3909,7 +3861,7 @@ gnus-group-kill-group
 	  ;; `gnus-newsrc-hashtb', this check will always return nil.
 	  (when (numberp (gnus-group-unread group))
 	    (gnus-request-update-group-status group 'unsubscribe))
-	  (message "Killed group %s" (gnus-group-decoded-name group)))
+	  (message "Killed group %s" group))
       ;; If there are lots and lots of groups to be killed, we use
       ;; this thing instead.
       (dolist (group (nreverse groups))
@@ -4047,7 +3999,7 @@ gnus-group-list-active
       (add-text-properties
        (point) (prog1 (1+ (point))
 		 (insert "       *: "
-			 (gnus-group-decoded-name group)
+			 group
 			 "\n"))
        (list 'gnus-group group
 	     'gnus-unread t
@@ -4494,9 +4446,9 @@ gnus-group-set-info
 		   (prin1-to-string (car method)))
 		 (and (consp method)
 		      (nth 1 (gnus-info-method info)))
-		 nil t)
+		 nil)
 	      ;; It's a native group.
-	      (gnus-group-make-group (gnus-info-group info) nil nil nil t)))
+	      (gnus-group-make-group (gnus-info-group info) nil nil nil)))
 	  (gnus-message 6 "Note: New group created")
 	  (setq entry
 		(gnus-group-entry (gnus-group-prefixed-name
@@ -4685,7 +4637,7 @@ gnus-group-listed-groups
     (while (setq point (text-property-not-all (point) (point-max)
 					      'gnus-group nil))
       (goto-char point)
-      (push (symbol-name (get-text-property point 'gnus-group)) groups)
+      (push (get-text-property point 'gnus-group) groups)
       (forward-char 1))
     groups))
 
@@ -4776,21 +4728,20 @@ gnus-group-compact-group
     (error "No group to compact"))
   (unless (gnus-check-backend-function 'request-compact-group group)
     (error "This back end does not support group compaction"))
-  (let ((group-decoded (gnus-group-decoded-name group)))
-    (gnus-message 6 "\
+  (gnus-message 6 "\
 Compacting group %s... (this may take a long time)"
-		  group-decoded)
-    (prog1
-	(if (not (gnus-request-compact-group group))
-	    (gnus-error 3 "Couldn't compact group %s" group-decoded)
-	  (gnus-message 6 "Compacting group %s...done" group-decoded)
-	  t)
-      ;; Invalidate the "original article" buffer which might be out of date.
-      ;; #### NOTE: Yes, this might be a bit rude, but since compaction
-      ;; #### will not happen very often, I think this is acceptable.
-      (gnus-kill-buffer gnus-original-article-buffer)
-      ;; Update the group line to reflect new information (art number etc).
-      (gnus-group-update-group-line))))
+		group)
+  (prog1
+      (if (not (gnus-request-compact-group group))
+	  (gnus-error 3 "Couldn't compact group %s" group)
+	(gnus-message 6 "Compacting group %s...done" group)
+	t)
+    ;; Invalidate the "original article" buffer which might be out of date.
+    ;; #### NOTE: Yes, this might be a bit rude, but since compaction
+    ;; #### will not happen very often, I think this is acceptable.
+    (gnus-kill-buffer gnus-original-article-buffer)
+    ;; Update the group line to reflect new information (art number etc).
+    (gnus-group-update-group-line)))
 
 (provide 'gnus-group)
 
diff --git a/lisp/gnus/gnus-msg.el b/lisp/gnus/gnus-msg.el
index 819936d935..25efb8afda 100644
--- a/lisp/gnus/gnus-msg.el
+++ b/lisp/gnus/gnus-msg.el
@@ -391,7 +391,7 @@ gnus-msg-force-broken-reply-to
 (defun gnus-inews-make-draft (articles)
   `(lambda ()
      (gnus-inews-make-draft-meta-information
-      ,(gnus-group-decoded-name gnus-newsgroup-name) ',articles)))
+      ,gnus-newsgroup-name ',articles)))
 
 (autoload 'nnir-article-number "nnir" nil nil 'macro)
 (autoload 'nnir-article-group "nnir" nil nil 'macro)
@@ -1680,7 +1680,6 @@ gnus-inews-do-gcc
 (defun gnus-inews-insert-gcc (&optional group)
   "Insert the Gcc to say where the article is to be archived."
   (let* ((group (or group gnus-newsgroup-name))
-         (group (when group (gnus-group-decoded-name group)))
          (var (or gnus-outgoing-message-group gnus-message-archive-group))
 	 (gcc-self-val
 	  (and group (not (gnus-virtual-group-p group))
diff --git a/lisp/gnus/gnus-srvr.el b/lisp/gnus/gnus-srvr.el
index 972ff28e63..71c7807518 100644
--- a/lisp/gnus/gnus-srvr.el
+++ b/lisp/gnus/gnus-srvr.el
@@ -784,11 +784,13 @@ gnus-browse-foreign-server
 	      (while (not (eobp))
 		(ignore-errors
 		  (push (cons
-			 (buffer-substring
-			  (point)
-			  (progn
-			    (skip-chars-forward "^ \t")
-			    (point)))
+			 (decode-coding-string
+			  (buffer-substring
+			   (point)
+			   (progn
+			     (skip-chars-forward "^ \t")
+			     (point)))
+			  'utf-8-emacs)
 			 (let ((last (read cur)))
 			   (cons (read cur) last)))
 			groups))
@@ -796,18 +798,20 @@ gnus-browse-foreign-server
 	    (while (not (eobp))
 	      (ignore-errors
 		(push (cons
-		       (if (eq (char-after) ?\")
-			   (read cur)
-			 (let ((p (point)) (name ""))
-			   (skip-chars-forward "^ \t\\\\")
-			   (setq name (buffer-substring p (point)))
-			   (while (eq (char-after) ?\\)
-			     (setq p (1+ (point)))
-			     (forward-char 2)
-			     (skip-chars-forward "^ \t\\\\")
-			     (setq name (concat name (buffer-substring
-						      p (point)))))
-			   name))
+		       (decode-coding-string
+			(if (eq (char-after) ?\")
+			    (read cur)
+			  (let ((p (point)) (name ""))
+			    (skip-chars-forward "^ \t\\\\")
+			    (setq name (buffer-substring p (point)))
+			    (while (eq (char-after) ?\\)
+			      (setq p (1+ (point)))
+			      (forward-char 2)
+			      (skip-chars-forward "^ \t\\\\")
+			      (setq name (concat name (buffer-substring
+						       p (point)))))
+			    name))
+			'utf-8-emacs)
 		       (let ((last (read cur)))
 			 (cons (read cur) last)))
 		      groups))
@@ -859,12 +863,7 @@ gnus-browse-foreign-server
 			   ((= level gnus-level-zombie) ?Z)
 			   (t ?K)))
 			(max 0 (- (1+ (cddr group)) (cadr group)))
-			;; Don't decode if name is ASCII
-			(if (eq (detect-coding-string name t) 'undecided)
-			    name
-			  (decode-coding-string
-			   name
-			   (inline (gnus-group-name-charset method name)))))))
+			name)))
 	     (list 'gnus-group name)
 	     )))
 	(switch-to-buffer (current-buffer)))
diff --git a/lisp/gnus/gnus-start.el b/lisp/gnus/gnus-start.el
index d726ee5aab..cb585472af 100644
--- a/lisp/gnus/gnus-start.el
+++ b/lisp/gnus/gnus-start.el
@@ -35,6 +35,7 @@
 (autoload 'gnus-agent-read-servers-validate "gnus-agent")
 (autoload 'gnus-agent-save-local "gnus-agent")
 (autoload 'gnus-agent-possibly-alter-active "gnus-agent")
+(declare-function gnus-group-decoded-name "gnus-group" (string))
 
 (eval-when-compile (require 'cl-lib))
 
@@ -1830,17 +1831,22 @@ gnus-make-hashtable-from-newsrc-alist
 	(if (setq rest (member method methods))
 	    (gnus-info-set-method info (car rest))
 	  (push method methods)))
+      ;; Check for encoded group names and decode them.
+      (when (string-match-p "[^[:ascii:]]" (setq gname (car info)))
+	(let ((decoded (gnus-group-decoded-name gname)))
+	 (setf gname decoded
+	       (car info) decoded)))
       ;; Check for duplicates.
-      (if (gethash (car info) gnus-newsrc-hashtb)
+      (if (gethash gname gnus-newsrc-hashtb)
 	  ;; Remove this entry from the alist.
 	  (setcdr alist (cddr alist))
 	(puthash
-	 (car info)
+	 gname
 	 ;; Preserve number of unread articles in groups.
-	 (list (and ohashtb (car (gethash (car info) ohashtb)))
+	 (list (and ohashtb (car (gethash gname ohashtb)))
 	       info)
 	 gnus-newsrc-hashtb)
-	(push (car info) gnus-group-list))
+	(push gname gnus-group-list))
       (setq alist (cdr alist)))
     (setq gnus-group-list (nreverse gnus-group-list))
     ;; Make the same select-methods in `gnus-server-alist' identical
@@ -2146,9 +2152,7 @@ gnus-active-to-gnus-format
 				      (cond ((numberp group)
 					     (number-to-string group))
 					    ((symbolp group)
-					     (encode-coding-string
-					      (symbol-name group)
-					      'latin-1))
+					     (symbol-name group))
 					    ((stringp group)
 					     group)))))
 		     (numberp (setq max (read cur)))
@@ -2157,7 +2161,11 @@ gnus-active-to-gnus-format
 			     (skip-chars-forward " \t")
 			     (memq (char-after)
 				   '(?= ?x ?j)))))
-		(progn (puthash group (cons min max) hashtb)
+		(progn (when (string-match-p "[^[:ascii:]]" group)
+			 ;; NNTP servers may give us encoded group
+			 ;; names.
+			 (setq group (gnus-group-decoded-name group)))
+		       (puthash group (cons min max) hashtb)
 		       ;; If group is moderated, stick it in the
 		       ;; moderation cache.
 		       (when (eq (char-after) ?m)
@@ -2396,6 +2404,17 @@ gnus-read-newsrc-el-file
 	(when gnus-newsrc-assoc
 	  (setq gnus-newsrc-alist gnus-newsrc-assoc))))
     (gnus-make-hashtable-from-newsrc-alist)
+    (when gnus-topic-alist
+      (setq gnus-topic-alist
+	    (mapcar
+	     (lambda (elt)
+	       (cons (car elt)
+		     (mapcar (lambda (g)
+			       (if (string-match-p "[^[:ascii:]]" g)
+				   (gnus-group-decoded-name g)
+				 g))
+			     (cdr elt))))
+	     gnus-topic-alist)))
     (when (file-newer-than-file-p file ding-file)
       ;; Old format quick file
       (gnus-message 5 "Reading %s..." file)
@@ -2494,7 +2513,9 @@ gnus-newsrc-to-gnus-format
 		 (read buf))
 	    group (if (numberp group)
 		      (number-to-string group)
-		    (symbol-name group)))
+		    ;; newsrc files are written as 'raw-text.
+		    (decode-coding-string
+		     (symbol-name group) 'raw-text)))
       (widen)
       (cond
        ;; It's possible that "group" is actually an options line.
@@ -2913,10 +2934,6 @@ gnus-gnus-to-newsrc-format
       (setq default-directory (file-name-directory buffer-file-name))
       (buffer-disable-undo)
       (erase-buffer)
-      ;; Use a unibyte buffer since group names are unibyte strings;
-      ;; in particular, non-ASCII group names are the ones encoded by
-      ;; a certain coding system.
-      (mm-disable-multibyte)
       ;; Write options.
       (when gnus-newsrc-options
 	(insert gnus-newsrc-options))
diff --git a/lisp/gnus/gnus-sum.el b/lisp/gnus/gnus-sum.el
index 73f0eb3918..a6a0bdb228 100644
--- a/lisp/gnus/gnus-sum.el
+++ b/lisp/gnus/gnus-sum.el
@@ -3500,8 +3500,7 @@ gnus-summary-setup-buffer
 
 Returns non-nil if the setup was successful."
   (let ((buffer (gnus-summary-buffer-name group))
-	(dead-name (concat "*Dead Summary "
-			   (gnus-group-decoded-name group) "*")))
+	(dead-name (concat "*Dead Summary " group "*")))
     ;; If a dead summary buffer exists, we kill it.
     (gnus-kill-buffer dead-name)
     (if (get-buffer buffer)
@@ -3984,8 +3983,7 @@ gnus-summary-read-group-1
   ;;  (when (and (not (gnus-group-native-p group))
   ;;	     (not (gethash group gnus-newsrc-hashtb)))
   ;;    (error "Dead non-native groups can't be entered"))
-  (gnus-message 7 "Retrieving newsgroup: %s..."
-		(gnus-group-decoded-name group))
+  (gnus-message 7 "Retrieving newsgroup: %s..." group)
   (let* ((new-group (gnus-summary-setup-buffer group))
 	 (quit-config (gnus-group-quit-config group))
 	 (did-select (and new-group (gnus-select-newsgroup
@@ -4016,8 +4014,7 @@ gnus-summary-read-group-1
 	      (gnus-group-next-unread-group 1))
 	  (gnus-handle-ephemeral-exit quit-config)))
       (if (null (gnus-list-of-unread-articles group))
-	  (gnus-message 3 "Group %s contains no messages"
-			(gnus-group-decoded-name group))
+	  (gnus-message 3 "Group %s contains no messages" group)
 	(gnus-message 3 "Can't select group"))
       nil)
      ;; The user did a `C-g' while prompting for number of articles,
@@ -5618,25 +5615,24 @@ gnus-summary-remove-list-identifiers
 
 (defun gnus-fetch-headers (articles &optional limit force-new dependencies)
   "Fetch headers of ARTICLES."
-  (let ((name (gnus-group-decoded-name gnus-newsgroup-name)))
-    (gnus-message 7 "Fetching headers for %s..." name)
-    (prog1
-	(if (eq 'nov
-		(setq gnus-headers-retrieved-by
-		      (gnus-retrieve-headers
-		       articles gnus-newsgroup-name
-		       (or limit
-			   ;; We might want to fetch old headers, but
-			   ;; not if there is only 1 article.
-			   (and (or (and
-				     (not (eq gnus-fetch-old-headers 'some))
-				     (not (numberp gnus-fetch-old-headers)))
-				    (> (length articles) 1))
-				gnus-fetch-old-headers)))))
-	    (gnus-get-newsgroup-headers-xover
-	     articles force-new dependencies gnus-newsgroup-name t)
-	  (gnus-get-newsgroup-headers dependencies force-new))
-      (gnus-message 7 "Fetching headers for %s...done" name))))
+  (gnus-message 7 "Fetching headers for %s..." gnus-newsgroup-name)
+  (prog1
+      (if (eq 'nov
+	      (setq gnus-headers-retrieved-by
+		    (gnus-retrieve-headers
+		     articles gnus-newsgroup-name
+		     (or limit
+			 ;; We might want to fetch old headers, but
+			 ;; not if there is only 1 article.
+			 (and (or (and
+				   (not (eq gnus-fetch-old-headers 'some))
+				   (not (numberp gnus-fetch-old-headers)))
+				  (> (length articles) 1))
+			      gnus-fetch-old-headers)))))
+	  (gnus-get-newsgroup-headers-xover
+	   articles force-new dependencies gnus-newsgroup-name t)
+	(gnus-get-newsgroup-headers dependencies force-new))
+    (gnus-message 7 "Fetching headers for %s...done" gnus-newsgroup-name)))
 
 (defun gnus-select-newsgroup (group &optional read-all select-articles)
   "Select newsgroup GROUP.
@@ -5649,13 +5645,12 @@ gnus-select-newsgroup
 	      t
 	    gnus-summary-ignore-duplicates))
 	 (info (nth 1 entry))
-	 charset articles fetched-articles cached)
+	 articles fetched-articles cached)
 
     (unless (gnus-check-server
 	     (set (make-local-variable 'gnus-current-select-method)
 		  (gnus-find-method-for-group group)))
       (error "Couldn't open server"))
-    (setq charset (gnus-group-name-charset gnus-current-select-method group))
 
     (or (and entry (not (eq (car entry) t))) ; Either it's active...
 	(gnus-activate-group group)	; Or we can activate it...
@@ -5663,16 +5658,12 @@ gnus-select-newsgroup
 	  (when (derived-mode-p 'gnus-summary-mode)
 	    (gnus-kill-buffer (current-buffer)))
 	  (error
-	   "Couldn't activate group %s: %s"
-	   (decode-coding-string group charset)
-	   (decode-coding-string (gnus-status-message group) charset))))
+	   "Couldn't activate group %s: %s" group (gnus-status-message group))))
 
     (unless (gnus-request-group group t nil info)
       (when (derived-mode-p 'gnus-summary-mode)
 	(gnus-kill-buffer (current-buffer)))
-      (error "Couldn't request group %s: %s"
-	     (decode-coding-string group charset)
-	     (decode-coding-string (gnus-status-message group) charset)))
+      (error "Couldn't request group %s: %s" group (gnus-status-message group)))
 
     (when (and gnus-agent
 	       (gnus-active group))
@@ -5938,13 +5929,11 @@ gnus-articles-to-read
 			   (if only-read-p
 			       (format
 				"How many articles from %s (available %d, default %d): "
-				(gnus-group-real-name
-				 (gnus-group-decoded-name gnus-newsgroup-name))
+				(gnus-group-real-name gnus-newsgroup-name)
 				number default)
 			     (format
 			      "How many articles from %s (%d default): "
-			      (gnus-group-real-name
-			       (gnus-group-decoded-name gnus-newsgroup-name))
+			      (gnus-group-real-name gnus-newsgroup-name)
 			      default))
 			   nil
 			   nil
@@ -5956,8 +5945,7 @@ gnus-articles-to-read
 			 (read-string
 			  (format "%s %s (%d scored, %d total): "
 				  "How many articles from"
-				  (gnus-group-decoded-name
-				   (gnus-group-real-name gnus-newsgroup-name))
+				  (gnus-group-real-name gnus-newsgroup-name)
 				  scored number))))
 		    (if (string-match "^[ \t]*$" input)
 			number input)))
@@ -6199,8 +6187,7 @@ gnus-set-mode-line
 			 (intern
 			  (format "gnus-%s-mode-line-format-spec" where))))
 	       (gnus-tmp-group-name (gnus-mode-string-quote
-				     (gnus-group-decoded-name
-				      gnus-newsgroup-name)))
+				     gnus-newsgroup-name))
 	       (gnus-tmp-article-number (or gnus-current-article 0))
 	       (gnus-tmp-unread gnus-newsgroup-unreads)
 	       (gnus-tmp-unread-and-unticked (length gnus-newsgroup-unreads))
@@ -7921,11 +7908,11 @@ gnus-summary-walk-group-buffer
 		      (not (gnus-ephemeral-group-p gnus-newsgroup-name)))
 		 (format " (Type %s for %s [%s])"
 			 (single-key-description cmd)
-			 (gnus-group-decoded-name group)
+			 group
 			 (gnus-group-unread group))
 	       (format " (Type %s to exit %s)"
 		       (single-key-description cmd)
-		       (gnus-group-decoded-name gnus-newsgroup-name)))))
+		       gnus-newsgroup-name))))
       ;; Confirm auto selection.
       (setq key (car (setq keve (gnus-read-event-char prompt)))
 	    ended t)
@@ -10110,7 +10097,7 @@ gnus-summary-move-article
 	(copy-buf (save-excursion
 		    (nnheader-set-temp-buffer " *copy article*")))
 	art-group to-method new-xref article to-groups
-	articles-to-update-marks encoded)
+	articles-to-update-marks)
     (unless (assq action names)
       (error "Unknown action %s" action))
     ;; Read the newsgroup name.
@@ -10132,22 +10119,12 @@ gnus-summary-move-article
 			  (symbol-value
 			   (intern (format "gnus-current-%s-group" action)))
 			  articles prefix)
-	    encoded to-newsgroup
 	    to-method (gnus-server-to-method (gnus-group-method to-newsgroup)))
-      (set (intern (format "gnus-current-%s-group" action))
-	   (decode-coding-string
-	    to-newsgroup
-	    (gnus-group-name-charset to-method to-newsgroup))))
+      (set (intern (format "gnus-current-%s-group" action)) to-newsgroup))
     (unless to-method
       (setq to-method (or select-method
 			  (gnus-server-to-method
 			   (gnus-group-method to-newsgroup)))))
-    (setq to-newsgroup
-	  (or encoded
-	      (and to-newsgroup
-		   (encode-coding-string
-		    to-newsgroup
-		    (gnus-group-name-charset to-method to-newsgroup)))))
     ;; Check the method we are to move this article to...
     (unless (gnus-check-backend-function
 	     'request-accept-article (car to-method))
@@ -10157,7 +10134,7 @@ gnus-summary-move-article
     (gnus-message 6 "%s to %s: %s..."
 		  (caddr (assq action names))
 		  (or (car select-method)
-		      (gnus-group-decoded-name to-newsgroup))
+		      to-newsgroup)
 		  articles)
     ;; This `while' is not equivalent to a `dolist' (bug#33653#134).
     (while articles
@@ -12469,27 +12446,23 @@ gnus-read-move-group-name
            (t
             (gnus-completing-read
              prom (nreverse split-name) nil nil 'gnus-group-history))))
-         (to-method (gnus-server-to-method (gnus-group-method to-newsgroup)))
-	 encoded)
+         (to-method (gnus-server-to-method (gnus-group-method to-newsgroup))))
     (when to-newsgroup
       (if (or (string= to-newsgroup "")
 	      (string= to-newsgroup prefix))
 	  (setq to-newsgroup default))
       (unless to-newsgroup
-	(user-error "No group name entered"))
-      (setq encoded (encode-coding-string
-		     to-newsgroup
-		     (gnus-group-name-charset to-method to-newsgroup)))
-      (or (gnus-active encoded)
-	  (gnus-activate-group encoded nil nil to-method)
+	(error "No group name entered"))
+      (or (gnus-active to-newsgroup)
+	  (gnus-activate-group to-newsgroup nil nil to-method)
 	  (if (gnus-y-or-n-p (format "No such group: %s.  Create it? "
 				     to-newsgroup))
-	      (or (and (gnus-request-create-group encoded to-method)
-		       (gnus-activate-group encoded nil nil to-method)
-		       (gnus-subscribe-group encoded))
+	      (or (and (gnus-request-create-group to-newsgroup to-method)
+		       (gnus-activate-group to-newsgroup nil nil to-method)
+		       (gnus-subscribe-group to-newsgroup))
 		  (error "Couldn't create group %s" to-newsgroup)))
-	  (user-error "No such group: %s" to-newsgroup))
-      encoded)))
+	  (error "No such group: %s" to-newsgroup))
+      to-newsgroup)))
 
 (defvar gnus-summary-save-parts-counter)
 (declare-function mm-uu-dissect "mm-uu" (&optional noheader mime-type))
@@ -13156,7 +13129,7 @@ gnus-summary-insert-old-articles
 		      (read-string
 		       (format
 			"How many articles from %s (%s %d): "
-			(gnus-group-decoded-name gnus-newsgroup-name)
+			gnus-newsgroup-name
 			(if initial "max" "default")
 			len)
 		       nil nil
diff --git a/lisp/gnus/gnus-util.el b/lisp/gnus/gnus-util.el
index 9ccdb83865..c6be59fd19 100644
--- a/lisp/gnus/gnus-util.el
+++ b/lisp/gnus/gnus-util.el
@@ -1173,16 +1173,9 @@ gnus-and
   "Return non-nil if all ELEMENTS are non-nil."
   (not (memq nil elements)))
 
-;; gnus.el requires mm-util.
-(declare-function mm-disable-multibyte "mm-util")
-
 (defun gnus-write-active-file (file hashtb &optional full-names)
-  ;; `coding-system-for-write' should be `raw-text' or equivalent.
   (let ((coding-system-for-write nnmail-active-file-coding-system))
     (with-temp-file file
-      ;; The buffer should be in the unibyte mode because group names
-      ;; are ASCII text or encoded non-ASCII text (i.e., unibyte).
-      (mm-disable-multibyte)
       (maphash
        (lambda (group active)
 	 (when active
diff --git a/lisp/gnus/gnus.el b/lisp/gnus/gnus.el
index 9ee7db9e20..f990569a30 100644
--- a/lisp/gnus/gnus.el
+++ b/lisp/gnus/gnus.el
@@ -3444,11 +3444,9 @@ gnus-group-prefixed-p
   "Return the prefix of the current group name."
   (< 0 (length (gnus-group-real-prefix group))))
 
-(declare-function gnus-group-decoded-name "gnus-group" (string))
-
 (defun gnus-summary-buffer-name (group)
   "Return the summary buffer name of GROUP."
-  (concat "*Summary " (gnus-group-decoded-name group) "*"))
+  (concat "*Summary " group "*"))
 
 (defun gnus-group-method (group)
   "Return the server or method used for selecting GROUP.
diff --git a/lisp/gnus/message.el b/lisp/gnus/message.el
index ea7a282b8b..1183cd9385 100644
--- a/lisp/gnus/message.el
+++ b/lisp/gnus/message.el
@@ -1889,7 +1889,6 @@ message-bogus-system-names
 (autoload 'gnus-delay-article "gnus-delay")
 (autoload 'gnus-extract-address-components "gnus-util")
 (autoload 'gnus-find-method-for-group "gnus")
-(autoload 'gnus-group-decoded-name "gnus-group")
 (autoload 'gnus-group-name-charset "gnus-group")
 (autoload 'gnus-group-name-decode "gnus-group")
 (autoload 'gnus-groups-from-server "gnus")
@@ -5626,7 +5625,7 @@ message-make-in-reply-to
 	  (concat
 	   msg-id (if msg-id " (")
 	   (if (car name)
-	       (if (string-match "[^\000-\177]" (car name))
+	       (if (string-match "[^[:ascii:]]" (car name))
 		   ;; Quote a string containing non-ASCII characters.
 		   ;; It will make the RFC2047 encoder cause an error
 		   ;; if there are special characters.
@@ -7283,12 +7282,11 @@ message-forward-subject-name-subject
   (let* ((group (message-fetch-field "newsgroups"))
 	 (from (message-fetch-field "from"))
 	 (prefix
-	  (if group
-	      (gnus-group-decoded-name group)
-	    (or (and from (or
-			   (car (gnus-extract-address-components from))
-			   (cadr (gnus-extract-address-components from))))
-		"(nowhere)"))))
+	  (or group
+	      (or (and from (or
+			     (car (gnus-extract-address-components from))
+			     (cadr (gnus-extract-address-components from))))
+		  "(nowhere)"))))
     (concat "["
 	    (if message-forward-decoded-p
 		prefix
@@ -7302,10 +7300,9 @@ message-forward-subject-author-subject
 the list of newsgroups is was posted to."
   (let* ((group (message-fetch-field "newsgroups"))
 	 (prefix
-	  (if group
-	      (gnus-group-decoded-name group)
-	    (or (message-fetch-field "from")
-		"(nowhere)"))))
+	  (or group
+	      (or (message-fetch-field "from")
+		  "(nowhere)"))))
     (concat "["
 	    (if message-forward-decoded-p
 		prefix
diff --git a/lisp/gnus/nnagent.el b/lisp/gnus/nnagent.el
index 64f3a86181..f0baf99bd4 100644
--- a/lisp/gnus/nnagent.el
+++ b/lisp/gnus/nnagent.el
@@ -117,18 +117,17 @@ nnagent-request-post
   (gnus-request-accept-article "nndraft:queue" nil t t))
 
 (deffoo nnagent-request-set-mark (group action server)
-  (mm-with-unibyte-buffer
-    (insert "(gnus-agent-synchronize-group-flags \""
-	    group
-	    "\" '")
-    (gnus-pp action)
-    (insert " \""
-	    (gnus-method-to-server gnus-command-method)
-	    "\"")
-    (insert ")\n")
-    (let ((coding-system-for-write nnheader-file-coding-system))
-      (write-region (point-min) (point-max) (gnus-agent-lib-file "flags")
-		    t 'silent)))
+  (insert "(gnus-agent-synchronize-group-flags \""
+	  group
+	  "\" '")
+  (gnus-pp action)
+  (insert " \""
+	  (gnus-method-to-server gnus-command-method)
+	  "\"")
+  (insert ")\n")
+  (let ((coding-system-for-write nnheader-file-coding-system))
+    (write-region (point-min) (point-max) (gnus-agent-lib-file "flags")
+		  t 'silent))
   ;; Also set the marks for the original back end that keeps marks in
   ;; the local system.
   (let ((gnus-agent nil))
diff --git a/lisp/gnus/nnheader.el b/lisp/gnus/nnheader.el
index 6ef324ae91..c87cfc8c7c 100644
--- a/lisp/gnus/nnheader.el
+++ b/lisp/gnus/nnheader.el
@@ -30,7 +30,6 @@
 
 (defvar nnmail-extra-headers)
 (defvar gnus-newsgroup-name)
-(defvar nnheader-file-coding-system)
 (defvar jka-compr-compression-info-list)
 
 ;; Requiring `gnus-util' at compile time creates a circular
@@ -499,7 +498,8 @@ nnheader-find-nov-line
 
 (defvar nntp-server-buffer nil)
 (defvar nntp-process-response nil)
-
+(defvar nnheader-file-coding-system 'undecided
+  "Coding system used in file backends of Gnus.")
 (defvar nnheader-callback-function nil)
 
 (defun nnheader-init-server-buffer ()
@@ -871,9 +871,6 @@ nnheader-re-read-dir
       (when (string-match (car ange-ftp-path-format) path)
 	(ange-ftp-re-read-dir path)))))
 
-(defvar nnheader-file-coding-system 'raw-text
-  "Coding system used in file backends of Gnus.")
-
 (defun nnheader-insert-file-contents (filename &optional visit beg end replace)
   "Like `insert-file-contents', q.v., but only reads in the file.
 A buffer may be modified in several ways after reading into the buffer due
diff --git a/lisp/gnus/nnimap.el b/lisp/gnus/nnimap.el
index c6eaa54c69..7c402e8d54 100644
--- a/lisp/gnus/nnimap.el
+++ b/lisp/gnus/nnimap.el
@@ -119,12 +119,6 @@ nnimap-current-infos
 
 (defvoo nnimap-namespace nil)
 
-(defun nnimap-decode-gnus-group (group)
-  (decode-coding-string group 'utf-8))
-
-(defun nnimap-encode-gnus-group (group)
-  (encode-coding-string group 'utf-8))
-
 (defvoo nnimap-fetch-partial-articles nil
   "If non-nil, Gnus will fetch partial articles.
 If t, Gnus will fetch only the first part.  If a string, it
@@ -209,8 +203,6 @@ nnimap-header-parameters
     (format "%s" (nreverse params))))
 
 (deffoo nnimap-retrieve-headers (articles &optional group server _fetch-old)
-  (when group
-    (setq group (nnimap-decode-gnus-group group)))
   (with-current-buffer nntp-server-buffer
     (erase-buffer)
     (when (nnimap-change-group group server)
@@ -645,8 +637,6 @@ nnimap-status-message
   nnimap-status-string)
 
 (deffoo nnimap-request-article (article &optional group server to-buffer)
-  (when group
-    (setq group (nnimap-decode-gnus-group group)))
   (with-current-buffer nntp-server-buffer
     (let ((result (nnimap-change-group group server))
 	  parts structure)
@@ -678,8 +668,6 @@ nnimap-request-article
 	    (cons group article)))))))
 
 (deffoo nnimap-request-head (article &optional group server to-buffer)
-  (when group
-    (setq group (nnimap-decode-gnus-group group)))
   (when (nnimap-change-group group server)
     (with-current-buffer (nnimap-buffer)
       (when (stringp article)
@@ -697,8 +685,6 @@ nnimap-request-head
 	    (cons group article)))))))
 
 (deffoo nnimap-request-articles (articles &optional group server)
-  (when group
-    (setq group (nnimap-decode-gnus-group group)))
   (with-current-buffer nntp-server-buffer
     (let ((result (nnimap-change-group group server)))
       (when result
@@ -848,7 +834,6 @@ nnimap-find-wanted-parts-1
     (nreverse parts)))
 
 (deffoo nnimap-request-group (group &optional server dont-check info)
-  (setq group (nnimap-decode-gnus-group group))
   (let ((result (nnimap-change-group
 		 ;; Don't SELECT the group if we're going to select it
 		 ;; later, anyway.
@@ -875,11 +860,10 @@ nnimap-request-group
 			(- (cdr active) (car active))
 			(car active)
 			(cdr active)
-			(nnimap-encode-gnus-group group)))
+			group))
 	t))))
 
 (deffoo nnimap-request-group-scan (group &optional server info)
-  (setq group (nnimap-decode-gnus-group group))
   (when (nnimap-change-group nil server)
     (let (marks high low)
       (with-current-buffer (nnimap-buffer)
@@ -911,23 +895,20 @@ nnimap-request-group-scan
 	(insert
 	 (format
 	  "211 %d %d %d %S\n" (1+ (- high low)) low high
-	  (nnimap-encode-gnus-group group)))
+	  group))
 	t))))
 
 (deffoo nnimap-request-create-group (group &optional server _args)
-  (setq group (nnimap-decode-gnus-group group))
   (when (nnimap-change-group nil server)
     (with-current-buffer (nnimap-buffer)
       (car (nnimap-command "CREATE %S" (nnimap-group-to-imap group))))))
 
 (deffoo nnimap-request-delete-group (group &optional _force server)
-  (setq group (nnimap-decode-gnus-group group))
   (when (nnimap-change-group nil server)
     (with-current-buffer (nnimap-buffer)
       (car (nnimap-command "DELETE %S" (nnimap-group-to-imap group))))))
 
 (deffoo nnimap-request-rename-group (group new-name &optional server)
-  (setq group (nnimap-decode-gnus-group group))
   (when (nnimap-change-group nil server)
     (with-current-buffer (nnimap-buffer)
       (nnimap-unselect-group)
@@ -942,7 +923,6 @@ nnimap-unselect-group
   (nnimap-command "EXAMINE DOES.NOT.EXIST"))
 
 (deffoo nnimap-request-expunge-group (group &optional server)
-  (setq group (nnimap-decode-gnus-group group))
   (when (nnimap-change-group group server)
     (with-current-buffer (nnimap-buffer)
       (car (nnimap-command "EXPUNGE")))))
@@ -971,9 +951,6 @@ nnimap-close-group
 (deffoo nnimap-request-move-article (article group server accept-form
 					     &optional _last
 					     internal-move-group)
-  (setq group (nnimap-decode-gnus-group group))
-  (when internal-move-group
-    (setq internal-move-group (nnimap-decode-gnus-group internal-move-group)))
   (with-temp-buffer
     (mm-disable-multibyte)
     (when (funcall (if internal-move-group
@@ -1007,7 +984,6 @@ nnimap-request-move-article
 	    result))))))
 
 (deffoo nnimap-request-expire-articles (articles group &optional server force)
-  (setq group (nnimap-decode-gnus-group group))
   (cond
    ((null articles)
     nil)
@@ -1156,8 +1132,6 @@ nnimap-delete-article
                                 "delete this article now"))))))
 
 (deffoo nnimap-request-scan (&optional group server)
-  (when group
-    (setq group (nnimap-decode-gnus-group group)))
   (when (and (nnimap-change-group nil server)
 	     nnimap-inbox
 	     nnimap-split-methods)
@@ -1176,7 +1150,6 @@ nnimap-marks-to-flags
     flags))
 
 (deffoo nnimap-request-update-group-status (group status &optional server)
-  (setq group (nnimap-decode-gnus-group group))
   (when (nnimap-change-group nil server)
     (let ((command (assoc
 		    status
@@ -1187,7 +1160,6 @@ nnimap-request-update-group-status
 	  (nnimap-command "%s %S" (cadr command) (nnimap-group-to-imap group)))))))
 
 (deffoo nnimap-request-set-mark (group actions &optional server)
-  (setq group (nnimap-decode-gnus-group group))
   (when (nnimap-change-group group server)
     (let (sequence)
       (with-current-buffer (nnimap-buffer)
@@ -1222,8 +1194,7 @@ nnimap-request-accept-article
 	    ;; that's determined by the IMAP server later.  So just
 	    ;; return the group name.
 	    (lambda (group)
-              (list (list group)))))))
-  (setq group (nnimap-decode-gnus-group group))
+	       (list (list group)))))))
   (when (nnimap-change-group nil server)
     (nnmail-check-syntax)
     (let ((message-id (message-field-value "message-id"))
@@ -1301,7 +1272,6 @@ nnimap-find-response-element
     result))
 
 (deffoo nnimap-request-replace-article (article group buffer)
-  (setq group (nnimap-decode-gnus-group group))
   (let (group-art)
     (when (and (nnimap-change-group group)
 	       ;; Put the article into the group.
@@ -1385,8 +1355,7 @@ nnimap-request-list
 	  (dolist (response responses)
 	    (let* ((sequence (car response))
 		   (response (cadr response))
-		   (group (cadr (assoc sequence sequences)))
-		   (egroup (nnimap-encode-gnus-group group)))
+		   (group (cadr (assoc sequence sequences))))
 	      (when (and group
 			 (equal (caar response) "OK"))
 		(let ((uidnext (nnimap-find-parameter "UIDNEXT" response))
@@ -1398,14 +1367,14 @@ nnimap-request-list
 		    (setq highest (1- (string-to-number (car uidnext)))))
 		  (cond
 		   ((null highest)
-		    (insert (format "%S 0 1 y\n" egroup)))
+		    (insert (format "%S 0 1 y\n" group)))
 		   ((zerop exists)
 		    ;; Empty group.
-		    (insert (format "%S %d %d y\n" egroup
+		    (insert (format "%S %d %d y\n" group
 				    highest (1+ highest))))
 		   (t
 		    ;; Return the widest possible range.
-		    (insert (format "%S %d 1 y\n" egroup
+		    (insert (format "%S %d 1 y\n" group
 				    (or highest exists)))))))))
 	  t)))))
 
@@ -1417,7 +1386,7 @@ nnimap-request-newgroups
 		       (nnimap-get-groups)))
 	(unless (assoc group nnimap-current-infos)
 	  ;; Insert dummy numbers here -- they don't matter.
-	  (insert (format "%S 0 1 y\n" (nnimap-encode-gnus-group group)))))
+	  (insert (format "%S 0 1 y\n" group))))
       t)))
 
 (deffoo nnimap-retrieve-group-data-early (server infos)
@@ -1434,8 +1403,7 @@ nnimap-retrieve-group-data-early
 	;; what and how to request the data.
 	(dolist (info infos)
 	  (setq params (gnus-info-params info)
-		group (nnimap-decode-gnus-group
-		       (gnus-group-real-name (gnus-info-group info)))
+		group (gnus-group-real-name (gnus-info-group info))
 		active (cdr (assq 'active params))
 		unexist (assq 'unexist (gnus-info-marks info))
 		uidvalidity (cdr (assq 'uidvalidity params))
@@ -1516,16 +1484,13 @@ nnimap-finish-retrieve-group-infos
 		     (active (gnus-active group)))
 		(when active
 		  (insert (format "%S %d %d y\n"
-				  (nnimap-encode-gnus-group
-				   (nnimap-decode-gnus-group
-				    (gnus-group-real-name group)))
+				  (gnus-group-real-name group)
 				  (cdr active)
 				  (car active))))))))))))
 
 (defun nnimap-update-infos (flags infos)
   (dolist (info infos)
-    (let* ((group (nnimap-decode-gnus-group
-		   (gnus-group-real-name (gnus-info-group info))))
+    (let* ((group (gnus-group-real-name (gnus-info-group info)))
 	   (marks (cdr (assoc group flags))))
       (when marks
 	(nnimap-update-info info marks)))))
@@ -1739,8 +1704,7 @@ nnimap-imap-ranges-to-gnus-ranges
       (nreverse result))))
 
 (defun nnimap-store-info (info active)
-  (let* ((group (nnimap-decode-gnus-group
-		 (gnus-group-real-name (gnus-info-group info))))
+  (let* ((group (gnus-group-real-name (gnus-info-group info)))
 	 (entry (assoc group nnimap-current-infos)))
     (if entry
 	(setcdr entry (list info active))
@@ -1865,8 +1829,6 @@ gnus-refer-thread-use-nnir
 (autoload 'nnir-search-thread "nnir")
 
 (deffoo nnimap-request-thread (header &optional group server)
-  (when group
-    (setq group (nnimap-decode-gnus-group group)))
   (if gnus-refer-thread-use-nnir
       (nnir-search-thread header)
     (when (nnimap-change-group group server)
diff --git a/lisp/gnus/nnmail.el b/lisp/gnus/nnmail.el
index 0699e81812..de6b01774d 100644
--- a/lisp/gnus/nnmail.el
+++ b/lisp/gnus/nnmail.el
@@ -665,9 +665,12 @@ nnmail-parse-active
       (condition-case err
 	  (progn
 	    (narrow-to-region (point) (point-at-eol))
-	    (setq group (read buffer))
-	    (unless (stringp group)
-	      (setq group (encode-coding-string (symbol-name group) 'latin-1)))
+	    (setq group (read buffer)
+		  group
+		  (cond ((symbolp group)
+			 (symbol-name group))
+			((numberp group)
+			 (number-to-string group))))
 	    (if (and (numberp (setq max (read buffer)))
 		     (numberp (setq min (read buffer))))
 		(push (list group (cons min max))
@@ -677,7 +680,7 @@ nnmail-parse-active
       (forward-line 1))
     group-assoc))
 
-(defcustom nnmail-active-file-coding-system 'raw-text
+(defcustom nnmail-active-file-coding-system 'utf-8-emacs
   "Coding system for active file."
   :group 'nnmail-various
   :type 'coding-system)
@@ -687,7 +690,7 @@ nnmail-save-active
   (let ((coding-system-for-write nnmail-active-file-coding-system))
     (when file-name
       (with-temp-file file-name
-	(mm-disable-multibyte)
+;	(mm-disable-multibyte)
 	(nnmail-generate-active group-assoc)))))
 
 (defun nnmail-generate-active (alist)
@@ -695,7 +698,7 @@ nnmail-generate-active
   (erase-buffer)
   (let (group)
     (while (setq group (pop alist))
-      (insert (format "%S %d %d y\n" (intern (car group)) (cdadr group)
+      (insert (format "%s %d %d y\n" (car group) (cdadr group)
 		      (caadr group))))
     (goto-char (point-max))
     (while (search-backward "\\." nil t)
@@ -1027,8 +1030,8 @@ nnmail-process-maildir-mail-format
       (nnmail-check-duplication message-id func artnum-func))
     1))
 
-(defvar nnmail-group-names-not-encoded-p nil
-  "Non-nil means group names are not encoded.")
+(make-obsolete-variable 'nnmail-group-names-not-encoded-p
+			"Group names are always decoded" "27.1")
 
 (defun nnmail-split-incoming (incoming func &optional exit-func
 				       group artnum-func junk-func)
@@ -1036,18 +1039,21 @@ nnmail-split-incoming
 FUNC will be called with the buffer narrowed to each mail.
 INCOMING can also be a buffer object.  In that case, the mail
 will be copied over from that buffer."
-  (let ( ;; If this is a group-specific split, we bind the split
+  (let (;; If this is a group-specific split, we bind the split
 	;; methods to just this group.
 	(nnmail-split-methods (if (and group
 				       (not nnmail-resplit-incoming))
 				  (list (list group ""))
-				nnmail-split-methods))
-	(nnmail-group-names-not-encoded-p t))
+				nnmail-split-methods)))
     ;; Insert the incoming file.
     (with-current-buffer (get-buffer-create nnmail-article-buffer)
       (erase-buffer)
       (if (bufferp incoming)
 	  (insert-buffer-substring incoming)
+	;; The following coding system is set to
+	;; `mm-text-coding-system', which is set to some flavor of
+	;; 'raw-text "to get rid of ^Ms".  But it's going to do a lot
+	;; more than that, right?  Shouldn't this also be 'undecided?
 	(let ((coding-system-for-read nnmail-incoming-coding-system))
 	  (mm-insert-file-contents incoming)))
       (prog1
diff --git a/lisp/gnus/nnmaildir.el b/lisp/gnus/nnmaildir.el
index 246f52c8d2..d62e1e9253 100644
--- a/lisp/gnus/nnmaildir.el
+++ b/lisp/gnus/nnmaildir.el
@@ -415,7 +415,7 @@ nnmaildir--new-number
 	   (t (signal (car err) (cdr err)))))))))
 
 (defun nnmaildir--update-nov (server group article)
-  (let ((nnheader-file-coding-system 'binary)
+  (let ((nnheader-file-coding-system 'undecided)
 	(srv-dir (nnmaildir--srv-dir server))
 	(storage-version 1) ;; [version article-number msgid [...nov...]]
 	dir gname pgname msgdir prefix suffix file attr mtime novdir novfile
diff --git a/lisp/gnus/nnml.el b/lisp/gnus/nnml.el
index 89c8b23b65..302589bd6d 100644
--- a/lisp/gnus/nnml.el
+++ b/lisp/gnus/nnml.el
@@ -111,36 +111,9 @@ nnml-file-coding-system
 
 (nnoo-define-basics nnml)
 
-(eval-when-compile
-  (defsubst nnml-group-name-charset (group server-or-method)
-    (gnus-group-name-charset
-     (if (stringp server-or-method)
-	 (gnus-server-to-method
-	  (if (string-match "\\+" server-or-method)
-	      (concat (substring server-or-method 0 (match-beginning 0))
-		      ":" (substring server-or-method (match-end 0)))
-	    (concat "nnml:" server-or-method)))
-       (or server-or-method gnus-command-method '(nnml "")))
-     group)))
-
-(defun nnml-decoded-group-name (group &optional server-or-method)
-  "Return a decoded group name of GROUP on SERVER-OR-METHOD."
-  (if nnmail-group-names-not-encoded-p
-      group
-    (decode-coding-string
-     group
-     (nnml-group-name-charset group server-or-method))))
-
-(defun nnml-encoded-group-name (group &optional server-or-method)
-  "Return an encoded group name of GROUP on SERVER-OR-METHOD."
-  (encode-coding-string
-   group
-   (nnml-group-name-charset group server-or-method)))
-
 (defun nnml-group-pathname (group &optional file server)
   "Return an absolute file name of FILE for GROUP on SERVER."
-  (nnmail-group-pathname (inline (nnml-decoded-group-name group server))
-			 nnml-directory file))
+  (nnmail-group-pathname group nnml-directory file))
 
 (deffoo nnml-retrieve-headers (sequence &optional group server fetch-old)
   (when (nnml-possibly-change-directory group server)
@@ -243,8 +216,7 @@ nnml-request-article
 	    (string-to-number (file-name-nondirectory path)))))))
 
 (deffoo nnml-request-group (group &optional server dont-check info)
-  (let ((file-name-coding-system nnmail-pathname-coding-system)
-	(decoded (nnml-decoded-group-name group server)))
+  (let ((file-name-coding-system nnmail-pathname-coding-system))
     (cond
      ((not (nnml-possibly-change-directory group server))
       (nnheader-report 'nnml "Invalid group (no such directory)"))
@@ -254,15 +226,15 @@ nnml-request-group
      ((not (file-directory-p nnml-current-directory))
       (nnheader-report 'nnml "%s is not a directory" nnml-current-directory))
      (dont-check
-      (nnheader-report 'nnml "Group %s selected" decoded)
+      (nnheader-report 'nnml "Group %s selected" group)
       t)
      (t
       (nnheader-re-read-dir nnml-current-directory)
       (nnmail-activate 'nnml)
       (let ((active (nth 1 (assoc-string group nnml-group-alist))))
 	(if (not active)
-	    (nnheader-report 'nnml "No such group: %s" decoded)
-	  (nnheader-report 'nnml "Selected group %s" decoded)
+	    (nnheader-report 'nnml "No such group: %s" group)
+	  (nnheader-report 'nnml "Selected group %s" group)
 	  (nnheader-insert "211 %d %d %d %s\n"
 			   (max (1+ (- (cdr active) (car active))) 0)
 			   (car active) (cdr active) group)))))))
@@ -332,7 +304,6 @@ nnml-request-expire-articles
 	 (active-articles
 	  (nnml-directory-articles nnml-current-directory))
 	 (is-old t)
-	 (decoded (nnml-decoded-group-name group server))
 	 article rest mod-time number target)
     (nnmail-activate 'nnml)
 
@@ -370,7 +341,7 @@ nnml-request-expire-articles
 	    (if target
 		(progn
 		  (nnheader-message 5 "Deleting article %s in %s"
-				    number decoded)
+				    number group)
 		  (condition-case ()
 		      (funcall nnmail-delete-file-function article)
 		    (file-error
@@ -506,13 +477,12 @@ nnml-request-delete-group
 			nnml-current-directory t
 			(concat
 			 nnheader-numerical-short-files
-			 "\\|" (regexp-quote nnml-nov-file-name) "$")))
-		      (decoded (nnml-decoded-group-name group server)))
+			 "\\|" (regexp-quote nnml-nov-file-name) "$"))))
 		  (dolist (article articles)
 		    (when (file-writable-p article)
 		      (nnheader-message 5 "Deleting article %s in %s..."
 					(file-name-nondirectory article)
-					decoded)
+					group)
 		      (funcall nnmail-delete-file-function article))))
 		;; Try to delete the directory itself.
 		(ignore-errors (delete-directory nnml-current-directory))))
@@ -687,15 +657,7 @@ nnml-save-mail
 			 (if (stringp nnml-use-compressed-files)
 			     nnml-use-compressed-files
 			   ".gz")))
-	 decoded dec file first headers)
-    (when nnmail-group-names-not-encoded-p
-      (dolist (ga (prog1 group-art (setq group-art nil)))
-	(setq group-art (nconc group-art
-			       (list (cons (nnml-encoded-group-name (car ga)
-								    server)
-					   (cdr ga))))
-	      decoded (nconc decoded (list (car ga)))))
-      (setq dec decoded))
+	 file first headers)
     (nnmail-insert-xref group-art)
     (run-hooks 'nnmail-prepare-save-mail-hook)
     (run-hooks 'nnml-prepare-save-mail-hook)
@@ -705,16 +667,10 @@ nnml-save-mail
       (forward-line 1))
     ;; We save the article in all the groups it belongs in.
     (dolist (ga group-art)
-      (if nnmail-group-names-not-encoded-p
-	  (progn
-	    (nnml-possibly-create-directory (car decoded) server)
-	    (setq file (nnmail-group-pathname
-			(pop decoded) nnml-directory
-			(concat (number-to-string (cdr ga)) extension))))
-	(nnml-possibly-create-directory (car ga) server)
-	(setq file (nnml-group-pathname
-		    (car ga) (concat (number-to-string (cdr ga)) extension)
-		    server)))
+      (nnml-possibly-create-directory (car ga) server)
+      (setq file (nnml-group-pathname
+		  (car ga) (concat (number-to-string (cdr ga)) extension)
+		  server))
       (if first
 	  ;; It was already saved, so we just make a hard link.
 	  (let ((file-name-coding-system nnmail-pathname-coding-system))
@@ -731,18 +687,13 @@ nnml-save-mail
     (let ((func (if full-nov
 		    'nnml-add-nov
 		  'nnml-add-incremental-nov)))
-      (if nnmail-group-names-not-encoded-p
-	  (dolist (ga group-art)
-	    (funcall func (pop dec) (cdr ga) headers))
-	(dolist (ga group-art)
-	  (funcall func (car ga) (cdr ga) headers)))))
+      (dolist (ga group-art)
+	(funcall func (car ga) (cdr ga) headers))))
   group-art)
 
 (defun nnml-active-number (group &optional server)
   "Compute the next article number in GROUP on SERVER."
-  (let* ((encoded (if nnmail-group-names-not-encoded-p
-		      (nnml-encoded-group-name group server)))
-	 (active (cadr (assoc-string (or encoded group) nnml-group-alist))))
+  (let ((active (cadr (assoc-string group nnml-group-alist))))
     ;; The group wasn't known to nnml, so we just create an active
     ;; entry for it.
     (unless active
@@ -760,7 +711,7 @@ nnml-active-number
 		(cons (caar nnml-article-file-alist)
 		      (caar (last nnml-article-file-alist)))
 	      (cons 1 0)))
-      (push (list (or encoded group) active) nnml-group-alist))
+      (push (list group active) nnml-group-alist))
     (setcdr active (1+ (cdr active)))
     (while (file-exists-p
 	    (nnml-group-pathname group (int-to-string (cdr active)) server))
@@ -821,16 +772,15 @@ nnml-parse-head
 	headers))))
 
 (defun nnml-get-nov-buffer (group &optional incrementalp)
-  (let* ((decoded (nnml-decoded-group-name group))
-	 (buffer (get-buffer-create (format " *nnml %soverview %s*"
+  (let ((buffer (get-buffer-create (format " *nnml %soverview %s*"
 					    (if incrementalp
 						"incremental "
 					      "")
-					    decoded)))
+					    group)))
 	 (file-name-coding-system nnmail-pathname-coding-system))
     (with-current-buffer buffer
       (set (make-local-variable 'nnml-nov-buffer-file-name)
-	   (nnmail-group-pathname decoded nnml-directory nnml-nov-file-name))
+	   (nnmail-group-pathname group nnml-directory nnml-nov-file-name))
       (erase-buffer)
       (when (and (not incrementalp)
 		 (file-exists-p nnml-nov-buffer-file-name))
@@ -908,7 +858,7 @@ nnml-generate-active-info
   ;; Update the active info for this group.
   (let ((group (directory-file-name dir))
 	entry last)
-    (setq group (nnheader-file-to-group (nnml-encoded-group-name group)
+    (setq group (nnheader-file-to-group group
 					nnml-directory)
 	  entry (assoc group nnml-group-alist)
 	  last (or (caadr entry) 0)
diff --git a/lisp/gnus/nnrss.el b/lisp/gnus/nnrss.el
index 0bfecb28e0..f4a387b2a4 100644
--- a/lisp/gnus/nnrss.el
+++ b/lisp/gnus/nnrss.el
@@ -367,7 +367,7 @@ nnrss-retrieve-groups
   (with-current-buffer nntp-server-buffer
     (erase-buffer)
     (dolist (group groups)
-      (let ((elem (assoc-string (gnus-group-decoded-name group) nnrss-server-data)))
+      (let ((elem (assoc-string group nnrss-server-data)))
 	(insert (format "%S %s 1 y\n" group (or (cadr elem) 0)))))
     'active))
 
-- 
2.22.0


--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 23 Jul 2019 23:52:47 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jul 23 19:52:47 2019
Received: from localhost ([127.0.0.1]:35817 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hq4aN-0000Ns-1F
	for submit <at> debbugs.gnu.org; Tue, 23 Jul 2019 19:52:47 -0400
Received: from ericabrahamsen.net ([52.70.2.18]:55500
 helo=mail.ericabrahamsen.net)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eric@HIDDEN>) id 1hq4aK-0000Ne-Py
 for 35383 <at> debbugs.gnu.org; Tue, 23 Jul 2019 19:52:45 -0400
Received: from localhost (c-73-254-86-141.hsd1.wa.comcast.net [73.254.86.141])
 (Authenticated sender: eric@HIDDEN)
 by mail.ericabrahamsen.net (Postfix) with ESMTPSA id B6D7EFA09D
 for <35383 <at> debbugs.gnu.org>; Tue, 23 Jul 2019 23:52:38 +0000 (UTC)
From: Eric Abrahamsen <eric@HIDDEN>
To: 35383 <at> debbugs.gnu.org
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN>
 <87lfy0bv9e.fsf@HIDDEN> <87sgs8z9zv.fsf@HIDDEN>
 <874l4ob2qm.fsf@HIDDEN> <87zhmdthjx.fsf@HIDDEN>
 <87imt18d9n.fsf@HIDDEN>
 <trinity-810a86e0-9451-49b2-817f-5420e9ce1adb-1561035623205@3c-app-mailcom-bs02>
 <874l4k5ifs.fsf@HIDDEN> <877e9g9j48.fsf@HIDDEN>
 <87a7ec3w4j.fsf@HIDDEN>
 <87o92qzmc5.fsf@HIDDEN> <87y31t8yso.fsf@HIDDEN>
 <87v9wxy53y.fsf@HIDDEN> <87r27klhpv.fsf@HIDDEN>
 <87o925z0h2.fsf@HIDDEN> <87k1cscns2.fsf@HIDDEN>
Date: Tue, 23 Jul 2019 16:52:37 -0700
In-Reply-To: <87k1cscns2.fsf@HIDDEN> (Deus Max's message of "Mon, 08
 Jul 2019 22:46:37 +0300")
Message-ID: <87r26gjol6.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 35383
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

By god, I think this branch (scratch/gnus-decoded) is done. I've been
running it for several weeks, have added some additional fixes, and have
merged a few times from master to keep up with development.

I just rebased onto master (it went better than I expected, the
merge-from-master commits were ignored), so now I have a local branch
with 19 commits in it, some of which are just WIP commits, others small
fixes and tweaks to previous commits in the branch.

If anyone wants to see this again I can push a new branch (say
feature/gnus-decoded) with either squashed or unsquashed commits, or I
can post patches here.

I'm assuming the final branch should be squashed. One thing about the
code here is that it preserves backwards compatibility with Gnus' files
(newsrc.eld, the registry persistence file if that's used, and the agent
category files), keeping non-ascii group names written in an encoded
format. My idea was that, as Emacs 27 is released, we could bump the
Gnus version a point, which would trigger `gnus-convert-old-newsrc' (or
maybe this would be a clean?), and the permanent decoding could be done
there -- the user would at least be warned that their files might not be
backwards compatible.

Anyway, if anyone has any opinions on any of this, let me know!

Eric




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 8 Jul 2019 19:47:04 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jul 08 15:47:04 2019
Received: from localhost ([127.0.0.1]:59591 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hkZbL-0003wI-WA
	for submit <at> debbugs.gnu.org; Mon, 08 Jul 2019 15:47:04 -0400
Received: from mout.gmx.net ([212.227.17.20]:34655)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <deusmax@HIDDEN>) id 1hkZbJ-0003vd-US
 for 35383 <at> debbugs.gnu.org; Mon, 08 Jul 2019 15:47:02 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1562615201;
 bh=d9CMH0KYbRqfB1dD2ur58Cw4cIn+1D/LCFrnQZS6Zvc=;
 h=X-UI-Sender-Class:From:To:Cc:Subject:References:Date:In-Reply-To;
 b=cgfHbuZyVGsc7SmAFvvhiExix8g+4DEWGu2K/qusfmg+fp+CirtYlhyjBwucbCMEP
 IVMjRdg2F3bTAzszYg8hYNPjvbkYL0LxZ7iIruwsK+VXtv8x5b8Mb2mpP+hipAIfkf
 A8agnOO9ds3sHdiwjuLkflkiF+afoKkDe0Y2r8HE=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from dellcorei5dias ([46.177.203.249]) by mail.gmx.com (mrgmx101
 [212.227.17.174]) with ESMTPSA (Nemesis) id 0Lp7d2-1iP6wv26Im-00exij; Mon, 08
 Jul 2019 21:46:41 +0200
From: Deus Max <deusmax@HIDDEN>
To: Eric Abrahamsen <eric@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN>
 <87lfy0bv9e.fsf@HIDDEN> <87sgs8z9zv.fsf@HIDDEN>
 <874l4ob2qm.fsf@HIDDEN> <87zhmdthjx.fsf@HIDDEN>
 <87imt18d9n.fsf@HIDDEN>
 <trinity-810a86e0-9451-49b2-817f-5420e9ce1adb-1561035623205@3c-app-mailcom-bs02>
 <874l4k5ifs.fsf@HIDDEN> <877e9g9j48.fsf@HIDDEN>
 <87a7ec3w4j.fsf@HIDDEN>
 <87o92qzmc5.fsf@HIDDEN> <87y31t8yso.fsf@HIDDEN>
 <87v9wxy53y.fsf@HIDDEN> <87r27klhpv.fsf@HIDDEN>
 <87o925z0h2.fsf@HIDDEN>
Date: Mon, 08 Jul 2019 22:46:37 +0300
In-Reply-To: <87o925z0h2.fsf@HIDDEN> (Eric Abrahamsen's message of
 "Sun, 07 Jul 2019 20:09:13 -0700")
Message-ID: <87k1cscns2.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Provags-ID: V03:K1:EzOH7C+WNKL0R0O1taEd2P8Gf7iDTeVJsx5Tdo4D6vywRrCKNMt
 RnqAbc2+RDEi6c6IQfBq8+aFexd0C6y001Yxyv2e6cii1bQw/FBeQbS9aQaa8kFQUnj4VwC
 34XFeRU7DgWLxhSJxjdaBZmTHbwRPghtI2M9LyGbfHuHSXoYOnnEI7PijAIpfiSyBvomX+C
 qziPIyS5+qTB6r+XrOWXg==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:A4L2q0SfRs4=:okDlDnt0ZvFXCaSmskeb6x
 Jp3wwcPPSL6pfvz1L1SWUZsigGS45R7yp9ofI+jdiVUz4dRb/9C3P/FDseoEzw7ICaQ71b3Cr
 DVn8IJkj7W66P6sLPGUGjBDT5arJMm2QjZdi0ZZLszFOdch1qGlOhamlqX3AGLJovcXxxBUEy
 ESpvYifWPDos5iCfNzbnwq3OSv5WxovMu0fKczeucHElOnq80Ee55kh5aqoB2vTRYmTucdrVq
 Jy8TrOXiV7PVkRvTnxQWuThGjoHiedcmuRbo8ykuPSsKrgZY1/seQxextmgC1jl6Rgn+ZZEZn
 f1zed9+fWGaJd5gTnzXkWWvn0S8T5Le7AX1+MiwnvUsQLnrsdruARro8H5VNYGDC4gaSXVPvh
 imIBve6E57HXtrqbuUn0kDl/B5tk04CNM2T6X+TG2vp/r4qvSnpWTRVKSasu8AemIpuAs5BxW
 ci1rBQoAc+l9ji7fYuX1hKgFOuW2mUVmhHIo6IwC1a8C8nLwEjOGwdCsDgzYDi0zEXbjMhg0m
 XM9QQQLnX5UbouqH3OvS5bWWl3U9ViEUeghYXb4ja1h0nbxKQaeVWvjNp0Pfz/Ox7h3MsVJsV
 zmyyaYHkykVuCcE7zdhAkToWXDNP6onfoBE5f1vQevb/MXen8Huy4RAfuwQOxol+569rc4JMl
 ok202Z/U/BseoPuJQzVqfjuyqi+fZ6HnVr6GASKN8uRxKlEC7jVhwl0YkIYNNMmmuhvgnA8pZ
 +0171V+gnVDp7QcxdsVtWUOq54VuOwvP1fQpdjdzfBby5uPPxeaaGjJPn/EuscMkTjXQqe5cF
 MsKfQSLXUNdVIxIM+4ueESN7f4wkEPynDh8vUvc4arI9gKNmqq2a/Bsdm/cDPRtaMx8scnhRg
 RzJiAkKUzYPFxZOLB95YderqWkfObHeFumygB3ikhS6J33GUW1kmFNxm+OKzMfbBN97kPwMXl
 hw5fKxCZyBOKaPzCw0H5DoqWEUqJOBrTB8Qx5nBD6GvuyL3gcH2AAtzFaCrJttlTL+qjl/R3P
 HWggNWDEDTnto8AYzQDto8ghyJ1+QhMCCGmmdG3/PJFcacLtQqSfu6El7eCVIMBl/perqeCDq
 KJp90vci/m0sYU=
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 35383
Cc: 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

On Sun, Jul 07 2019, Eric Abrahamsen wrote:

>
> Sorry for my slow response, and thank you for the testing! This was very
> thorough, and I will definitely be coming back to you for testing in the
> future :)
>
> So far as I know, all the behaviors you've noted here are bugs, but I've
> also been able to reproduce the bugs in the Emacs 26 branch. Which
> doesn't mean I won't fix them -- it would be a pleasure to fix bugs that
> I didn't cause myself, for once -- but I might hold off on them until
> this branch has landed. One thing at a time...
>
> Thanks again!
>
> Eric

Sure, happy to help.
For me Gnus is one of Emacs' underappreciated gems.

Let me know when its done.











Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 8 Jul 2019 03:09:25 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jul 07 23:09:25 2019
Received: from localhost ([127.0.0.1]:57630 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hkK1s-00021t-M4
	for submit <at> debbugs.gnu.org; Sun, 07 Jul 2019 23:09:24 -0400
Received: from ericabrahamsen.net ([52.70.2.18]:42016
 helo=mail.ericabrahamsen.net)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eric@HIDDEN>) id 1hkK1q-00021e-8D
 for 35383 <at> debbugs.gnu.org; Sun, 07 Jul 2019 23:09:23 -0400
Received: from localhost (c-73-254-86-141.hsd1.wa.comcast.net [73.254.86.141])
 (Authenticated sender: eric@HIDDEN)
 by mail.ericabrahamsen.net (Postfix) with ESMTPSA id BB50DFA01E;
 Mon,  8 Jul 2019 03:09:15 +0000 (UTC)
From: Eric Abrahamsen <eric@HIDDEN>
To: Deus Max <deusmax@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN>
 <87lfy0bv9e.fsf@HIDDEN> <87sgs8z9zv.fsf@HIDDEN>
 <874l4ob2qm.fsf@HIDDEN> <87zhmdthjx.fsf@HIDDEN>
 <87imt18d9n.fsf@HIDDEN>
 <trinity-810a86e0-9451-49b2-817f-5420e9ce1adb-1561035623205@3c-app-mailcom-bs02>
 <874l4k5ifs.fsf@HIDDEN> <877e9g9j48.fsf@HIDDEN>
 <87a7ec3w4j.fsf@HIDDEN>
 <87o92qzmc5.fsf@HIDDEN> <87y31t8yso.fsf@HIDDEN>
 <87v9wxy53y.fsf@HIDDEN> <87r27klhpv.fsf@HIDDEN>
Date: Sun, 07 Jul 2019 20:09:13 -0700
In-Reply-To: <87r27klhpv.fsf@HIDDEN> (Deus Max's message of "Sun, 23
 Jun 2019 13:27:24 +0300")
Message-ID: <87o925z0h2.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 35383
Cc: 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)


On 06/23/19 13:27 PM, Deus Max wrote:
> On Sat, Jun 22 2019, Eric Abrahamsen wrote:
>
>>>> All right, I've pushed these fixes and a bunch of other ones to
>>>> scratch/gnus-decoded. If you're still interested in testing, you can
>>>> pull in that branch, then either run "make bootstrap" or delete all the
>>>> *elc files under lisp/gnus and run a regular "make", then try again.
>>>>
>>>> Unfortunately this led to so many new tweaks and fixes that I'm going =
to
>>>> restart the clock on dogfooding and testing before it's ready to push.
>>>>
>>>> Eric
>>>
>>> dogfooding ??
>>
>> Ha -- "eating your own dogfood", ie I'll spend a week or two using this
>> branch as my daily driver, and see if anything explodes. I'm not sure
>> who started using that term, and why it has to be dog food, in particula=
r.
>
> :-)  I like that. Funny !
>
> Pulled in and bootstrapped. Here's what I found:
>
> 1. From a Summary Buffer used "B m" to move articles to a new Greek
>    group.=20
>    - The confirmation of this action disappears to the message
>      "nnimap read...".=20
>      : No such group: nnimap+AIA:=CE=96=CF=89=CE=B7=CE=95=CE=BD=CE=A4=CE=
=AC=CF=86=CE=BF.  Create it? (y or n) y
>      : Moving to nnimap+AIA:=CE=96=CF=89=CE=B7=CE=95=CE=BD=CE=A4=CE=AC=CF=
=86=CE=BF: (27666)...
>      : nnimap read 0k from imap-mail.outlook.com (initial sync of 1
>      :   group; please wait)
>=20=20=20=20
> 2. The article count for the encoded group is +1 the actual number.
>
> 3. In the Group buffer typing "j" (gnus-group-jump-to-group), creates
>    the buffer with a "K" and is not usable.  ex:
>    :  K     *: Dias/Crappy=CE=9A=CF=8E=CE=BB=CE=BF=CF=82
>
>    From the *Messages* buffer (No unknown folder ??):
>    : Retrieving newsgroup: Dias/Crappy=CE=9A=CF=8E=CE=BB=CE=BF=CF=82...
>    : gnus-select-newsgroup: Couldn=E2=80=99t activate group Dias/Crappy=
=CE=9A=CF=8E=CE=BB=CE=BF=CF=82:=20
>    :   NO unknown folder
>
> 4. Further, when trying to move articles to above group:
>    : No such group: Dias/Crappy=CE=9A=CF=8E=CE=BB=CE=BF=CF=82.  Create it=
? (y or n) n
>    : gnus-read-move-group-name: No such group: Dias/Crappy=CE=9A=CF=8E=CE=
=BB=CE=BF=CF=82

Sorry for my slow response, and thank you for the testing! This was very
thorough, and I will definitely be coming back to you for testing in the
future :)

So far as I know, all the behaviors you've noted here are bugs, but I've
also been able to reproduce the bugs in the Emacs 26 branch. Which
doesn't mean I won't fix them -- it would be a pleasure to fix bugs that
I didn't cause myself, for once -- but I might hold off on them until
this branch has landed. One thing at a time...

Thanks again!

Eric




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 23 Jun 2019 10:40:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jun 23 06:40:49 2019
Received: from localhost ([127.0.0.1]:52908 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hezvU-0001rT-Qn
	for submit <at> debbugs.gnu.org; Sun, 23 Jun 2019 06:40:49 -0400
Received: from mout.gmx.net ([212.227.17.22]:40773)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <deusmax@HIDDEN>) id 1hezvS-0001rB-31
 for 35383 <at> debbugs.gnu.org; Sun, 23 Jun 2019 06:40:46 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1561286437;
 bh=xanPl1DyYzCVG3DOwFshkpNJE0azUB5OJvzbXwbBnLM=;
 h=X-UI-Sender-Class:From:To:Cc:Subject:References:Date:In-Reply-To;
 b=QAMkhLdNOPKe0UAWuigWKCrSvyJSjG65wiBn7BUe9X3M20PPtnBB+Yc2eVuqzsy54
 xaC01L2/uJtmbuCPyrVckZHJgviFmXqnBOjhyuEDYR+HPlhBgQiEo+fDvK1cH/UsGY
 3wD/n6wMw3ZnrDt9N1W/mNLM6o8gmUneRTuLczss=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from dellcorei5dias ([89.44.216.23]) by mail.gmx.com (mrgmx101
 [212.227.17.174]) with ESMTPSA (Nemesis) id 0M5Z5A-1iY3HF37O4-00xdS8; Sun, 23
 Jun 2019 12:27:30 +0200
From: Deus Max <deusmax@HIDDEN>
To: Eric Abrahamsen <eric@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN>
 <87lfy0bv9e.fsf@HIDDEN> <87sgs8z9zv.fsf@HIDDEN>
 <874l4ob2qm.fsf@HIDDEN> <87zhmdthjx.fsf@HIDDEN>
 <87imt18d9n.fsf@HIDDEN>
 <trinity-810a86e0-9451-49b2-817f-5420e9ce1adb-1561035623205@3c-app-mailcom-bs02>
 <874l4k5ifs.fsf@HIDDEN> <877e9g9j48.fsf@HIDDEN>
 <87a7ec3w4j.fsf@HIDDEN>
 <87o92qzmc5.fsf@HIDDEN> <87y31t8yso.fsf@HIDDEN>
 <87v9wxy53y.fsf@HIDDEN>
Date: Sun, 23 Jun 2019 13:27:24 +0300
In-Reply-To: <87v9wxy53y.fsf@HIDDEN> (Eric Abrahamsen's message of
 "Sat, 22 Jun 2019 09:09:05 -0700")
Message-ID: <87r27klhpv.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Provags-ID: V03:K1:mk+u404nQcX0RuZJ2qqCmFW2IQrAjadD6UkFTeezg5jD6h0ANbG
 rLms0gjB9McVOqBzGQ9V6MCZlmRBqMtKhGtnyPEPNNtfs6k1NQShIlMp2wtVsEXHYyRt0RM
 8YwrcljlIZxGpQq6mBwh6BJksxNvPK7ZFwGknIKEmQSBnmpRSsGuS1z51kiAD1TtbDLs6Es
 9isWxzc4ak1vB1p09YsqQ==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:s+Ko32n5Dxs=:DTXh1s2OC2XeKAY+9ZRbPh
 WRMn29MXZ7opnT/SqZ3M3Ky48goSxxy1N/SeQ0sr6KUwgKkqJMNYyGLB8d3CaSbtS3gFNge9V
 hELKTKDHdZ0Ei/2lg/J7MMl5dYgO2c6pklzjRl8wwAK0z1b6TyVExtNE1Zp/7LMFS45MMDNkU
 0ewuoJRyH+efVd7uVSEQTpBZyNcEwZ6Y/ZdW8tjKcdVSjknFx7a3n6PeB4TffiSRRJMcYtQve
 7n4vCRzeL8Bpd30jcGv+Xk7TBrYGTxXRWvNxgaBPoMJ5ihb18w8qu8JGmMn5Y6CgXbPwrxeSO
 ujWtKQsW/cRDaMEJmmblWAIDqIO9hHfhx1wipB1BC+nj2nR9M1auYsem+sCOaVViPz0edufT2
 X8oFMLJj9gtaogecmoPviAhyITamBFoQN+78cPDbtY5z+4ZHaS6hVQONwuIKbublYkttNwcgh
 etrL4YORMcnT8vEsGw8ILgmVf0fae2Zm4nOtbaT5NXkbbyTwsJPqAfvgQv6dsXf/68cQbhvrD
 H/XHAL0JPfzVmgDmqbnJ5IXG3FqWUiuXZWSGdFCw7CYzhg3iS4UwT+QUrhx8oS7RmSQnpgOuW
 0eupPuXBb2D88s+HyO3PJSTb7pL5NtMZzxqvqesJkEEcCzD7MGjoLfDufM86pUKDoBEOeh86t
 4M+7b+mk30CHZEc1mVVQGoUY77ERlN2eHyD9zDcpxRLzFcCcQgfbvDBymCF7GWBPC4KSO77Jb
 grPVZadSiPSgkuAsdabTWNZqkALvxKooDV8p57oQFtOE0p4mDOnMusCIt4jmLomV/6rOrDLNZ
 IEOI2E9+UH0iC5kE9ZYxNkFDV2OYy8RJpFbgIlGZhq0Zz65k9u4scB+yy8+apUrhIbWRHcB6E
 sV42bOdpLGEm4cF7oSjxzrid+EDy8XUpn6lbothde0+AI8oIxXXYadQUaXVe7vVcg22BKE1wa
 rDfhY+q72Vd21NwaVyOH6DdRYwPH9+SdBjK98q7ftg5O7cQAmGqEg
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 35383
Cc: 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

On Sat, Jun 22 2019, Eric Abrahamsen wrote:

>>> All right, I've pushed these fixes and a bunch of other ones to
>>> scratch/gnus-decoded. If you're still interested in testing, you can
>>> pull in that branch, then either run "make bootstrap" or delete all the
>>> *elc files under lisp/gnus and run a regular "make", then try again.
>>>
>>> Unfortunately this led to so many new tweaks and fixes that I'm going to
>>> restart the clock on dogfooding and testing before it's ready to push.
>>>
>>> Eric
>>
>> dogfooding ??
>
> Ha -- "eating your own dogfood", ie I'll spend a week or two using this
> branch as my daily driver, and see if anything explodes. I'm not sure
> who started using that term, and why it has to be dog food, in particular.

:-)  I like that. Funny !

Pulled in and bootstrapped. Here's what I found:

1. From a Summary Buffer used "B m" to move articles to a new Greek
   group.=20
   - The confirmation of this action disappears to the message
     "nnimap read...".=20
     : No such group: nnimap+AIA:=CE=96=CF=89=CE=B7=CE=95=CE=BD=CE=A4=CE=AC=
=CF=86=CE=BF.  Create it? (y or n) y
     : Moving to nnimap+AIA:=CE=96=CF=89=CE=B7=CE=95=CE=BD=CE=A4=CE=AC=CF=
=86=CE=BF: (27666)...
     : nnimap read 0k from imap-mail.outlook.com (initial sync of 1
     :   group; please wait)
=20=20=20
2. The article count for the encoded group is +1 the actual number.

3. In the Group buffer typing "j" (gnus-group-jump-to-group), creates
   the buffer with a "K" and is not usable.  ex:
   :  K     *: Dias/Crappy=CE=9A=CF=8E=CE=BB=CE=BF=CF=82

   From the *Messages* buffer (No unknown folder ??):
   : Retrieving newsgroup: Dias/Crappy=CE=9A=CF=8E=CE=BB=CE=BF=CF=82...
   : gnus-select-newsgroup: Couldn=E2=80=99t activate group Dias/Crappy=CE=
=9A=CF=8E=CE=BB=CE=BF=CF=82:=20
   :   NO unknown folder

4. Further, when trying to move articles to above group:
   : No such group: Dias/Crappy=CE=9A=CF=8E=CE=BB=CE=BF=CF=82.  Create it? =
(y or n) n
   : gnus-read-move-group-name: No such group: Dias/Crappy=CE=9A=CF=8E=CE=
=BB=CE=BF=CF=82

Dias






Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 22 Jun 2019 16:09:22 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jun 22 12:09:22 2019
Received: from localhost ([127.0.0.1]:52447 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1heiZs-0005G0-6J
	for submit <at> debbugs.gnu.org; Sat, 22 Jun 2019 12:09:22 -0400
Received: from ericabrahamsen.net ([52.70.2.18]:37786
 helo=mail.ericabrahamsen.net)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eric@HIDDEN>) id 1heiZq-0005Fh-2a
 for 35383 <at> debbugs.gnu.org; Sat, 22 Jun 2019 12:09:18 -0400
Received: from localhost (unknown [172.92.212.120])
 (Authenticated sender: eric@HIDDEN)
 by mail.ericabrahamsen.net (Postfix) with ESMTPSA id CA6B4FA648;
 Sat, 22 Jun 2019 16:09:11 +0000 (UTC)
From: Eric Abrahamsen <eric@HIDDEN>
To: Deus Max <deusmax@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN>
 <87lfy0bv9e.fsf@HIDDEN> <87sgs8z9zv.fsf@HIDDEN>
 <874l4ob2qm.fsf@HIDDEN> <87zhmdthjx.fsf@HIDDEN>
 <87imt18d9n.fsf@HIDDEN>
 <trinity-810a86e0-9451-49b2-817f-5420e9ce1adb-1561035623205@3c-app-mailcom-bs02>
 <874l4k5ifs.fsf@HIDDEN> <877e9g9j48.fsf@HIDDEN>
 <87a7ec3w4j.fsf@HIDDEN>
 <87o92qzmc5.fsf@HIDDEN> <87y31t8yso.fsf@HIDDEN>
Date: Sat, 22 Jun 2019 09:09:05 -0700
In-Reply-To: <87y31t8yso.fsf@HIDDEN> (Deus Max's message of "Sat, 22
 Jun 2019 17:44:39 +0300")
Message-ID: <87v9wxy53y.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 35383
Cc: 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Deus Max <deusmax@HIDDEN> writes:

> On Fri, Jun 21 2019, Eric Abrahamsen wrote:
>
>> Eric Abrahamsen <eric@HIDDEN> writes:
>>
>>> On 06/20/19 22:01 PM, Deus Max wrote:
>>>> On Thu, Jun 20 2019, Eric Abrahamsen wrote:
>>>>
>>>>> "Deus Max" <deusmax@HIDDEN> writes:
>>>>>
>>>>>>=20=20=20
>>>>>>> : gnus-read-move-group-name: Couldnt create group Dias/=EF=BD=A3=EF=
=BD=BA=EF=BF=BD=EF=BD=BB=EF=BD=B9=EF=BF=BD=EF=BD=B9=EF=BD=B1=E5=93=A9=EF=BD=
=B7
>>>>>>
>>>>>> Oh bother. Once again an area I was quite sure I've tested. Can you
>>>>>> tell
>>>>>> me which backend you're trying to create the group on?
>>>>>>
>>>>>> Thank you very much for testing!
>>>>>>
>>>>>> (And don't worry about sending the exact mis-encoded string, it's
>>>>>> enough
>>>>>> to know it's mis-encoded.)
>>>>>>=20
>>>>>>=20
>>>>>>=20
>>>>>> Using the nnimap backend
>>>>>
>>>>> Found the bug, thanks! I have a few other patches I'm working on for
>>>>> this branch, once those are done I'll push them all together. I
>>>>> appreciate the help.
>>>>>
>>>>> Eric
>>>>
>>>>
>>>> Great !! Glad to help.
>>>>
>>>> Here's another bug:
>>>>
>>>> using (G r) "Rename group" works fine for an English group, but fails
>>>> for other lang. characters (Greek as my test case):
>>>>
>>>> Here's a few samples:
>>>>
>>>>   GreeK: (fails)
>>>>       Renaming group =CE=A3=CE=BA=CF=8D=CE=BB=CE=BF=CF=82 to =CE=A3=CE=
=BA=CF=8D=CE=BB=CE=BF=CF=82=CE=93=CE=B1=CF=84=CE=B1...
>>>>       Couldn=E2=80=99t rename group =CE=A3=CE=BA=CF=8D=CE=BB=CE=BF=CF=
=82 to =CE=A3=CE=BA=CF=8D=CE=BB=CE=BF=CF=82=CE=93=CE=B1=CF=84=CE=B1
>>>>
>>>>   English: (OK)
>>>>      Renaming group Dias/MyLifeAsDog to Dias/MyLifeAsRat...
>>>>      Killed group Dias/MyLifeAsDog
>>>>      Renaming group Dias/MyLifeAsDog to Dias/MyLifeAsRat...done
>>>>
>>>>
>>>> Also multi-language names fail too:
>>>>
>>>>   English+Greek:
>>>>      Renaming group Dias/MyLifeAsRat to Dias/MyLifeAs=CE=A6=CF=89=CF=
=82...
>>>>      Couldn=E2=80=99t rename group Dias/MyLifeAsRat to Dias/MyLifeAs=
=CE=A6=CF=89=CF=82
>>>
>>> Okay, got that one too...
>>
>> All right, I've pushed these fixes and a bunch of other ones to
>> scratch/gnus-decoded. If you're still interested in testing, you can
>> pull in that branch, then either run "make bootstrap" or delete all the
>> *elc files under lisp/gnus and run a regular "make", then try again.
>>
>> Unfortunately this led to so many new tweaks and fixes that I'm going to
>> restart the clock on dogfooding and testing before it's ready to push.
>>
>> Eric
>
> dogfooding ??

Ha -- "eating your own dogfood", ie I'll spend a week or two using this
branch as my daily driver, and see if anything explodes. I'm not sure
who started using that term, and why it has to be dog food, in particular.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 22 Jun 2019 14:45:10 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jun 22 10:45:09 2019
Received: from localhost ([127.0.0.1]:52390 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hehGP-0002qj-L8
	for submit <at> debbugs.gnu.org; Sat, 22 Jun 2019 10:45:09 -0400
Received: from mout.gmx.net ([212.227.17.22]:59185)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <deusmax@HIDDEN>) id 1hehGM-0002pw-Hd
 for 35383 <at> debbugs.gnu.org; Sat, 22 Jun 2019 10:45:07 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1561214686;
 bh=7C70TE6BxKZ1LBeDU4ann+Qo5sFfGJpUdEsmcCEjfvI=;
 h=X-UI-Sender-Class:From:To:Cc:Subject:References:Date:In-Reply-To;
 b=DJRDTn+groZgAeMdQZIXWuvX+jipkgkqMZKZHuI1h0fxUW0HfoibReDwFXMpH1hqF
 Jdp686CkfSERIVOLuWSnsQn3I6bQW9I3EfJSMlH9sriKcPK6spUlrph7gKNoEEzk97
 mJl1A8+yF6v31xGULvyZ0QvM9vLvZOQ81fB8GTKM=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from dellcorei5dias ([89.44.216.23]) by mail.gmx.com (mrgmx105
 [212.227.17.174]) with ESMTPSA (Nemesis) id 1MgNct-1iEpDV15ln-00hszW; Sat, 22
 Jun 2019 16:44:46 +0200
From: Deus Max <deusmax@HIDDEN>
To: Eric Abrahamsen <eric@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN>
 <87lfy0bv9e.fsf@HIDDEN> <87sgs8z9zv.fsf@HIDDEN>
 <874l4ob2qm.fsf@HIDDEN> <87zhmdthjx.fsf@HIDDEN>
 <87imt18d9n.fsf@HIDDEN>
 <trinity-810a86e0-9451-49b2-817f-5420e9ce1adb-1561035623205@3c-app-mailcom-bs02>
 <874l4k5ifs.fsf@HIDDEN> <877e9g9j48.fsf@HIDDEN>
 <87a7ec3w4j.fsf@HIDDEN>
 <87o92qzmc5.fsf@HIDDEN>
Date: Sat, 22 Jun 2019 17:44:39 +0300
In-Reply-To: <87o92qzmc5.fsf@HIDDEN> (Eric Abrahamsen's message of
 "Fri, 21 Jun 2019 13:59:22 -0700")
Message-ID: <87y31t8yso.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Provags-ID: V03:K1:0G+eCoP5VYknMTqRybwGpSGjHSNhamE/huiC8l+WmcDVFvsYsuk
 eECEhxxA4Rsf6hsy0MEKWta6o6lFyr0WN8t1zcjGnJ/p9QY2O9hzRUCXrRw/LFuwum/srNU
 R2A9XQ0jZ4oDt4I0FFkGNEs5Km59dfeUa3QMAJzMQ2blT2lIJcaMzLIKgR3hHOgmlpTcbwA
 mWVW3joUw9Eo6oaBR1zpA==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:yqRCJBPrkuw=:7Xd2qtt73BoGtB5XNVytGn
 Ux4VpGjvgfTCXdmMbXhXqDfjGkupmVuSTps4vsud2idlHmfr7K2Ta7XZY5AjfRPzT0X6CYUrI
 i14wo/QimxcFek7jbSmiUw1TLPTQtThOhhq0+64TQYYq4r3Rig2KPl4xzuyulsz5FK09gnkv4
 +WiZfCw42tcvRczWQbdEOPGSpM9ABqvmD8MMp4dmK1/kzsCK7i7ves2QCUgl0U0e0C+xCqlQp
 lwkdvLoFT+h+E9+l87BBITa5bGrBKj9otkTRiXoEdxkjjWIlPRBuHsus1+jKCX8WdihM4lXfT
 /f9yOnFGtR19ENfTbHVK0EUNThuclkBu1Qztqhsuarw5+YUNKeJuR9r/ymIj87F0Br4Dmdjcm
 rWvHyN0PGgRqnyl11VX80xZgQb3ofmamqDZfdAsO/h32NObwiOCNc1HZMoTzQkafUjdnIOG5p
 JuRtaoH0iXs4MNgpXETtX0vmKTJuSV031KTdZuXf6RJck7qUzEpcgyFqEUE53c36/e5ZwCV4b
 zs0ThgEoNKTPh6mMQ9juE7aemtlYsDE3fq1er2gi9HGEaORGF9VpYVE2urkKogWBvzhf3EaUs
 MokhtjTqTMxF4HGgc1KuItHreQdUTUUgmFw4NlYvJI/rul3Tf9/rQIFnmIxcSXEnweBitnifo
 GB6RsKXb8Mj4CPYUMTNTBb5x6ekot6aBP+wCssVkAQATaLdpltAIDcO5G4J8MOaBjrAmD+pCA
 h7ZLTzoWGXoqCOn6lEYWfagxrzklLTdJ8ynFlLRcXeXPcc91emK5aTcpunhdxJkPmmyK4qQHJ
 2BPwjUSFmvcVjlocIOlb1JdUa3AjJRqpHzR3Z2p35r+aNTbhxsKg9qD6iGeW1amOx6TbI7nLH
 ivqjTS5YDra5u3KCMLrdBdqHSlCClfJwE9Qaw1/iFsHraz0R0iqpuCfWHVdkO8EMj3RjhBXEm
 v0pHiBDAKte2KBXHVLN/QQv3Hj7IJcdvbmEIC75Zi9CZN5VOtYzuM
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 35383
Cc: 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

On Fri, Jun 21 2019, Eric Abrahamsen wrote:

> Eric Abrahamsen <eric@HIDDEN> writes:
>
>> On 06/20/19 22:01 PM, Deus Max wrote:
>>> On Thu, Jun 20 2019, Eric Abrahamsen wrote:
>>>
>>>> "Deus Max" <deusmax@HIDDEN> writes:
>>>>
>>>>>=20=20=20
>>>>>> : gnus-read-move-group-name: Couldnt create group Dias/=EF=BD=A3=EF=
=BD=BA=EF=BF=BD=EF=BD=BB=EF=BD=B9=EF=BF=BD=EF=BD=B9=EF=BD=B1=E5=93=A9=EF=BD=
=B7
>>>>>
>>>>> Oh bother. Once again an area I was quite sure I've tested. Can you
>>>>> tell
>>>>> me which backend you're trying to create the group on?
>>>>>
>>>>> Thank you very much for testing!
>>>>>
>>>>> (And don't worry about sending the exact mis-encoded string, it's
>>>>> enough
>>>>> to know it's mis-encoded.)
>>>>>=20
>>>>>=20
>>>>>=20
>>>>> Using the nnimap backend
>>>>
>>>> Found the bug, thanks! I have a few other patches I'm working on for
>>>> this branch, once those are done I'll push them all together. I
>>>> appreciate the help.
>>>>
>>>> Eric
>>>
>>>
>>> Great !! Glad to help.
>>>
>>> Here's another bug:
>>>
>>> using (G r) "Rename group" works fine for an English group, but fails
>>> for other lang. characters (Greek as my test case):
>>>
>>> Here's a few samples:
>>>
>>>   GreeK: (fails)
>>>       Renaming group =CE=A3=CE=BA=CF=8D=CE=BB=CE=BF=CF=82 to =CE=A3=CE=
=BA=CF=8D=CE=BB=CE=BF=CF=82=CE=93=CE=B1=CF=84=CE=B1...
>>>       Couldn=E2=80=99t rename group =CE=A3=CE=BA=CF=8D=CE=BB=CE=BF=CF=
=82 to =CE=A3=CE=BA=CF=8D=CE=BB=CE=BF=CF=82=CE=93=CE=B1=CF=84=CE=B1
>>>
>>>   English: (OK)
>>>      Renaming group Dias/MyLifeAsDog to Dias/MyLifeAsRat...
>>>      Killed group Dias/MyLifeAsDog
>>>      Renaming group Dias/MyLifeAsDog to Dias/MyLifeAsRat...done
>>>
>>>
>>> Also multi-language names fail too:
>>>
>>>   English+Greek:
>>>      Renaming group Dias/MyLifeAsRat to Dias/MyLifeAs=CE=A6=CF=89=CF=82=
...
>>>      Couldn=E2=80=99t rename group Dias/MyLifeAsRat to Dias/MyLifeAs=CE=
=A6=CF=89=CF=82
>>
>> Okay, got that one too...
>
> All right, I've pushed these fixes and a bunch of other ones to
> scratch/gnus-decoded. If you're still interested in testing, you can
> pull in that branch, then either run "make bootstrap" or delete all the
> *elc files under lisp/gnus and run a regular "make", then try again.
>
> Unfortunately this led to so many new tweaks and fixes that I'm going to
> restart the clock on dogfooding and testing before it's ready to push.
>
> Eric

dogfooding ??




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 21 Jun 2019 20:59:43 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Jun 21 16:59:43 2019
Received: from localhost ([127.0.0.1]:50759 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1heQdK-0001lM-QB
	for submit <at> debbugs.gnu.org; Fri, 21 Jun 2019 16:59:43 -0400
Received: from ericabrahamsen.net ([52.70.2.18]:39958
 helo=mail.ericabrahamsen.net)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eric@HIDDEN>) id 1heQdI-0001l1-GP
 for 35383 <at> debbugs.gnu.org; Fri, 21 Jun 2019 16:59:41 -0400
Received: from localhost (unknown [172.92.212.120])
 (Authenticated sender: eric@HIDDEN)
 by mail.ericabrahamsen.net (Postfix) with ESMTPSA id 294C4FA42A;
 Fri, 21 Jun 2019 20:59:33 +0000 (UTC)
From: Eric Abrahamsen <eric@HIDDEN>
To: Deus Max <deusmax@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN>
 <87lfy0bv9e.fsf@HIDDEN> <87sgs8z9zv.fsf@HIDDEN>
 <874l4ob2qm.fsf@HIDDEN> <87zhmdthjx.fsf@HIDDEN>
 <87imt18d9n.fsf@HIDDEN>
 <trinity-810a86e0-9451-49b2-817f-5420e9ce1adb-1561035623205@3c-app-mailcom-bs02>
 <874l4k5ifs.fsf@HIDDEN> <877e9g9j48.fsf@HIDDEN>
 <87a7ec3w4j.fsf@HIDDEN>
Date: Fri, 21 Jun 2019 13:59:22 -0700
In-Reply-To: <87a7ec3w4j.fsf@HIDDEN> (Eric Abrahamsen's message of
 "Thu, 20 Jun 2019 12:16:44 -0700")
Message-ID: <87o92qzmc5.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 35383
Cc: 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Eric Abrahamsen <eric@HIDDEN> writes:

> On 06/20/19 22:01 PM, Deus Max wrote:
>> On Thu, Jun 20 2019, Eric Abrahamsen wrote:
>>
>>> "Deus Max" <deusmax@HIDDEN> writes:
>>>
>>>>=20=20=20
>>>>> : gnus-read-move-group-name: Couldnt create group Dias/=EF=BD=A3=EF=
=BD=BA=EF=BF=BD=EF=BD=BB=EF=BD=B9=EF=BF=BD=EF=BD=B9=EF=BD=B1=E5=93=A9=EF=BD=
=B7
>>>>
>>>> Oh bother. Once again an area I was quite sure I've tested. Can you
>>>> tell
>>>> me which backend you're trying to create the group on?
>>>>
>>>> Thank you very much for testing!
>>>>
>>>> (And don't worry about sending the exact mis-encoded string, it's
>>>> enough
>>>> to know it's mis-encoded.)
>>>>=20
>>>>=20
>>>>=20
>>>> Using the nnimap backend
>>>
>>> Found the bug, thanks! I have a few other patches I'm working on for
>>> this branch, once those are done I'll push them all together. I
>>> appreciate the help.
>>>
>>> Eric
>>
>>
>> Great !! Glad to help.
>>
>> Here's another bug:
>>
>> using (G r) "Rename group" works fine for an English group, but fails
>> for other lang. characters (Greek as my test case):
>>
>> Here's a few samples:
>>
>>   GreeK: (fails)
>>       Renaming group =CE=A3=CE=BA=CF=8D=CE=BB=CE=BF=CF=82 to =CE=A3=CE=
=BA=CF=8D=CE=BB=CE=BF=CF=82=CE=93=CE=B1=CF=84=CE=B1...
>>       Couldn=E2=80=99t rename group =CE=A3=CE=BA=CF=8D=CE=BB=CE=BF=CF=82=
 to =CE=A3=CE=BA=CF=8D=CE=BB=CE=BF=CF=82=CE=93=CE=B1=CF=84=CE=B1
>>
>>   English: (OK)
>>      Renaming group Dias/MyLifeAsDog to Dias/MyLifeAsRat...
>>      Killed group Dias/MyLifeAsDog
>>      Renaming group Dias/MyLifeAsDog to Dias/MyLifeAsRat...done
>>
>>
>> Also multi-language names fail too:
>>
>>   English+Greek:
>>      Renaming group Dias/MyLifeAsRat to Dias/MyLifeAs=CE=A6=CF=89=CF=82.=
..
>>      Couldn=E2=80=99t rename group Dias/MyLifeAsRat to Dias/MyLifeAs=CE=
=A6=CF=89=CF=82
>
> Okay, got that one too...

All right, I've pushed these fixes and a bunch of other ones to
scratch/gnus-decoded. If you're still interested in testing, you can
pull in that branch, then either run "make bootstrap" or delete all the
*elc files under lisp/gnus and run a regular "make", then try again.

Unfortunately this led to so many new tweaks and fixes that I'm going to
restart the clock on dogfooding and testing before it's ready to push.

Eric




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 20 Jun 2019 19:17:00 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jun 20 15:17:00 2019
Received: from localhost ([127.0.0.1]:49306 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1he2YM-0004gE-PI
	for submit <at> debbugs.gnu.org; Thu, 20 Jun 2019 15:17:00 -0400
Received: from ericabrahamsen.net ([52.70.2.18]:43974
 helo=mail.ericabrahamsen.net)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eric@HIDDEN>) id 1he2YL-0004ao-4o
 for 35383 <at> debbugs.gnu.org; Thu, 20 Jun 2019 15:16:57 -0400
Received: from localhost (unknown [172.92.212.120])
 (Authenticated sender: eric@HIDDEN)
 by mail.ericabrahamsen.net (Postfix) with ESMTPSA id E903EFA05D;
 Thu, 20 Jun 2019 19:16:50 +0000 (UTC)
From: Eric Abrahamsen <eric@HIDDEN>
To: Deus Max <deusmax@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN>
 <87lfy0bv9e.fsf@HIDDEN> <87sgs8z9zv.fsf@HIDDEN>
 <874l4ob2qm.fsf@HIDDEN> <87zhmdthjx.fsf@HIDDEN>
 <87imt18d9n.fsf@HIDDEN>
 <trinity-810a86e0-9451-49b2-817f-5420e9ce1adb-1561035623205@3c-app-mailcom-bs02>
 <874l4k5ifs.fsf@HIDDEN> <877e9g9j48.fsf@HIDDEN>
Date: Thu, 20 Jun 2019 12:16:44 -0700
In-Reply-To: <877e9g9j48.fsf@HIDDEN> (Deus Max's message of "Thu, 20
 Jun 2019 22:01:11 +0300")
Message-ID: <87a7ec3w4j.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 35383
Cc: 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)


On 06/20/19 22:01 PM, Deus Max wrote:
> On Thu, Jun 20 2019, Eric Abrahamsen wrote:
>
>> "Deus Max" <deusmax@HIDDEN> writes:
>>
>>>=20=20=20
>>>> : gnus-read-move-group-name: Couldnt create group Dias/=EF=BD=A3=EF=BD=
=BA=EF=BF=BD=EF=BD=BB=EF=BD=B9=EF=BF=BD=EF=BD=B9=EF=BD=B1=E5=93=A9=EF=BD=B7
>>>
>>> Oh bother. Once again an area I was quite sure I've tested. Can you
>>> tell
>>> me which backend you're trying to create the group on?
>>>
>>> Thank you very much for testing!
>>>
>>> (And don't worry about sending the exact mis-encoded string, it's
>>> enough
>>> to know it's mis-encoded.)
>>>=20
>>>=20
>>>=20
>>> Using the nnimap backend
>>
>> Found the bug, thanks! I have a few other patches I'm working on for
>> this branch, once those are done I'll push them all together. I
>> appreciate the help.
>>
>> Eric
>
>
> Great !! Glad to help.
>
> Here's another bug:
>
> using (G r) "Rename group" works fine for an English group, but fails
> for other lang. characters (Greek as my test case):
>
> Here's a few samples:
>
>   GreeK: (fails)
>       Renaming group =CE=A3=CE=BA=CF=8D=CE=BB=CE=BF=CF=82 to =CE=A3=CE=BA=
=CF=8D=CE=BB=CE=BF=CF=82=CE=93=CE=B1=CF=84=CE=B1...
>       Couldn=E2=80=99t rename group =CE=A3=CE=BA=CF=8D=CE=BB=CE=BF=CF=82 =
to =CE=A3=CE=BA=CF=8D=CE=BB=CE=BF=CF=82=CE=93=CE=B1=CF=84=CE=B1
>
>   English: (OK)
>      Renaming group Dias/MyLifeAsDog to Dias/MyLifeAsRat...
>      Killed group Dias/MyLifeAsDog
>      Renaming group Dias/MyLifeAsDog to Dias/MyLifeAsRat...done
>
>
> Also multi-language names fail too:
>
>   English+Greek:
>      Renaming group Dias/MyLifeAsRat to Dias/MyLifeAs=CE=A6=CF=89=CF=82...
>      Couldn=E2=80=99t rename group Dias/MyLifeAsRat to Dias/MyLifeAs=CE=
=A6=CF=89=CF=82

Okay, got that one too...




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 20 Jun 2019 19:01:41 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jun 20 15:01:41 2019
Received: from localhost ([127.0.0.1]:49277 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1he2JY-0002hK-Q7
	for submit <at> debbugs.gnu.org; Thu, 20 Jun 2019 15:01:41 -0400
Received: from mout.gmx.net ([212.227.17.21]:44419)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <deusmax@HIDDEN>) id 1he2JV-0002h3-9c
 for 35383 <at> debbugs.gnu.org; Thu, 20 Jun 2019 15:01:39 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1561057277;
 bh=vmS5PFxZcToFF3f2/HI5pteZXyXddJV/eoaDCOYNfRM=;
 h=X-UI-Sender-Class:From:To:Cc:Subject:References:Date:In-Reply-To;
 b=c+cCglpYfFKLYnJp1cQlHPIN6Bd2rnF/td9JxQYtaB8/URhYlLCE/D1xUbLWZPbS5
 3upV0G/2xOpeUHK2rME+hkgbCH2qEdIfYjLIG3E/QCq877T72atd8+v84jX72cZ5h9
 9wOirvupLMuVOfZpP21pdDAyMcBpIUEsQDTGfyxk=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from dellcorei5dias ([89.44.216.23]) by mail.gmx.com (mrgmx101
 [212.227.17.174]) with ESMTPSA (Nemesis) id 0MWPOI-1i62T90U02-00XgLi; Thu, 20
 Jun 2019 21:01:17 +0200
From: Deus Max <deusmax@HIDDEN>
To: Eric Abrahamsen <eric@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN>
 <87lfy0bv9e.fsf@HIDDEN> <87sgs8z9zv.fsf@HIDDEN>
 <874l4ob2qm.fsf@HIDDEN> <87zhmdthjx.fsf@HIDDEN>
 <87imt18d9n.fsf@HIDDEN>
 <trinity-810a86e0-9451-49b2-817f-5420e9ce1adb-1561035623205@3c-app-mailcom-bs02>
 <874l4k5ifs.fsf@HIDDEN>
Date: Thu, 20 Jun 2019 22:01:11 +0300
In-Reply-To: <874l4k5ifs.fsf@HIDDEN> (Eric Abrahamsen's message of
 "Thu, 20 Jun 2019 09:29:27 -0700")
Message-ID: <877e9g9j48.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Provags-ID: V03:K1:wm+KqqxSce+gADu1vIO9N43gue6J1qoNzOUOMsKMxgBGhV4SU6T
 WKi6mtWd1HNj7jE3XvAJqGYtgdg/JU33xbqzW9dymeUyCeBLBsC9lJ5nXturtmgBMDhUvpi
 AafDXKfSE2ZnRArxoydRHCt9cVmaTMF2v4vcbiAG4ECdOPWhObaQ3KFu4Kop2Z6/45yy104
 wVCstMi/38TSP0Lrf3ixQ==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:iaSDMNPN2M8=:RuyKtJ8VfB7tzI3oegdURM
 h91UJUAl54ItbBYjpFOm2ZIJcg4HjkbSQSnPHCD+Ab5500lYpbwyRqb7rvBU3O7zbEeS7mxkv
 aVX80Xna0A3VBzVVXWOrW+mJJuus4+OseFGMmbQ0RCXJEhFaF/EUC7pgOXEA0By0mzxX53Q48
 WAz5vIxo7/I3cbjQO8OjECzq42+1HmPUoodGJlZBS0mUxzIN4Mk5dfWdLdCf4bw3iOqCzlYvg
 HoedJk/sDhPgadncZ3YBqB12GumAJSSjyzY3QWDthQpUa5pfxa+lc9tYOUENwNws9bWtMHCBE
 /go6zzygwPtKhVV49LZAd08GXPrvjRGShxLmHxVTh1TqHxuaygO3WXY6PEpHkrCD4Aoo5HAq0
 MftpdpJPCCWBvxsGevN4SvR0xqrijAuL2lrhSDxc7vZLABjIrCjp9hvh/B1wtcadHXj1rlZgB
 ZzJPNL9gMGB9yneFEOddk/RADWvhrfn6PRQ0KsVrP3JvFjbgC/kJE40dC8KmmIessqiSIPqOE
 NNr0J6jJmDIcxXSFWo3lUtWyF6Ysg8s1XvjComNEWvSnTpNSbZsMvhk2dFL4daWqIgO8DTqe8
 AeXLRVRLe3aRlO+IqnQG0TaHJWmU+MIsZP/5YL9t8vuUjo8U909A1mATvomW9MheUpkYmlEgk
 dFhoSggO0fqmBgvpY8V958knfBJvRZdgDqWRyxSeaPSFwcc1b/mVDBhAhVMwTU7i5uzxS/SMj
 4nv3+c1m8yJrxBTy6vi0DNA9NlW3UtPJKEpKJAteF/TzENhNBeuJ8xSDvG5mCdvuh8i6DekGi
 0CQm8oEE802xVWv6edUCv6IEo3GbMsLfCBNwSq4C+1Dn42dJNtD0rJzcrGjbVCMNoMEatQhw+
 xtmlmsNaM7FKcrfy0C3R8B+ZjTePY5gaJ2bSRiYUPsBg7teAkRkFezbPhbeHVY0fjI/6earEb
 7JKlek/i3Sci/WqzAt6tADTBIZSP2ivB4Z+9rQpmCSltCSvsHtclo
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 35383
Cc: 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

On Thu, Jun 20 2019, Eric Abrahamsen wrote:

> "Deus Max" <deusmax@HIDDEN> writes:
>
>>=20=20=20
>>> : gnus-read-move-group-name: Couldnt create group Dias/=EF=BD=A3=EF=BD=
=BA=EF=BF=BD=EF=BD=BB=EF=BD=B9=EF=BF=BD=EF=BD=B9=EF=BD=B1=E5=93=A9=EF=BD=B7
>>
>> Oh bother. Once again an area I was quite sure I've tested. Can you
>> tell
>> me which backend you're trying to create the group on?
>>
>> Thank you very much for testing!
>>
>> (And don't worry about sending the exact mis-encoded string, it's
>> enough
>> to know it's mis-encoded.)
>>=20
>>=20
>>=20
>> Using the nnimap backend
>
> Found the bug, thanks! I have a few other patches I'm working on for
> this branch, once those are done I'll push them all together. I
> appreciate the help.
>
> Eric


Great !! Glad to help.

Here's another bug:

using (G r) "Rename group" works fine for an English group, but fails
for other lang. characters (Greek as my test case):

Here's a few samples:

  GreeK: (fails)
      Renaming group =CE=A3=CE=BA=CF=8D=CE=BB=CE=BF=CF=82 to =CE=A3=CE=BA=
=CF=8D=CE=BB=CE=BF=CF=82=CE=93=CE=B1=CF=84=CE=B1...
      Couldn=E2=80=99t rename group =CE=A3=CE=BA=CF=8D=CE=BB=CE=BF=CF=82 to=
 =CE=A3=CE=BA=CF=8D=CE=BB=CE=BF=CF=82=CE=93=CE=B1=CF=84=CE=B1

  English: (OK)
     Renaming group Dias/MyLifeAsDog to Dias/MyLifeAsRat...
     Killed group Dias/MyLifeAsDog
     Renaming group Dias/MyLifeAsDog to Dias/MyLifeAsRat...done


Also multi-language names fail too:

  English+Greek:
     Renaming group Dias/MyLifeAsRat to Dias/MyLifeAs=CE=A6=CF=89=CF=82...
     Couldn=E2=80=99t rename group Dias/MyLifeAsRat to Dias/MyLifeAs=CE=A6=
=CF=89=CF=82

Dias




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 20 Jun 2019 16:29:43 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jun 20 12:29:43 2019
Received: from localhost ([127.0.0.1]:49193 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hdzwU-0004GJ-Qu
	for submit <at> debbugs.gnu.org; Thu, 20 Jun 2019 12:29:43 -0400
Received: from ericabrahamsen.net ([52.70.2.18]:60238
 helo=mail.ericabrahamsen.net)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eric@HIDDEN>) id 1hdzwS-0004Fy-Ls
 for 35383 <at> debbugs.gnu.org; Thu, 20 Jun 2019 12:29:41 -0400
Received: from localhost (unknown [172.92.212.120])
 (Authenticated sender: eric@HIDDEN)
 by mail.ericabrahamsen.net (Postfix) with ESMTPSA id F1487FA624;
 Thu, 20 Jun 2019 16:29:33 +0000 (UTC)
From: Eric Abrahamsen <eric@HIDDEN>
To: "Deus Max" <deusmax@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN>
 <87lfy0bv9e.fsf@HIDDEN> <87sgs8z9zv.fsf@HIDDEN>
 <874l4ob2qm.fsf@HIDDEN> <87zhmdthjx.fsf@HIDDEN>
 <87imt18d9n.fsf@HIDDEN>
 <trinity-810a86e0-9451-49b2-817f-5420e9ce1adb-1561035623205@3c-app-mailcom-bs02>
Date: Thu, 20 Jun 2019 09:29:27 -0700
In-Reply-To: <trinity-810a86e0-9451-49b2-817f-5420e9ce1adb-1561035623205@3c-app-mailcom-bs02>
 (Deus Max's message of "Thu, 20 Jun 2019 15:00:23 +0200")
Message-ID: <874l4k5ifs.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 35383
Cc: 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

"Deus Max" <deusmax@HIDDEN> writes:

>=20=20=20
>> : gnus-read-move-group-name: Couldnt create group Dias/=EF=BD=A3=EF=BD=
=BA=EF=BF=BD=EF=BD=BB=EF=BD=B9=EF=BF=BD=EF=BD=B9=EF=BD=B1=E5=93=A9=EF=BD=B7
>
> Oh bother. Once again an area I was quite sure I've tested. Can you
> tell
> me which backend you're trying to create the group on?
>
> Thank you very much for testing!
>
> (And don't worry about sending the exact mis-encoded string, it's
> enough
> to know it's mis-encoded.)
>=20
>=20
>=20
> Using the nnimap backend

Found the bug, thanks! I have a few other patches I'm working on for
this branch, once those are done I'll push them all together. I
appreciate the help.

Eric




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 20 Jun 2019 13:00:42 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Jun 20 09:00:42 2019
Received: from localhost ([127.0.0.1]:48048 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hdwgE-00076D-9g
	for submit <at> debbugs.gnu.org; Thu, 20 Jun 2019 09:00:42 -0400
Received: from mout.gmx.net ([212.227.17.21]:58405)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <deusmax@HIDDEN>) id 1hdwgB-00075x-0z
 for 35383 <at> debbugs.gnu.org; Thu, 20 Jun 2019 09:00:40 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1561035623;
 bh=D7IDQtTX6+mjDR+Hv0GFBzwU3KRYKrcq6ERD50X96hQ=;
 h=X-UI-Sender-Class:From:To:Cc:Subject:Date:In-Reply-To:References;
 b=kTvcH2fZVyVaktiwTuQ2UDy0FtMowd39knwJ/6S0x6Up2oyU5Ghdfn8SmLXDb3uh5
 yzmY6iOiXmOpT0B27s5qtbrG3iwb2q/pW8aqve1RKEqD0nw11SM7eRUCTHhzeRSQ6Y
 77HbaF1GQhzdY48xcrMzQ/koWi/S9s9Zxhk5vSuc=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from [185.16.164.144] ([185.16.164.144]) by web-mail.gmx.net
 (3c-app-mailcom-bs02.server.lan [172.19.170.129]) (via HTTP); Thu, 20 Jun
 2019 15:00:23 +0200
MIME-Version: 1.0
Message-ID: <trinity-810a86e0-9451-49b2-817f-5420e9ce1adb-1561035623205@3c-app-mailcom-bs02>
From: "Deus Max" <deusmax@HIDDEN>
To: "Eric Abrahamsen" <eric@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
Content-Type: text/html; charset=UTF-8
Date: Thu, 20 Jun 2019 15:00:23 +0200
Importance: normal
Sensitivity: Normal
In-Reply-To: <87imt18d9n.fsf@HIDDEN>
References: <878sw1995f.fsf@HIDDEN>
 <87lfy0bv9e.fsf@HIDDEN> <87sgs8z9zv.fsf@HIDDEN>
 <874l4ob2qm.fsf@HIDDEN> <87zhmdthjx.fsf@HIDDEN>
 <87imt18d9n.fsf@HIDDEN>
X-UI-Message-Type: mail
X-Priority: 3
X-Provags-ID: V03:K1:17LM4VYBovZbzJLH9y81Sdn7d2+YwSVezTfUozBjkz/RbuSZza0116q2yzr4ZTwzvvTZR
 1NBWPNOpKvEdvXNzdUTlsL8WEAp6+oGOebvLxsbgeASwWamzfXQSRCxhxpwCTMAZEQ0giIX2ofVB
 v+nGrY65famL5OQqO1mxWyuIQhoSee6SKzZjbGoZpYkD1kQjSieHVrGMv25/E9not65Fc0BCdP7D
 KCB7FUL6T3vR/O52dSAgVWm4Z4EknIOJrzacZ6ewOSnbQTOo9yo2AivAXjHTtIp4SAfRNPQi7UOx
 Dc=
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:iCmZR2HiVBc=:MjFI+4MVk9Gu0a5GdenRI7
 rPoiEQT6YxbRdspJkqey0zr+S5xZ1DL5AWqPcic8VvuRgOqzt4eW4eIT90aL8S0UBQAQf9FoY
 I6OGVx95i3p/mdg+SF+wZhi6GtpwU5ZZ+rZI8prJYshc1/8LHPLhRfC6bQm9xHM1SGbWGqQuO
 4XJP8u5R1HZDvCgxbksQ4k5VyKyxFp94xrsxJQUIcZQaNzjy+ozoVGhIsoyIH8RYa8IFN/iAU
 UyRjFyGmY5OjvoOTy0bfkjpKJQDwXpvkbKz0+TPnOOACc3MM/Y+C6WCHmQ/vZ7MTbD6bRseXZ
 VaC3vJ4w1I8HOqkGdF/OBCE9xi5sEvNT4ei7khtzIHS9RZn0y2hfQdL5AF3Hy1cRbb3J8BKBL
 zT6WtxcAlbH6GCm3wBek6RVz6rgWAi4OQS5GUwDHktUiRMPaDAMnp5LLPW9dRD5QQDJCwGNkm
 pft0oo9dOAhBr9VdEsKnbkd+Plino6hm86E+x+zpYCf8gNrz8DdJAkdMFdhQO2LdeR9CWtbRX
 jxcUZV1g6GzRLFv7c324BFZXqLH14SVd3hXF0ncgQDI0d+EJvS3M9uzHfeahrE6o5nCToTZdq
 Xj/4xVQx1gq/v6EXi9rSEpq3kwHHtKGK8BSmuqHhngh/WuNZZVzhBUhA==
X-Spam-Score: -0.6 (/)
X-Debbugs-Envelope-To: 35383
Cc: 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.6 (-)

<html><head></head><body><div style="font-family: Verdana;font-size: 12.0px;"><div>&nbsp;
<div>&nbsp;
<div name="quote" style="margin:10px 5px 5px 10px; padding: 10px 0 10px 10px; border-left:2px solid #C3D9E5; word-wrap: break-word; -webkit-nbsp-mode: space; -webkit-line-break: after-white-space;">
<div style="margin:0 0 10px 0;"><b>Sent:</b>&nbsp;Thursday, June 20, 2019 at 12:40 AM<br/>
<b>From:</b>&nbsp;&quot;Eric Abrahamsen&quot; &lt;eric@HIDDEN&gt;<br/>
<b>To:</b>&nbsp;&quot;Deus Max&quot; &lt;deusmax@HIDDEN&gt;<br/>
<b>Cc:</b>&nbsp;35383 <at> debbugs.gnu.org<br/>
<b>Subject:</b>&nbsp;Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names</div>

<div name="quoted-content"><br/>
On 06/20/19 00:02 AM, Deus Max wrote:<br/>
&gt; On Mon, Jun 17 2019, Eric Abrahamsen wrote:<br/>
&gt;<br/>
&gt;&gt; Deus Max &lt;deusmax@HIDDEN&gt; writes:<br/>
&gt;&gt;<br/>
&gt;&gt;&gt; Hi Eric,<br/>
&gt;&gt;&gt;<br/>
&gt;&gt;&gt; I would be happy to test for gnus group names.<br/>
&gt;&gt;&gt;<br/>
&gt;&gt;&gt; Sorry, I haven&#39;t been following the thread.<br/>
&gt;&gt;&gt; So, how can I help testing ?<br/>
&gt;&gt;<br/>
&gt;&gt; Cool, thanks! I don&#39;t know if you&#39;ve built Emacs from git before, so<br/>
&gt;&gt; here&#39;s complete instructions, assuming something unixy:<br/>
&gt;&gt;<br/>
&gt;&gt; git clone <a href="https://git.savannah.gnu.org/git/emacs.git" target="_blank">https://git.savannah.gnu.org/git/emacs.git</a><br/>
&gt;&gt; cd emacs<br/>
&gt;&gt; git checkout scratch/gnus-decoded<br/>
&gt;&gt; make (maybe ./autogen.sh is needed?)<br/>
&gt;&gt; [back up your newsrc.eld file, and gnus.registry.eieio if you use it]<br/>
&gt;&gt; src/emacs<br/>
&gt;&gt;<br/>
&gt;&gt; Then just start Gnus as normal. Basically I&#39;m just hoping that nothing<br/>
&gt;&gt; &quot;funny&quot; happens. Do what you usually do, maybe kill and yank some<br/>
&gt;&gt; groups, copy messages around, etc. See if anything looks wrong. There&#39;s<br/>
&gt;&gt; such an enormous variety of Gnus customization out there, it&#39;s important<br/>
&gt;&gt; to get more people with more setups running the code.<br/>
&gt;&gt;<br/>
&gt;&gt; Test until you get bored, and let me know if you see anything!<br/>
&gt;&gt;<br/>
&gt;&gt; Thanks again,<br/>
&gt;&gt; Eric<br/>
&gt;<br/>
&gt; Hi Eric,<br/>
&gt;<br/>
&gt; My previous emali converted the messages to ascii.<br/>
&gt;<br/>
&gt; Here is the Gnus related messages again:<br/>
&gt;<br/>
&gt; : Generating summary...done<br/>
&gt; : Loading quail/greek...done<br/>
&gt; : No such group: Dias/&#65379;&#65402;&#65533;&#65403;&#65401;&#65533;&#65401;&#65393;&#21737;&#65399;. Create it? (y or n) y<br/>
&gt; : gnus-read-move-group-name: Couldnt create group Dias/&#65379;&#65402;&#65533;&#65403;&#65401;&#65533;&#65401;&#65393;&#21737;&#65399;<br/>
<br/>
Oh bother. Once again an area I was quite sure I&#39;ve tested. Can you tell<br/>
me which backend you&#39;re trying to create the group on?<br/>
<br/>
Thank you very much for testing!<br/>
<br/>
(And don&#39;t worry about sending the exact mis-encoded string, it&#39;s enough<br/>
to know it&#39;s mis-encoded.)</div>

<div name="quoted-content">&nbsp;</div>

<div>&nbsp;</div>

<div name="quoted-content">&nbsp;</div>

<div name="quoted-content">Using the <strong>nnimap</strong> backend</div>
</div>
</div>
</div></div></body></html>




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 19 Jun 2019 21:40:52 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jun 19 17:40:52 2019
Received: from localhost ([127.0.0.1]:47545 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hdiK4-00059Y-Bi
	for submit <at> debbugs.gnu.org; Wed, 19 Jun 2019 17:40:52 -0400
Received: from ericabrahamsen.net ([52.70.2.18]:36420
 helo=mail.ericabrahamsen.net)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eric@HIDDEN>) id 1hdiK2-00059L-9Z
 for 35383 <at> debbugs.gnu.org; Wed, 19 Jun 2019 17:40:50 -0400
Received: from localhost (unknown [172.92.212.120])
 (Authenticated sender: eric@HIDDEN)
 by mail.ericabrahamsen.net (Postfix) with ESMTPSA id DC1F2FA624;
 Wed, 19 Jun 2019 21:40:42 +0000 (UTC)
From: Eric Abrahamsen <eric@HIDDEN>
To: Deus Max <deusmax@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN>
 <87lfy0bv9e.fsf@HIDDEN> <87sgs8z9zv.fsf@HIDDEN>
 <874l4ob2qm.fsf@HIDDEN> <87zhmdthjx.fsf@HIDDEN>
Date: Wed, 19 Jun 2019 14:40:36 -0700
In-Reply-To: <87zhmdthjx.fsf@HIDDEN> (Deus Max's message of "Thu, 20
 Jun 2019 00:02:26 +0300")
Message-ID: <87imt18d9n.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=shift_jis
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 35383
Cc: 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)


On 06/20/19 00:02 AM, Deus Max wrote:
> On Mon, Jun 17 2019, Eric Abrahamsen wrote:
>
>> Deus Max <deusmax@HIDDEN> writes:
>>
>>> Hi Eric,
>>>
>>> I would be happy to test for gnus group names.
>>>
>>> Sorry, I haven't been following the thread.
>>> So, how can I help testing ?
>>
>> Cool, thanks! I don't know if you've built Emacs from git before, so
>> here's complete instructions, assuming something unixy:
>>
>> git clone https://git.savannah.gnu.org/git/emacs.git
>> cd emacs
>> git checkout scratch/gnus-decoded
>> make (maybe ./autogen.sh is needed?)
>> [back up your newsrc.eld file, and gnus.registry.eieio if you use it]
>> src/emacs
>>
>> Then just start Gnus as normal. Basically I'm just hoping that nothing
>> "funny" happens. Do what you usually do, maybe kill and yank some
>> groups, copy messages around, etc. See if anything looks wrong. There's
>> such an enormous variety of Gnus customization out there, it's important
>> to get more people with more setups running the code.
>>
>> Test until you get bored, and let me know if you see anything!
>>
>> Thanks again,
>> Eric
>
> Hi Eric,
>
> My previous emali converted the messages to ascii.
>
> Here is the Gnus related messages again:
>
>   : Generating summary...done
>   : Loading quail/greek...done
>   : No such group: Dias/=A3=BA=85=BB=B9=83=B9=B1=96=89=B7.  Create it? (y=
 or n) y
>   : gnus-read-move-group-name: Couldnt create group Dias/=A3=BA=85=BB=B9=
=83=B9=B1=96=89=B7

Oh bother. Once again an area I was quite sure I've tested. Can you tell
me which backend you're trying to create the group on?

Thank you very much for testing!

(And don't worry about sending the exact mis-encoded string, it's enough
to know it's mis-encoded.)




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 19 Jun 2019 21:28:41 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jun 19 17:28:41 2019
Received: from localhost ([127.0.0.1]:47534 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hdi8H-0004r4-1l
	for submit <at> debbugs.gnu.org; Wed, 19 Jun 2019 17:28:41 -0400
Received: from mout.gmx.net ([212.227.17.22]:35349)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <deusmax@HIDDEN>) id 1hdi8E-0004qr-G1
 for 35383 <at> debbugs.gnu.org; Wed, 19 Jun 2019 17:28:39 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1560979706;
 bh=jbiQGyEjIAFtEnS8sIfG0VS5o+sbX02BCNjkIGhhVOo=;
 h=X-UI-Sender-Class:From:To:Cc:Subject:References:Date:In-Reply-To;
 b=AnDarKOczDq/JgrYw3e/MFSM/9/IAOfN7T4Gz6stXj4VTVAVR7j5kqML73w5wNmP7
 rT2rNOLGcqcJ/LPEoCTLEgPtG4QxZpvIxQ0QjVlAS/J4v5zuKz9/Fbm77ekHV46WUH
 Nqs+oEJG7mXXyCp7K2ebtALe0GOdLOIDyFkQ00zs=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from dellcorei5dias ([46.177.207.252]) by mail.gmx.com (mrgmx105
 [212.227.17.174]) with ESMTPSA (Nemesis) id 1Mz9Ux-1iYaCX0OpP-00wFnk; Wed, 19
 Jun 2019 23:28:26 +0200
From: Deus Max <deusmax@HIDDEN>
To: Eric Abrahamsen <eric@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN>
 <87lfy0bv9e.fsf@HIDDEN> <87sgs8z9zv.fsf@HIDDEN>
 <874l4ob2qm.fsf@HIDDEN>
Date: Thu, 20 Jun 2019 00:28:21 +0300
In-Reply-To: <874l4ob2qm.fsf@HIDDEN> (Eric Abrahamsen's message of
 "Mon, 17 Jun 2019 09:22:57 -0700")
Message-ID: <87v9x1tgcq.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-Provags-ID: V03:K1:680MvP7qJCl7AgUingwQ+B/yb0Yqvs9FiF5XUlF89sidOMDxAsm
 9TV8teiRqYV6XmlHIpx7/KhFv0XoZBbE4YPwM725ICtWfLBTnsNeKJ11RIAU1kh6JvtTL46
 TtVTpjk9DxIZx0P/ijxG5s4gym3WnOx92WI+NnbIYH1+Uq74dLAXyx23OHfqtq1v0tPa/Kw
 SpG6u436U3IPYcaW8lZYw==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:CEinyjw28vQ=:yLgv93qvsha5aQNd1F/BAB
 4SG0+NHY4sF94YH4K2/NAyltfD6c1I9CuBdTz1KGF80XABtnc+XUQLMF7F34ndV/qN2GYgGrJ
 jSxDayFSLTaw2gEGODc5hl8UXaFdnFXUkE5OWx4lDO5mJ8zWan8Hqhn5j12RjXsqY/YeLkBwg
 CeALyyx4OdoDZU/eeLIJhcum64CmauJwXANi7h13tEfGHsQWUAo1QhPYCC64zdvnNtvYdvxHP
 3fJqa+koP551mHyWjlEcfo2eu12NoZQjt+GtbZd1N9pVI0digy9rMDQnWgKfdu5n9FOEwmLuN
 YNubabjNsq3QgujXUHBZfwNyJ7Tkd/O0mx/9p/VEsbUzkaTZKz6Pv8dR2wYTjyXe1LIq26zH1
 7qVaGL3u1w7KN9ZKeZK8Zoo1qcsb72PxpKMDBcOmdpX8tq9pqd33VcwEes+UnZFKT0GpyL8t5
 WVmjniLlihuPltnGRqnITnWhtGO0nww04AEC4Hcm8nbUC3OszuXCnIy5/mgLJ5biL9EERSJiS
 sm/PJtrkim3HhoAvcdTrfHfhOwlhc74wuXxO/HOcz33+TEZGR/8GaXb+DEGzUJuY1n+o+r0Nj
 dl8FcQce3moXssCgXEiaX09A+Q45IRMELAgWR5xz6inHkwzqcQ7gqHq5E5P8C1ZCa/Q/45lcH
 MxhevSiWHOa2aFQSkKafUZmBARH0MzDXnHvc5oMRIrq5+aeMJjnUIcsmV4xyZ0uWzh8N7CzVP
 MtMwQWak9zS4jd3GA1zFKj/Py223Qa+h6sTf7DSyiW8SK8QtPTeky2woFvtlS90EVaf69MtOm
 Veu2QRpudUTIsVwMngx9aL64NNvYDrXek7hKLhYHIxbLqEnDkxktT924+BJb/UPnECo/AyUyK
 K8PBYoTY3iemwz7kiGQZMEtthD2FTmJ3at7g0p9FTta+EJxBmhSy6Hrp1ZwxsgY6lRnf1ne0s
 RXvLWs6b+q2o1jfrdQ7pg/PsrFPIXjpY=
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 35383
Cc: 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

--=-=-=
Content-Type: text/plain

On Mon, Jun 17 2019, Eric Abrahamsen wrote:

> Deus Max <deusmax@HIDDEN> writes:
>
>> Hi Eric,
>>
>> I would be happy to test for gnus group names.
>>
>> Sorry, I haven't been following the thread.
>> So, how can I help testing ?
>
> Cool, thanks! I don't know if you've built Emacs from git before, so
> here's complete instructions, assuming something unixy:
>
> git clone https://git.savannah.gnu.org/git/emacs.git
> cd emacs
> git checkout scratch/gnus-decoded
> make (maybe ./autogen.sh is needed?)
> [back up your newsrc.eld file, and gnus.registry.eieio if you use it]
> src/emacs
>
> Then just start Gnus as normal. Basically I'm just hoping that nothing
> "funny" happens. Do what you usually do, maybe kill and yank some
> groups, copy messages around, etc. See if anything looks wrong. There's
> such an enormous variety of Gnus customization out there, it's important
> to get more people with more setups running the code.
>
> Test until you get bored, and let me know if you see anything!
>
> Thanks again,
> Eric

Sorry for the multiple posts.
Here's what I was trying to show:


--=-=-=
Content-Type: image/png
Content-Disposition: inline;
 filename=emacs-GnusGroups-2019-06-20T00-24-16.png
Content-Transfer-Encoding: base64
Content-Description: Gnus Group create in Greek
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--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 19 Jun 2019 21:02:58 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jun 19 17:02:58 2019
Received: from localhost ([127.0.0.1]:47520 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hdhjO-0004G7-E3
	for submit <at> debbugs.gnu.org; Wed, 19 Jun 2019 17:02:58 -0400
Received: from mout.gmx.net ([212.227.17.22]:50195)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <deusmax@HIDDEN>) id 1hdhjM-0004Fv-SC
 for 35383 <at> debbugs.gnu.org; Wed, 19 Jun 2019 17:02:57 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1560978158;
 bh=3LYHyboKd9zymGNewINuYAZv6SKB1YO9xf2zVATmTRg=;
 h=X-UI-Sender-Class:From:To:Cc:Subject:References:Date:In-Reply-To;
 b=c7u29mC8TGaHjNFed5oTihUXOClt3WW7vMOtKL+PrVhTHpjUoCcmV7p6EU/UhqV9P
 i+utHqglhuPPn9jNZIMqN8y12BjrTMScyuwb37Rh0x2opjPYmW5BSTmiEXvwBvTcHR
 88ZLgWwBNc6Ydm8ncwbafsCS7BzpqKnVIFgJf5bk=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from dellcorei5dias ([46.177.207.252]) by mail.gmx.com (mrgmx103
 [212.227.17.174]) with ESMTPSA (Nemesis) id 0LiDHj-1iPfaf0Wg7-00nPkH; Wed, 19
 Jun 2019 23:02:38 +0200
From: Deus Max <deusmax@HIDDEN>
To: Eric Abrahamsen <eric@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN>
 <87lfy0bv9e.fsf@HIDDEN> <87sgs8z9zv.fsf@HIDDEN>
 <874l4ob2qm.fsf@HIDDEN>
Date: Thu, 20 Jun 2019 00:02:26 +0300
In-Reply-To: <874l4ob2qm.fsf@HIDDEN> (Eric Abrahamsen's message of
 "Mon, 17 Jun 2019 09:22:57 -0700")
Message-ID: <87zhmdthjx.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable
X-Provags-ID: V03:K1:eyRNoxZYpbiVQcloj1lNz76+RgYY5GlIqFMv/wA5GCFMA0a+e8u
 X6GXW5yT4hZZdFI8A3Rcpv+mmUnuPF1xtUWkBet2W4LTq9DenLN2W0iQjxCoqUvTRC3nbJ7
 1KJUecepdFXtHdE+U5S7Zeccv4Qg6oWhRv3PKOYn78KYW11zL028eN7Sx9pOw9d/rfHX5SE
 1vbpQHa4l9ltletS5+iBg==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:na3sGICG2ac=:6px0GywWuclUijG08u3dUQ
 MKiKOjn5klau2t69MDUfPdRlZX0vg+pZ9hu1Hf0LuXK6sQPwRcXKPz/zWbczekjcuKS7+wqeM
 t7LvzJjmEu97T2yoJyb2WNuaqbMX5+ZUWQhZjIti3lbgZ6+jajv0hHsTK4TbIDHthedmc21sr
 BiGswZaJpbkfyI0VwfqkfYDloeXSZY7ln74Tkga6w95y+xlVmZjDfEzJlVqDpQQ/uLMC9qXHl
 TARIrW2NPjy9k7JCf1lJOLArMdW2063QcXmB7aR43jSdfVqL+NpRCzQFgWxS36+QsB7ovRS0Z
 PS5YtaqoUVxmc+BRGKBG16z8svBQEbxNAU+gfNSQf0TNDLsy6NUxU+mwH/9hounnxibEqg6VK
 wsw0qg4HLnk3j6zoHGAApcF9lUNNKzcDMU/hZmLj8BJx9nKiAFmtAlKcM0z4U803X73BSSmdO
 CiR0oxlKtW3Sg1LfnX8fo8+2IXworCHsKLM1WhWkrT4c+Qh1c+F4T/SJN9C2bvVoVROqfVKy9
 y794HZuqCP46I58P66cAzVkMpwCSX6uBOZTMeOGgX2ziqTJpTSZJJEoP+detBn2xIO5RV4Mvt
 lRP4qrxfbPopcicOnvmxVF1p/VmiEoJ05oB0a4oiMRkZ7QqlVBwJI3Tx8dZvi0Rlka2sgmV2J
 Cv6VYSpoHgxaq+15WfVFrT+u8e1nvjKwagPN8CdJcpP5AhGq8skknHXdCy67yL/r84sXgBwwH
 mZRNOeKKuVf7DrkmkRD53B8Y7lCw8xbHYo99wif1CVEpFUVZbhOLCQ71QoCN0St56mq+JrLvP
 cRPibi5TKNuH65Adv2BbsMnsu7QdJwoQcpv2D+NqOr9IfIislLP8XhF4/N6nlLFXls/jkL+x3
 ek2K+zdrmlRtoFudcW1FkLIcFHhEkxca9gLsN7zAahazCrvW87ePapZ1rL0A6ErBIUOADx6/p
 q5aP/rMQsfybXbwB8yqoLtzZ0mplf9Nq459WOf7fucQLFn0Qjt30Y
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 35383
Cc: 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

On Mon, Jun 17 2019, Eric Abrahamsen wrote:

> Deus Max <deusmax@HIDDEN> writes:
>
>> Hi Eric,
>>
>> I would be happy to test for gnus group names.
>>
>> Sorry, I haven't been following the thread.
>> So, how can I help testing ?
>
> Cool, thanks! I don't know if you've built Emacs from git before, so
> here's complete instructions, assuming something unixy:
>
> git clone https://git.savannah.gnu.org/git/emacs.git
> cd emacs
> git checkout scratch/gnus-decoded
> make (maybe ./autogen.sh is needed?)
> [back up your newsrc.eld file, and gnus.registry.eieio if you use it]
> src/emacs
>
> Then just start Gnus as normal. Basically I'm just hoping that nothing
> "funny" happens. Do what you usually do, maybe kill and yank some
> groups, copy messages around, etc. See if anything looks wrong. There's
> such an enormous variety of Gnus customization out there, it's important
> to get more people with more setups running the code.
>
> Test until you get bored, and let me know if you see anything!
>
> Thanks again,
> Eric

Hi Eric,

My previous emali converted the messages to ascii.

Here is the Gnus related messages again:

  : Generating summary...done
  : Loading quail/greek...done
  : No such group: Dias/=A3=BA=85=BB=B9=83=B9=B1=96=89=B7.  Create it? (y =
or n) y
  : gnus-read-move-group-name: Couldn=19t create group Dias/=A3=BA=85=BB=
=B9=83=B9=B1=96=89=B7
  : No more articles [2 times]
  : No such group: Dias/=96=89=B7=95=BD=A4=B1=86=BF.  Create it? (y or n) =
y
  : gnus-read-move-group-name: Couldn=19t create group Dias/=96=89=B7=95=
=BD=A4=B1=86=BF
  : next-line: End of buffer
  : No more articles [2 times]


And the warnings:

  : These default coding systems were tried to encode text
  : in the buffer =18emacs-gnus-group-2019-06-19.txt=19:
  :   (utf-8-emacs-unix (74 . 4194254) (75 . 4194211) (76 . 4194254) (77 .=
 4194234) (78
  :   . 4194255) (79 . 4194181) (80 . 4194254) (81 . 4194235) (82 . 419425=
4) (83 .
  :   4194233) (84 . 4194255))
  : However, each of them encountered characters it couldn=19t encode:
  :   utf-8-emacs-unix cannot encode these:           ...
  :
  : Click on a character (or switch to this window by =18M-x other-window=
=19
  : and select the characters by RET) to jump to the place it appears,
  : where =18C-u C-x =3D=19 will give information about it.
  :
  : Select one of the safe coding systems listed below,
  : or cancel the writing with C-g and edit the buffer
  :    to remove or modify the problematic characters,
  : or specify any other coding system (and risk losing
  :    the problematic characters).
  :
  :   raw-text no-conversion


Hope they display as I see them.

Dias






Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 19 Jun 2019 20:58:17 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jun 19 16:58:17 2019
Received: from localhost ([127.0.0.1]:47512 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hdheq-000483-Ir
	for submit <at> debbugs.gnu.org; Wed, 19 Jun 2019 16:58:17 -0400
Received: from mout.gmx.net ([212.227.17.20]:45037)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <deusmax@HIDDEN>) id 1hdheo-00047o-DI
 for 35383 <at> debbugs.gnu.org; Wed, 19 Jun 2019 16:58:15 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1560977878;
 bh=fYQEdCwgS3KzkhI6qrsJqIfc8RZQ5N+EAngP7DB7zJQ=;
 h=X-UI-Sender-Class:From:To:Cc:Subject:References:Date:In-Reply-To;
 b=HFpkLlUqPdQuEoMpjMUGmWi/+QCJj66cEj/wv1kOjs3fUprVVTGVfRVMUB8LbPAfn
 rqZqmOJOwSGKBD6Muc3DgLSR5yAF9s+0Nw9U9TLPvsOL8yodRZOsSqMR6ONNKWhxf0
 XiOTKuy9dtZhaJ4rqTSxFIxaRidjnRfQJmQUeFGw=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from dellcorei5dias ([46.177.207.252]) by mail.gmx.com (mrgmx105
 [212.227.17.174]) with ESMTPSA (Nemesis) id 1Mel3t-1iE8nb0Dor-00aiBk; Wed, 19
 Jun 2019 22:57:58 +0200
From: Deus Max <deusmax@HIDDEN>
To: Eric Abrahamsen <eric@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN>
 <87lfy0bv9e.fsf@HIDDEN> <87sgs8z9zv.fsf@HIDDEN>
 <874l4ob2qm.fsf@HIDDEN>
Date: Wed, 19 Jun 2019 23:57:40 +0300
In-Reply-To: <874l4ob2qm.fsf@HIDDEN> (Eric Abrahamsen's message of
 "Mon, 17 Jun 2019 09:22:57 -0700")
Message-ID: <874l4luwcb.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable
X-Provags-ID: V03:K1:pdt3Hzo/tcS4zE6X+apmrV91Fmw3W3I8+BNDVYwKSPZBtqJ1QUt
 GcQqHhSUZI0KtpOjrR77F6eARkJY0AdGIa3Vd1Q9ebLl3RykmnZ/QAN+TV7AyFBYVCibHjY
 Evjfz9I9Eu2t/cV2nCYq5YiCQu99TTEB2RXnvkEGwS4Mw6rp8cliSCtiUPEqG+LIV54MNBK
 l/OxANVEVajA+zIihfnOw==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:tqpXB0/rLnw=:o8Sbm0MDIgNBk6vQgxW7lG
 vtXBgHN6sF3UKPbb4cAVR+4Blwd116gMxsPCglRRJxcihIkye15gh+rui04293Mfwk90+U5Ta
 cgI1RwWExfs9CbwBWEUAYK90PoOkGYOSQVIjGA7IxA02le4TOXvYVEPypvX1NsBC0T8bHJvUt
 hazfWY8OMsviwZDNL9zIfkmrWIuaaTDXU8/x97vHRWbbJD2GjNppWCqExuP1DML4PvA1BBjkO
 DY0pcsxwLiqH9g5CpUCImxiJZYpIvLqMeh4t9+3LJ72sFFcZeBzKmi/Y8njDCcY5JjrGGQpZQ
 KXjSnvAx/ZgpbjIEaPqfMedcNJuJ2b/EY/nV79WxIkAib2+PhxVCNLxM56DGT5G1r/VqLOID4
 izPjusLHCjhHC33pPMc1Uc/tc/We1qgm/W89TiOYHJKS63d/cpZ/E3ZYm19jwO7L8qCsZbsfL
 hQvWtpfT2Mf1ILczpO99Q9B3dxT2LPmCm5u4ntSdHENNatB9ih9EXoenhjkPsZfrOyF7S3ptb
 9OoKcmUrGB6UuvMv1ScROVviduW3dIzFZR5OTrXV9O8FfvLgZyB/xIYku5EmfMkUEco+Q5Pql
 hD9ky8WWzDiLay3kCD22r7Q2q5faj+Lol+1eX7yWeWN+s+jpFWBrgpLKKuGESGIDU0+ZE4cKK
 k1ki1ISQkOL9Gvr8whxr2P+ZpUQmUJi7+q2o4cQOLi8kKnwY+3RRGtxjBefCYGbMYiOpZOVRr
 gtEaVPGeVeZDwJaPv6VJeKxaYERGjIzxrv6UT/RkwlGIGGTzxJMh4CAeztBsr/5t7xjmEhm5t
 sfelp8qbmmqvvheMLKQNvVJtgJ7oVpF7vMGZuU5cUFRtmzs/zkFcOi/OFOGDATZLMZWIvitpX
 i1TdQUW/E7GLw+sKP746TAdL7ouEgfz8CroYjha+sxy/04CwuYJKxoROIZy512YB6RZ8y9MEx
 A9SwCCnwxOedHNDD+9IEbg3f+FcvwyiTCGH5kCj1Ws5UaHbUh3MAe
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 35383
Cc: 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

On Mon, Jun 17 2019, Eric Abrahamsen wrote:

> Deus Max <deusmax@HIDDEN> writes:
>
>> Hi Eric,
>>
>> I would be happy to test for gnus group names.
>>
>> Sorry, I haven't been following the thread.
>> So, how can I help testing ?
>
> Cool, thanks! I don't know if you've built Emacs from git before, so
> here's complete instructions, assuming something unixy:
>
> git clone https://git.savannah.gnu.org/git/emacs.git
> cd emacs
> git checkout scratch/gnus-decoded
> make (maybe ./autogen.sh is needed?)
> [back up your newsrc.eld file, and gnus.registry.eieio if you use it]
> src/emacs
>
> Then just start Gnus as normal. Basically I'm just hoping that nothing
> "funny" happens. Do what you usually do, maybe kill and yank some
> groups, copy messages around, etc. See if anything looks wrong. There's
> such an enormous variety of Gnus customization out there, it's important
> to get more people with more setups running the code.
>
> Test until you get bored, and let me know if you see anything!
>
> Thanks again,
> Eric


Followed your instruction and compiled an emacs binary from the
scratch/gnus-decoded branch.

1. When listing Groups in the Group buffer using (l) or (L), all good.

2. In a group Summary Buffer, when moving (B m) an article to a new
   (non-existent) group in English, Gnus asks, creates group & moves artic=
le.

3. Same group Summary Buffer, moving to a Greek named  group, Gnus asks
   with name encoded as numbers and fails to create group. Here is
   '*Message*' buffer:

   : Generating summary...done
   : Loading quail/greek...done
   : No such group: Dias/=A3=BA=85=BB=B9=83=B9=B1=96=89=B7.  Create it? (y=
 or n) y
   : gnus-read-move-group-name: Couldn=19t create group Dias/=A3=BA=85=BB=
=B9=83=B9=B1=96=89=B7
   : No more articles [2 times]
   : No such group: Dias/=96=89=B7=95=BD=A4=B1=86=BF.  Create it? (y or n)=
 y
   : gnus-read-move-group-name: Couldn=19t create group Dias/=96=89=B7=95=
=BD=A4=B1=86=BF
   : next-line: End of buffer
   : No more articles [2 times]

Also, trying to save the above text in a separate file, I get (after
setting the coding system to utf-8-emacs-unix):

   : These default coding systems were tried to encode text
   : in the buffer =18emacs-gnus-group-2019-06-19.txt=19:
   :   (utf-8-emacs-unix (74 . 4194254) (75 . 4194211) (76 . 4194254) (77 =
. 4194234) (78
   :   . 4194255) (79 . 4194181) (80 . 4194254) (81 . 4194235) (82 . 41942=
54) (83 .
   :   4194233) (84 . 4194255))
   : However, each of them encountered characters it couldn=19t encode:
   :   utf-8-emacs-unix cannot encode these:           ...
   :
   : Click on a character (or switch to this window by =18M-x other-window=
=19
   : and select the characters by RET) to jump to the place it appears,
   : where =18C-u C-x =3D=19 will give information about it.
   :
   : Select one of the safe coding systems listed below,
   : or cancel the writing with C-g and edit the buffer
   :    to remove or modify the problematic characters,
   : or specify any other coding system (and risk losing
   :    the problematic characters).
   :
   :   raw-text no-conversion


Hope this helps.
1. comit: 40ad1c0d63804d8d0c30d994907b330ccb952793
2. not using the Gnus registry





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 17 Jun 2019 16:23:30 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jun 17 12:23:30 2019
Received: from localhost ([127.0.0.1]:43187 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hcuPp-0003xx-U4
	for submit <at> debbugs.gnu.org; Mon, 17 Jun 2019 12:23:30 -0400
Received: from lists.gnu.org ([209.51.188.17]:33986)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1hcuPp-0003xp-1z
 for submit <at> debbugs.gnu.org; Mon, 17 Jun 2019 12:23:29 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:50223)
 by lists.gnu.org with esmtp (Exim 4.86_2)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1hcuPm-0005aQ-H3
 for bug-gnu-emacs@HIDDEN; Mon, 17 Jun 2019 12:23:28 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.8 required=5.0 tests=BAYES_40,RDNS_NONE,
 URIBL_BLOCKED autolearn=disabled version=3.3.2
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1hcuPk-0006QU-LZ
 for bug-gnu-emacs@HIDDEN; Mon, 17 Jun 2019 12:23:26 -0400
Received: from [195.159.176.226] (port=45076 helo=blaine.gmane.org)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1hcuPk-0006Or-D3
 for bug-gnu-emacs@HIDDEN; Mon, 17 Jun 2019 12:23:24 -0400
Received: from list by blaine.gmane.org with local (Exim 4.89)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1hcuPh-000UUx-4s
 for bug-gnu-emacs@HIDDEN; Mon, 17 Jun 2019 18:23:21 +0200
X-Injected-Via-Gmane: http://gmane.org/
To: bug-gnu-emacs@HIDDEN
From: Eric Abrahamsen <eric@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
Date: Mon, 17 Jun 2019 09:22:57 -0700
Message-ID: <874l4ob2qm.fsf@HIDDEN>
References: <878sw1995f.fsf@HIDDEN>
 <87lfy0bv9e.fsf@HIDDEN> <87sgs8z9zv.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
Cancel-Lock: sha1:7hVSvEoj4mtv4hUugMxfJmM/Src=
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 195.159.176.226
X-Spam-Score: -2.0 (--)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.0 (---)

Deus Max <deusmax@HIDDEN> writes:

> Hi Eric,
>
> I would be happy to test for gnus group names.
>
> Sorry, I haven't been following the thread.
> So, how can I help testing ?

Cool, thanks! I don't know if you've built Emacs from git before, so
here's complete instructions, assuming something unixy:

git clone https://git.savannah.gnu.org/git/emacs.git
cd emacs
git checkout scratch/gnus-decoded
make (maybe ./autogen.sh is needed?)
[back up your newsrc.eld file, and gnus.registry.eieio if you use it]
src/emacs

Then just start Gnus as normal. Basically I'm just hoping that nothing
"funny" happens. Do what you usually do, maybe kill and yank some
groups, copy messages around, etc. See if anything looks wrong. There's
such an enormous variety of Gnus customization out there, it's important
to get more people with more setups running the code.

Test until you get bored, and let me know if you see anything!

Thanks again,
Eric





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 17 Jun 2019 12:12:48 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jun 17 08:12:48 2019
Received: from localhost ([127.0.0.1]:42106 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hcqVE-0001QB-6u
	for submit <at> debbugs.gnu.org; Mon, 17 Jun 2019 08:12:48 -0400
Received: from mout.gmx.net ([212.227.17.21]:58277)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <deusmax@HIDDEN>) id 1hcqVC-0001Pu-Ei
 for 35383 <at> debbugs.gnu.org; Mon, 17 Jun 2019 08:12:47 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1560773548;
 bh=By2iBBIwpxGBA8vHQlM9+mH0880YZ5Npm0lvCRn08/U=;
 h=X-UI-Sender-Class:From:To:Cc:Subject:References:Date:In-Reply-To;
 b=S0s0uDg8Yfoz419dllKjWEaTNmdyipeHa6gYDsAtp2GvnJ3oSH3SQbtCCRR0Yh7Uv
 TduCzfeQ1DDyCp3hkOGZ7T6FLcdGISOxVUf2WPfcw4n7nHUi3uxB3pIU+Z+ZsPD+nj
 881Fpw32kFa1tH1dJJ8MlRqy8eodZpvgv8eI+VSA=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from dellcorei5dias ([46.177.207.252]) by mail.gmx.com (mrgmx101
 [212.227.17.174]) with ESMTPSA (Nemesis) id 0MFPyK-1hp06i1qYm-00EPOL; Mon, 17
 Jun 2019 14:12:28 +0200
From: Deus Max <deusmax@HIDDEN>
To: Eric Abrahamsen <eric@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN>
 <87lfy0bv9e.fsf@HIDDEN>
Date: Mon, 17 Jun 2019 15:12:20 +0300
In-Reply-To: <87lfy0bv9e.fsf@HIDDEN> (Eric Abrahamsen's message of
 "Sun, 16 Jun 2019 23:06:53 -0700")
Message-ID: <87sgs8z9zv.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Provags-ID: V03:K1:Y0BPInFNo2R6FCAwIEAaFcrNFV5cqpUgjqs2Y4n80Fl24P4hTj/
 HKzC35aMi9E67ZR/Xwntq9KCi8wfowL3o8tI6vhwKivj7O8uBHNZJzyG5aN3XcJEB19B0A4
 ChYxzYVL0+X7Ke1feCTYNFdFs/M64rgmf4OjtnVy+Z8mDngxsZcPeEiENUdrZ5ht2jYtYXz
 1UDVOT6asmXOKg3XO2r0A==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:0c17hfFx+2w=:br7/vIqwOLoKEgp/9Wu8RF
 qgU/3vWpkpl0HoUcLn9xxc4oJWHhFBu0tx1Uk4h5SGWfLtI4PM6D2flBb0ljY4zFMm9OHVFFK
 8uJ0DBDjmh9XFmjGF8cCoY+7YHGHeWy5aqTu6Wkxsh/DppbtmD9SiESRs+SDLLuoKuArcVSo2
 FN5v/BmsWW6b5w6QTXlhzzojc1eNPdSoamdHVOUUgTSN6L1UMWHwtIJZY4XAWaor22JFQanqP
 Gqi66gJXMRYd2D8jOGBdLriMkIEVFGSy+dy0K57fwaXy6FKiYLF0ar2U1u4ZgwdQ8oP8viFYu
 GSxdTGOu7FgmQHTdLX4B5pP181Y4/I3ifYR7meRyFer090opBxSjPJu6BbAWlnVSwq22GWrW1
 tP3gnkiP3O+cfKrFLaUC7Cj3XZcAF4lda5EvqhAb7rbhHUu3pzgmmXnPxrBRhNJpqs/zqPz9b
 3cSFJIS3GvahbtQAoWYf5EA3ooZZbfDSjriZKkbLy/7cXpOLpWSt5BA6cOkcX+HGwrcB0O7Jt
 Bk2FDhqUI7B3Zcp5WkjrVxph4gy3mCZh+DkcbIuCQuD/yQ15u7oAcN1aZ86+8jkPV0mhSy7iA
 y+bZieurvQMT7olVlpiFKYiP5vR275euAZMJFmFa5kKXG2j8rS+JXeDf28SiuIHIAecXVcHuQ
 rEAlcgnJh4+ubOh/S/6pvWY5EP8Okq+MemgROt8Vur3vjF13CvSY9CZh6fgcIKQmyab7/simH
 toeBRA60Ik3xMelOGaVjMXf5ILJX/C1GbtB5akwFypBaXa5u+bOz3U3bmBN/h8TaSLYks8PB4
 X1gyRBcrUAZqB/nhCfINQzDXBbTNfIggKImC3lTRmYR5hHQp6aq+oAOtBTojQ0gYzlNcaflBa
 UCHpvk2kFoh4gcEenKXPOAt2xsWvgm8KuuKAoYbVOiZG8C+PDaKDAI80KMLAk/jnVjRxplBBa
 GFdp2zms3xDeHFM7RzaCrOWsqxxeUPhRKYLxz9Mda2Dgli0Ja7smVMwrZgd1cRqCKALha2ngl
 Yg==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 35383
Cc: 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)


Hi Eric,

I would be happy to test for gnus group names.

Sorry, I haven't been following the thread.
So, how can I help testing ?





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 17 Jun 2019 06:07:24 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jun 17 02:07:23 2019
Received: from localhost ([127.0.0.1]:41815 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hcknZ-0007BD-Oj
	for submit <at> debbugs.gnu.org; Mon, 17 Jun 2019 02:07:23 -0400
Received: from lists.gnu.org ([209.51.188.17]:33280)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1hcknY-0007B6-1h
 for submit <at> debbugs.gnu.org; Mon, 17 Jun 2019 02:07:20 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:43915)
 by lists.gnu.org with esmtp (Exim 4.86_2)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1hcknX-0004Ut-61
 for bug-gnu-emacs@HIDDEN; Mon, 17 Jun 2019 02:07:20 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: *
X-Spam-Status: No, score=1.6 required=5.0 tests=BAYES_50,RDNS_NONE,
 URIBL_BLOCKED autolearn=disabled version=3.3.2
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1hcknW-0001ii-2x
 for bug-gnu-emacs@HIDDEN; Mon, 17 Jun 2019 02:07:19 -0400
Received: from [195.159.176.226] (port=51594 helo=blaine.gmane.org)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1hcknV-0001bH-Sz
 for bug-gnu-emacs@HIDDEN; Mon, 17 Jun 2019 02:07:18 -0400
Received: from list by blaine.gmane.org with local (Exim 4.89)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1hcknO-000PLr-HO
 for bug-gnu-emacs@HIDDEN; Mon, 17 Jun 2019 08:07:10 +0200
X-Injected-Via-Gmane: http://gmane.org/
To: bug-gnu-emacs@HIDDEN
From: Eric Abrahamsen <eric@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
Date: Sun, 16 Jun 2019 23:06:53 -0700
Message-ID: <87lfy0bv9e.fsf@HIDDEN>
References: <878sw1995f.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
Cancel-Lock: sha1:Ex5VA5RL/5SiKANKBtMOGa/YN0E=
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 195.159.176.226
X-Spam-Score: -2.0 (--)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.0 (---)

Eric Abrahamsen <eric@HIDDEN> writes:

> This is part two and the completion of bug#33653, which changed Gnus's
> obarrays into hash tables, and group names from symbols to (encoded)
> strings. The commits in the recently-pushed "scratch/gnus-decoded"
> branch change group names to decoded strings.

I think the code in scratch/gnus-decoded is nearing "ready". I've got a
few testers who have flushed out some good bugs, but it would be nice to
have a couple more.

This change was supposed to involve an update to Gnus' data files
(non-ascii group names would be encoded properly as utf-8). But I ended up
putting in code that maintains the status quo, pending a future bump to
Gnus' version. That will trigger an upgrade that the user has to okay,
and alert them that their data files are no longer backwards-usable.

I do hope to get another tester or two, though!

Eric





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 11 Jun 2019 08:09:46 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jun 11 04:09:46 2019
Received: from localhost ([127.0.0.1]:57972 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1habqj-0000hL-VO
	for submit <at> debbugs.gnu.org; Tue, 11 Jun 2019 04:09:46 -0400
Received: from black.elm.relay.mailchannels.net ([23.83.212.19]:39105)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <yamaoka@HIDDEN>) id 1habqi-0000hB-10
 for 35383 <at> debbugs.gnu.org; Tue, 11 Jun 2019 04:09:45 -0400
X-Sender-Id: tih5qno0ow|x-authuser|yamaoka@HIDDEN
Received: from relay.mailchannels.net (localhost [127.0.0.1])
 by relay.mailchannels.net (Postfix) with ESMTP id 8B5D73417B4;
 Tue, 11 Jun 2019 08:09:42 +0000 (UTC)
Received: from hampton.hostforweb.net
 (100-96-11-129.trex.outbound.svc.cluster.local [100.96.11.129])
 (Authenticated sender: tih5qno0ow)
 by relay.mailchannels.net (Postfix) with ESMTPA id CE26A341B9A;
 Tue, 11 Jun 2019 08:09:41 +0000 (UTC)
X-Sender-Id: tih5qno0ow|x-authuser|yamaoka@HIDDEN
Received: from hampton.hostforweb.net ([TEMPUNAVAIL]. [172.245.115.217])
 (using TLSv1.2 with cipher DHE-RSA-AES256-GCM-SHA384)
 by 0.0.0.0:2500 (trex/5.17.2); Tue, 11 Jun 2019 08:09:42 +0000
X-MC-Relay: Neutral
X-MailChannels-SenderId: tih5qno0ow|x-authuser|yamaoka@HIDDEN
X-MailChannels-Auth-Id: tih5qno0ow
X-Lettuce-Little: 4075f5af0d257d58_1560240582366_3406199107
X-MC-Loop-Signature: 1560240582366:3553614147
X-MC-Ingress-Time: 1560240582366
Received: from s70.gtokyofl21.vectant.ne.jp ([202.215.75.70]:60000
 helo=localhost) by hampton.hostforweb.net with esmtpsa
 (TLSv1.2:ECDHE-RSA-AES256-GCM-SHA384:256) (Exim 4.89_1)
 (envelope-from <yamaoka@HIDDEN>)
 id 1habqY-001Ujv-Dm; Tue, 11 Jun 2019 03:09:35 -0500
Date: Tue, 11 Jun 2019 17:09:31 +0900
Message-ID: <b4m1s001r2c.fsf@HIDDEN>
From: Katsumi Yamaoka <yamaoka@HIDDEN>
To: Eric Abrahamsen <eric@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN> <b4mk1fl16oz.fsf@HIDDEN>
 <87sgu87ayo.fsf@HIDDEN> <b4mzhnrw5w6.fsf@HIDDEN>
 <87woiuf6ya.fsf@HIDDEN> <87ef4v4iii.fsf@HIDDEN>
 <87r28v76pd.fsf@HIDDEN> <874l5r4a9w.fsf@HIDDEN>
 <8736lbuufz.fsf@HIDDEN> <87tvdr2lv9.fsf@HIDDEN>
 <87o93y2x9p.fsf@HIDDEN> <b4mimtdhvvb.fsf@HIDDEN>
 <87d0jk68qw.fsf@HIDDEN>
Organization: Emacsen advocacy group
X-Face: #kKnN,xUnmKia.'[pp`;
 Omh}odZK)?7wQSl"4o04=EixTF+V[""w~iNbM9ZL+.b*_CxUmFk
 B#Fu[*?MZZH@IkN:!"\w%I_zt>[$nm7nQosZ<3eu; B:$Q_:p!',P.c0-_Cy[dz4oIpw0ESA^D*1Lw=
 L&i*6&(
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (x86_64-pc-cygwin)
Cancel-Lock: sha1:t6WNNlb7VvIaPafSfpQD0eXCzu8=
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
X-OutGoing-Spam-Status: No, score=-0.2
X-AuthUser: yamaoka@HIDDEN
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 35383
Cc: 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On Mon, 10 Jun 2019 21:33:59 -0700, Eric Abrahamsen wrote:
> Okay, that should be fixed, thanks.
> I'm getting more testers!

Works fine as before.  Thank you for the fix!




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 11 Jun 2019 04:34:10 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jun 11 00:34:10 2019
Received: from localhost ([127.0.0.1]:57793 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1haYU6-0003cj-9r
	for submit <at> debbugs.gnu.org; Tue, 11 Jun 2019 00:34:10 -0400
Received: from ericabrahamsen.net ([52.70.2.18]:56198
 helo=mail.ericabrahamsen.net)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eric@HIDDEN>) id 1haYU4-0003cP-9t
 for 35383 <at> debbugs.gnu.org; Tue, 11 Jun 2019 00:34:08 -0400
Received: from localhost (75-172-120-8.tukw.qwest.net [75.172.120.8])
 (Authenticated sender: eric@HIDDEN)
 by mail.ericabrahamsen.net (Postfix) with ESMTPSA id 3DAAEFA05C;
 Tue, 11 Jun 2019 04:34:01 +0000 (UTC)
From: Eric Abrahamsen <eric@HIDDEN>
To: Katsumi Yamaoka <yamaoka@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN> <b4mk1fl16oz.fsf@HIDDEN>
 <87sgu87ayo.fsf@HIDDEN> <b4mzhnrw5w6.fsf@HIDDEN>
 <87woiuf6ya.fsf@HIDDEN>
 <87ef4v4iii.fsf@HIDDEN> <87r28v76pd.fsf@HIDDEN>
 <874l5r4a9w.fsf@HIDDEN> <8736lbuufz.fsf@HIDDEN>
 <87tvdr2lv9.fsf@HIDDEN>
 <87o93y2x9p.fsf@HIDDEN> <b4mimtdhvvb.fsf@HIDDEN>
Date: Mon, 10 Jun 2019 21:33:59 -0700
In-Reply-To: <b4mimtdhvvb.fsf@HIDDEN> (Katsumi Yamaoka's message of "Tue, 11
 Jun 2019 08:19:04 +0900")
Message-ID: <87d0jk68qw.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 35383
Cc: 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Katsumi Yamaoka <yamaoka@HIDDEN> writes:

> Ouch!  `gnus-newsrc-alist' in the .newsrc.eld file turned into a
> list of just group names, i.e.:
>
> (setq gnus-newsrc-alist '("nnml:foo" "nnml:bar" "nnml:baz"...))
>
> Ok, I have a backup.  Not investigated it yet sorry, but I guess
> this is due to the recent changes in the scratch/gnus-decoded
> branch.

Okay, that should be fixed, thanks.

I'm getting more testers!

Eric




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 11 Jun 2019 00:04:07 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jun 10 20:04:07 2019
Received: from localhost ([127.0.0.1]:57682 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1haUGk-0003PR-Qf
	for submit <at> debbugs.gnu.org; Mon, 10 Jun 2019 20:04:06 -0400
Received: from ericabrahamsen.net ([52.70.2.18]:47984
 helo=mail.ericabrahamsen.net)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eric@HIDDEN>) id 1haUGj-0003Ox-Dn
 for 35383 <at> debbugs.gnu.org; Mon, 10 Jun 2019 20:04:06 -0400
Received: from localhost (c-73-140-95-250.hsd1.wa.comcast.net [73.140.95.250])
 (Authenticated sender: eric@HIDDEN)
 by mail.ericabrahamsen.net (Postfix) with ESMTPSA id 61012FA07D;
 Tue, 11 Jun 2019 00:03:59 +0000 (UTC)
From: Eric Abrahamsen <eric@HIDDEN>
To: Katsumi Yamaoka <yamaoka@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN> <b4mk1fl16oz.fsf@HIDDEN>
 <87sgu87ayo.fsf@HIDDEN> <b4mzhnrw5w6.fsf@HIDDEN>
 <87woiuf6ya.fsf@HIDDEN>
 <87ef4v4iii.fsf@HIDDEN> <87r28v76pd.fsf@HIDDEN>
 <874l5r4a9w.fsf@HIDDEN> <8736lbuufz.fsf@HIDDEN>
 <87tvdr2lv9.fsf@HIDDEN>
 <87o93y2x9p.fsf@HIDDEN> <b4mimtdhvvb.fsf@HIDDEN>
Date: Mon, 10 Jun 2019 17:03:57 -0700
In-Reply-To: <b4mimtdhvvb.fsf@HIDDEN> (Katsumi Yamaoka's message of "Tue, 11
 Jun 2019 08:19:04 +0900")
Message-ID: <87h88x56oi.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 35383
Cc: 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)


On 06/11/19 08:19 AM, Katsumi Yamaoka wrote:
> Ouch!  `gnus-newsrc-alist' in the .newsrc.eld file turned into a
> list of just group names, i.e.:
>
> (setq gnus-newsrc-alist '("nnml:foo" "nnml:bar" "nnml:baz"...))
>
> Ok, I have a backup.  Not investigated it yet sorry, but I guess
> this is due to the recent changes in the scratch/gnus-decoded
> branch.

Oh yuck, that was a very stupid mistake. I thought I ran this code
before posting... The fix is easy, give me a bit and I'll add another
(tested) commit.

Sorry,
Eric




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 10 Jun 2019 23:19:21 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jun 10 19:19:21 2019
Received: from localhost ([127.0.0.1]:57640 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1haTZQ-0002IP-Ug
	for submit <at> debbugs.gnu.org; Mon, 10 Jun 2019 19:19:21 -0400
Received: from blue.elm.relay.mailchannels.net ([23.83.212.20]:60473)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <yamaoka@HIDDEN>) id 1haTZP-0002IG-JP
 for 35383 <at> debbugs.gnu.org; Mon, 10 Jun 2019 19:19:20 -0400
X-Sender-Id: tih5qno0ow|x-authuser|yamaoka@HIDDEN
Received: from relay.mailchannels.net (localhost [127.0.0.1])
 by relay.mailchannels.net (Postfix) with ESMTP id 1C09E22401;
 Mon, 10 Jun 2019 23:19:18 +0000 (UTC)
Received: from hampton.hostforweb.net
 (100-96-38-146.trex.outbound.svc.cluster.local [100.96.38.146])
 (Authenticated sender: tih5qno0ow)
 by relay.mailchannels.net (Postfix) with ESMTPA id 4091322301;
 Mon, 10 Jun 2019 23:19:17 +0000 (UTC)
X-Sender-Id: tih5qno0ow|x-authuser|yamaoka@HIDDEN
Received: from hampton.hostforweb.net ([TEMPUNAVAIL]. [172.245.115.217])
 (using TLSv1.2 with cipher DHE-RSA-AES256-GCM-SHA384)
 by 0.0.0.0:2500 (trex/5.17.2); Mon, 10 Jun 2019 23:19:18 +0000
X-MC-Relay: Neutral
X-MailChannels-SenderId: tih5qno0ow|x-authuser|yamaoka@HIDDEN
X-MailChannels-Auth-Id: tih5qno0ow
X-Cooperative-Unite: 755d52400112531b_1560208757909_3969488893
X-MC-Loop-Signature: 1560208757909:2415595225
X-MC-Ingress-Time: 1560208757908
Received: from s70.gtokyofl21.vectant.ne.jp ([202.215.75.70]:60000
 helo=localhost) by hampton.hostforweb.net with esmtpsa
 (TLSv1.2:ECDHE-RSA-AES256-GCM-SHA384:256) (Exim 4.89_1)
 (envelope-from <yamaoka@HIDDEN>)
 id 1haTZE-00GSYX-D1; Mon, 10 Jun 2019 18:19:09 -0500
Date: Tue, 11 Jun 2019 08:19:04 +0900
Message-ID: <b4mimtdhvvb.fsf@HIDDEN>
From: Katsumi Yamaoka <yamaoka@HIDDEN>
To: Eric Abrahamsen <eric@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN> <b4mk1fl16oz.fsf@HIDDEN>
 <87sgu87ayo.fsf@HIDDEN> <b4mzhnrw5w6.fsf@HIDDEN>
 <87woiuf6ya.fsf@HIDDEN> <87ef4v4iii.fsf@HIDDEN>
 <87r28v76pd.fsf@HIDDEN> <874l5r4a9w.fsf@HIDDEN>
 <8736lbuufz.fsf@HIDDEN> <87tvdr2lv9.fsf@HIDDEN>
 <87o93y2x9p.fsf@HIDDEN>
Organization: Emacsen advocacy group
X-Face: #kKnN,xUnmKia.'[pp`;
 Omh}odZK)?7wQSl"4o04=EixTF+V[""w~iNbM9ZL+.b*_CxUmFk
 B#Fu[*?MZZH@IkN:!"\w%I_zt>[$nm7nQosZ<3eu; B:$Q_:p!',P.c0-_Cy[dz4oIpw0ESA^D*1Lw=
 L&i*6&(
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (x86_64-pc-cygwin)
Cancel-Lock: sha1:uzD3oEOwkFvuTf0ajK0MAy133V4=
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
X-OutGoing-Spam-Status: No, score=-0.2
X-AuthUser: yamaoka@HIDDEN
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 35383
Cc: 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Ouch!  `gnus-newsrc-alist' in the .newsrc.eld file turned into a
list of just group names, i.e.:

(setq gnus-newsrc-alist '("nnml:foo" "nnml:bar" "nnml:baz"...))

Ok, I have a backup.  Not investigated it yet sorry, but I guess
this is due to the recent changes in the scratch/gnus-decoded
branch.

On Mon, 10 Jun 2019 00:01:39 -0400, Eric Abrahamsen wrote:
> branch: scratch/gnus-decoded
> commit 2e2ed9f8f2b018e681379d0b4d333038dcc29ebb
> Author: Eric Abrahamsen <eric@HIDDEN>
> Commit: Eric Abrahamsen <eric@HIDDEN>

>     Fix/extension to previous commit

>     * lisp/gnus/gnus-start.el (gnus-read-newsrc-el-file): The same
>       decoding needs to be done for group names in gnus-topic-alist.
>       (gnus-gnus-to-quick-newsrc-format): Fix bogus temporary setting of
>       variables; a simply let binding is sufficient.

On Thu, 06 Jun 2019 23:47:59 -0400, Eric Abrahamsen wrote:
> branch: scratch/gnus-decoded
> commit f1c980a979f23676253c71c07a78e4546ee57800
> Author: Eric Abrahamsen <eric@HIDDEN>
> Commit: Eric Abrahamsen <eric@HIDDEN>

>     Preserve group name encoding in newsrc.eld files

>     * lisp/gnus/gnus-start.el (gnus-gnus-to-quick-newsrc-format): Preserve
>       Gnus' earlier odd encoding of group names. Don't change any file
>       formats until it's time to release a new Gnus version.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 19 May 2019 17:02:22 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun May 19 13:02:22 2019
Received: from localhost ([127.0.0.1]:35418 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hSPCY-0006S9-Fd
	for submit <at> debbugs.gnu.org; Sun, 19 May 2019 13:02:22 -0400
Received: from ericabrahamsen.net ([52.70.2.18]:53464
 helo=mail.ericabrahamsen.net)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eric@HIDDEN>) id 1hSPCW-0006Rq-3y
 for 35383 <at> debbugs.gnu.org; Sun, 19 May 2019 13:02:21 -0400
Received: from localhost (97-113-63-69.tukw.qwest.net [97.113.63.69])
 (Authenticated sender: eric@HIDDEN)
 by mail.ericabrahamsen.net (Postfix) with ESMTPSA id 110DEFAF0B;
 Sun, 19 May 2019 17:02:12 +0000 (UTC)
From: Eric Abrahamsen <eric@HIDDEN>
To: "Basil L. Contovounesios" <contovob@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN> <b4mk1fl16oz.fsf@HIDDEN>
 <87sgu87ayo.fsf@HIDDEN> <b4mzhnrw5w6.fsf@HIDDEN>
 <87woiuf6ya.fsf@HIDDEN>
 <87ef4v4iii.fsf@HIDDEN> <87r28v76pd.fsf@HIDDEN>
 <874l5r4a9w.fsf@HIDDEN> <8736lbuufz.fsf@HIDDEN>
 <87tvdr2lv9.fsf@HIDDEN>
Date: Sun, 19 May 2019 10:02:10 -0700
In-Reply-To: <87tvdr2lv9.fsf@HIDDEN> (Eric Abrahamsen's message of
 "Sat, 18 May 2019 19:56:10 -0700")
Message-ID: <87o93y2x9p.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 35383
Cc: Katsumi Yamaoka <yamaoka@HIDDEN>, 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)


On 05/18/19 19:56 PM, Eric Abrahamsen wrote:
> "Basil L. Contovounesios" <contovob@HIDDEN> writes:
>
>> Eric Abrahamsen <eric@HIDDEN> writes:
>>
>>>> I noticed gnus-start.el (already) uses seq.el functions without first
>>>> loading the library, so how about the following minor addendum?
>>>
>>> It does require gnus.el, though, which requires seq, so I figured that
>>> was good enough -- no compiler warnings, anyway.
>>
>> I think it's customary (if not better) for each translation unit to load
>> its own dependencies, without depending on dependencies to do so, but I
>> don't know whether this falls in bikeshedding territory.
>
> I don't know if that's policy, TBH, but in the case of Gnus it would
> result in a fair amount of churn, I'm not sure it's worth it...

Okay, I've pushed this to master.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 19 May 2019 02:57:22 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat May 18 22:57:22 2019
Received: from localhost ([127.0.0.1]:33558 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hSC0o-0000mO-8W
	for submit <at> debbugs.gnu.org; Sat, 18 May 2019 22:57:22 -0400
Received: from ericabrahamsen.net ([52.70.2.18]:35892
 helo=mail.ericabrahamsen.net)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eric@HIDDEN>) id 1hSC0l-0000mB-Q6
 for 35383 <at> debbugs.gnu.org; Sat, 18 May 2019 22:57:20 -0400
Received: from localhost (97-113-63-69.tukw.qwest.net [97.113.63.69])
 (Authenticated sender: eric@HIDDEN)
 by mail.ericabrahamsen.net (Postfix) with ESMTPSA id EBE21FAF0B;
 Sun, 19 May 2019 02:56:56 +0000 (UTC)
From: Eric Abrahamsen <eric@HIDDEN>
To: "Basil L. Contovounesios" <contovob@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
In-Reply-To: <8736lbuufz.fsf@HIDDEN> (Basil L. Contovounesios's message of
 "Sun, 19 May 2019 02:03:28 +0100")
References: <878sw1995f.fsf@HIDDEN> <b4mk1fl16oz.fsf@HIDDEN>
 <87sgu87ayo.fsf@HIDDEN> <b4mzhnrw5w6.fsf@HIDDEN>
 <87woiuf6ya.fsf@HIDDEN>
 <87ef4v4iii.fsf@HIDDEN> <87r28v76pd.fsf@HIDDEN>
 <874l5r4a9w.fsf@HIDDEN> <8736lbuufz.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
Date: Sat, 18 May 2019 19:56:10 -0700
Message-ID: <87tvdr2lv9.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 35383
Cc: Katsumi Yamaoka <yamaoka@HIDDEN>, 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

"Basil L. Contovounesios" <contovob@HIDDEN> writes:

> Eric Abrahamsen <eric@HIDDEN> writes:
>
>>> I noticed gnus-start.el (already) uses seq.el functions without first
>>> loading the library, so how about the following minor addendum?
>>
>> It does require gnus.el, though, which requires seq, so I figured that
>> was good enough -- no compiler warnings, anyway.
>
> I think it's customary (if not better) for each translation unit to load
> its own dependencies, without depending on dependencies to do so, but I
> don't know whether this falls in bikeshedding territory.

I don't know if that's policy, TBH, but in the case of Gnus it would
result in a fair amount of churn, I'm not sure it's worth it...




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 19 May 2019 01:03:39 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat May 18 21:03:39 2019
Received: from localhost ([127.0.0.1]:33405 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hSAEl-0006Yv-28
	for submit <at> debbugs.gnu.org; Sat, 18 May 2019 21:03:39 -0400
Received: from mail-ed1-f67.google.com ([209.85.208.67]:37841)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <contovob@HIDDEN>) id 1hSAEi-0006Yi-W9
 for 35383 <at> debbugs.gnu.org; Sat, 18 May 2019 21:03:38 -0400
Received: by mail-ed1-f67.google.com with SMTP id w37so17282700edw.4
 for <35383 <at> debbugs.gnu.org>; Sat, 18 May 2019 18:03:36 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=tcd-ie.20150623.gappssmtp.com; s=20150623;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version;
 bh=iqE4OcmeG99C4rjOY9hR0ZkCu5rMVNSdD2p93TfXp+o=;
 b=hKTMTfZ12HuwZOwQ6Ay14bm3yCMjuQVUEfiCMkEDxPC7HW0MGlk8FhN2ZjVUTONQHz
 oc5Tv+yszwYVTLOLPCpHMvac6s0w9t+j6BV+8JqmFfgwfy/SCdOmNhAsw0yeav3xjeHk
 8AUmv0uyu5fJX3uBO4EivEvEGjrLYgE38RIAAgmSYm/ns4ebLE0ZGUxRyckdbcMNFY1U
 sPtke/t1FelKqqS9Mc09SsIVsIaVnGbfhLhQI07yCpw5Jq7Seaz1v4QshugctRtl5YCh
 jlsNLQlFGKujP+c1KucqeuEiEAbT9Apq3RAK+eWjO1+tAYMDtEEIrGiq5mjjhijC/sio
 tXlA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:user-agent:mime-version;
 bh=iqE4OcmeG99C4rjOY9hR0ZkCu5rMVNSdD2p93TfXp+o=;
 b=PUQoxgIuVnXkiD9VN8v5I7HVshQc05YAW9Z4J9/G2iAjiQZ+bUlxi9Z3Rdn9nQY3fN
 Q93Aa9JMsh//5Ftm3pgdbKqOan9sCyzbisGFBciw+f9tpQ5FNlHSad7QTsypMfOZMacA
 zRBy4RS1Wpu+3bigrfcm4OVbrlDUCBNdwBLmIUgRIkI1lxuUNH+9vhaegV7G3beJuZNp
 wI1w7k9OtN4A2JRd8yLmpoLEXamzb6QZwa1UhNzbg6PDoU0Cr6uGpcSTIY+sAy1A59gH
 63zfQY7BboqfEZMI5GcEBfI3bm4Jhl748RRKCoA41jlIHYMPiUzqxDYzv7xqkJUgN5pT
 y7gg==
X-Gm-Message-State: APjAAAU01CGrn+8fqHMe5v3Wf1/xllQ5ffgYRye7VsNaoimvtwWOfJ7n
 +HtBzhHWJcCIgOYsYx2LRXAqfQ==
X-Google-Smtp-Source: APXvYqwUbsnDAfaDT5pq8OnkTIq/wuAgYInrc9Ofwoh8TZ6KajjeCtgmDtsgyrmKat1XUicTFBvS9A==
X-Received: by 2002:a50:9987:: with SMTP id m7mr64669809edb.286.1558227811094; 
 Sat, 18 May 2019 18:03:31 -0700 (PDT)
Received: from localhost ([2a02:8084:20e2:c380:8cad:ae29:555d:852d])
 by smtp.gmail.com with ESMTPSA id r3sm2403536ejb.88.2019.05.18.18.03.29
 (version=TLS1_3 cipher=AEAD-AES256-GCM-SHA384 bits=256/256);
 Sat, 18 May 2019 18:03:30 -0700 (PDT)
From: "Basil L. Contovounesios" <contovob@HIDDEN>
To: Eric Abrahamsen <eric@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN> <b4mk1fl16oz.fsf@HIDDEN>
 <87sgu87ayo.fsf@HIDDEN> <b4mzhnrw5w6.fsf@HIDDEN>
 <87woiuf6ya.fsf@HIDDEN>
 <87ef4v4iii.fsf@HIDDEN> <87r28v76pd.fsf@HIDDEN>
 <874l5r4a9w.fsf@HIDDEN>
Date: Sun, 19 May 2019 02:03:28 +0100
In-Reply-To: <874l5r4a9w.fsf@HIDDEN> (Eric Abrahamsen's message of
 "Sat, 18 May 2019 16:23:39 -0700")
Message-ID: <8736lbuufz.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 35383
Cc: Katsumi Yamaoka <yamaoka@HIDDEN>, 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eric Abrahamsen <eric@HIDDEN> writes:

>> I noticed gnus-start.el (already) uses seq.el functions without first
>> loading the library, so how about the following minor addendum?
>
> It does require gnus.el, though, which requires seq, so I figured that
> was good enough -- no compiler warnings, anyway.

I think it's customary (if not better) for each translation unit to load
its own dependencies, without depending on dependencies to do so, but I
don't know whether this falls in bikeshedding territory.

>> (defun gnus-subscribe-alphabetically (newgroup)
>> "Subscribe new NEWGROUP and insert it in alphabetical order."
>> - (let ((groups (cdr gnus-group-list))
>> - before)
>> - (while (and (not before) groups)
>> - (if (string< newgroup (car groups))
>> - (setq before (car groups))
>> - (setq groups (cdr groups))))
>> + (let ((before (seq-find (lambda (group)
>> + (string< newgroup group))
>> + (cdr gnus-group-list))))
>> (gnus-subscribe-newsgroup newgroup before)))
>
> Looks fine to me! I'll just add this to the patch?

Yes please, thanks,

-- 
Basil




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 18 May 2019 23:24:52 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat May 18 19:24:52 2019
Received: from localhost ([127.0.0.1]:33236 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hS8h9-0004E0-V0
	for submit <at> debbugs.gnu.org; Sat, 18 May 2019 19:24:52 -0400
Received: from ericabrahamsen.net ([52.70.2.18]:59536
 helo=mail.ericabrahamsen.net)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eric@HIDDEN>) id 1hS8h7-0004Dn-Iu
 for 35383 <at> debbugs.gnu.org; Sat, 18 May 2019 19:24:50 -0400
Received: from localhost (97-113-41-227.tukw.qwest.net [97.113.41.227])
 (Authenticated sender: eric@HIDDEN)
 by mail.ericabrahamsen.net (Postfix) with ESMTPSA id ABB6EFAF0B;
 Sat, 18 May 2019 23:24:29 +0000 (UTC)
From: Eric Abrahamsen <eric@HIDDEN>
To: "Basil L. Contovounesios" <contovob@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
In-Reply-To: <87r28v76pd.fsf@HIDDEN> (Basil L. Contovounesios's message of
 "Sat, 18 May 2019 23:12:30 +0100")
References: <878sw1995f.fsf@HIDDEN> <b4mk1fl16oz.fsf@HIDDEN>
 <87sgu87ayo.fsf@HIDDEN> <b4mzhnrw5w6.fsf@HIDDEN>
 <87woiuf6ya.fsf@HIDDEN>
 <87ef4v4iii.fsf@HIDDEN> <87r28v76pd.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
Date: Sat, 18 May 2019 16:23:39 -0700
Message-ID: <874l5r4a9w.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 35383
Cc: Katsumi Yamaoka <yamaoka@HIDDEN>, 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

"Basil L. Contovounesios" <contovob@HIDDEN> writes:

> Eric Abrahamsen <eric@HIDDEN> writes:
>
>> The attached patch should go into master, and then master merged into
>> scratch/gnus-decoded.
>
> [...]
>
>> diff --git a/lisp/gnus/gnus-start.el b/lisp/gnus/gnus-start.el
>> index 2f8a260bf1..16d167613e 100644
>> --- a/lisp/gnus/gnus-start.el
>> +++ b/lisp/gnus/gnus-start.el
>> @@ -583,11 +583,11 @@ gnus-subscribe-randomly
>>  
>>  (defun gnus-subscribe-alphabetically (newgroup)
>>    "Subscribe new NEWGROUP and insert it in alphabetical order."
>> -  (let ((groups (cdr gnus-newsrc-alist))
>> +  (let ((groups (cdr gnus-group-list))
>>  	before)
>>      (while (and (not before) groups)
>> -      (if (string< newgroup (caar groups))
>> -	  (setq before (caar groups))
>> +      (if (string< newgroup (car groups))
>> +	  (setq before (car groups))
>>  	(setq groups (cdr groups))))
>>      (gnus-subscribe-newsgroup newgroup before)))
>
> I noticed gnus-start.el (already) uses seq.el functions without first
> loading the library, so how about the following minor addendum?

It does require gnus.el, though, which requires seq, so I figured that
was good enough -- no compiler warnings, anyway.

> (defun gnus-subscribe-alphabetically (newgroup)
> "Subscribe new NEWGROUP and insert it in alphabetical order."
> - (let ((groups (cdr gnus-group-list))
> - before)
> - (while (and (not before) groups)
> - (if (string< newgroup (car groups))
> - (setq before (car groups))
> - (setq groups (cdr groups))))
> + (let ((before (seq-find (lambda (group)
> + (string< newgroup group))
> + (cdr gnus-group-list))))
> (gnus-subscribe-newsgroup newgroup before)))

Looks fine to me! I'll just add this to the patch?

Thanks,
Eric




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 18 May 2019 22:12:44 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat May 18 18:12:44 2019
Received: from localhost ([127.0.0.1]:33135 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hS7ZJ-0002RT-5Y
	for submit <at> debbugs.gnu.org; Sat, 18 May 2019 18:12:44 -0400
Received: from mail-ed1-f66.google.com ([209.85.208.66]:45429)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <contovob@HIDDEN>) id 1hS7ZG-0002RD-MH
 for 35383 <at> debbugs.gnu.org; Sat, 18 May 2019 18:12:39 -0400
Received: by mail-ed1-f66.google.com with SMTP id g57so16767499edc.12
 for <35383 <at> debbugs.gnu.org>; Sat, 18 May 2019 15:12:38 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=tcd-ie.20150623.gappssmtp.com; s=20150623;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version;
 bh=T0+5vHmCIS0rQzT3CE1qaKnJqqWECg+eHEXAlr6Ttx8=;
 b=tuewjN8OEN2bv3fRT9fB0ASheO665K0M/3aT9eXCFL6vG732PAl0+a/Z6ZjuC+JTNh
 a0oI+ooG+vuEtKsstqpyGBg3lj0NTM3YVchwFpFOtGq+GnEkwGes8adOSKSr3MqrMFVj
 h+jqPObI/wwSGQMB0rLYj3VwEIVUl4cRi1WV5eMXH1XMo37vvG/cwaMSUVp/opX32asU
 No73pbU8y0mamUK/VltmcjUuNYOjjsufL5LnBwJNxO8SmgMy0NZifJV/K2Z49uNyPeWh
 xrAKrcsMVeAxR4a6BPzjlPUYav1C7Bs1uxBWvdNkn8+oNmkoriMlzVeDkn2YraJMIdhD
 JXlg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:user-agent:mime-version;
 bh=T0+5vHmCIS0rQzT3CE1qaKnJqqWECg+eHEXAlr6Ttx8=;
 b=phYBaKH0cuWeppFMIdTAMuhfqFN0OFzFPZBjU4b0W3VBXodgz6mCnSXuC/QW28hM5f
 E7IRTsUrfov8jpqe8yw/JdooxF2f+dDzVSzru0tTfDSuGSRHptPWUb8pHLncd743tGks
 ChDYueywzJTe6Q1c0Ot9zWpGBqzy8Mm5QoS9B89IPgtc/wOgq+xUPwCNImTikFARSh9C
 eE/9ahez/CWsy/JkeNl4tSWMoKUqfsbv+Miiz6TgfDonUWzZYpkYwWundHe9/4i/4ZRG
 1pys4vNlBXEvO5bJwPcuFuCHFyzYLNRIMt9p9IgW1FNwuHEXyUjowviaPq/H0dxkwCtN
 DBMg==
X-Gm-Message-State: APjAAAViGRXr8huJT7pQVov7qK6CfE+pigGJoDclELTUy4LoTQwHoGeL
 3awZzeGTuMXeXr5kT9kEsI4Iiw==
X-Google-Smtp-Source: APXvYqyMTEcsoP3HWSrKAaCFqlAcAtA6SczWVAIDFmj8myuIuxadsRtyYuSc1DwzS+UpLoQ46JRW3A==
X-Received: by 2002:a50:a389:: with SMTP id s9mr65229642edb.113.1558217552931; 
 Sat, 18 May 2019 15:12:32 -0700 (PDT)
Received: from localhost ([2a02:8084:20e2:c380:8cad:ae29:555d:852d])
 by smtp.gmail.com with ESMTPSA id h4sm2362021ejx.81.2019.05.18.15.12.31
 (version=TLS1_3 cipher=AEAD-AES256-GCM-SHA384 bits=256/256);
 Sat, 18 May 2019 15:12:31 -0700 (PDT)
From: "Basil L. Contovounesios" <contovob@HIDDEN>
To: Eric Abrahamsen <eric@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN> <b4mk1fl16oz.fsf@HIDDEN>
 <87sgu87ayo.fsf@HIDDEN> <b4mzhnrw5w6.fsf@HIDDEN>
 <87woiuf6ya.fsf@HIDDEN>
 <87ef4v4iii.fsf@HIDDEN>
Date: Sat, 18 May 2019 23:12:30 +0100
In-Reply-To: <87ef4v4iii.fsf@HIDDEN> (Eric Abrahamsen's message of
 "Sat, 18 May 2019 13:25:41 -0700")
Message-ID: <87r28v76pd.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 35383
Cc: Katsumi Yamaoka <yamaoka@HIDDEN>, 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--=-=-=
Content-Type: text/plain

Eric Abrahamsen <eric@HIDDEN> writes:

> The attached patch should go into master, and then master merged into
> scratch/gnus-decoded.

[...]

> diff --git a/lisp/gnus/gnus-start.el b/lisp/gnus/gnus-start.el
> index 2f8a260bf1..16d167613e 100644
> --- a/lisp/gnus/gnus-start.el
> +++ b/lisp/gnus/gnus-start.el
> @@ -583,11 +583,11 @@ gnus-subscribe-randomly
>  
>  (defun gnus-subscribe-alphabetically (newgroup)
>    "Subscribe new NEWGROUP and insert it in alphabetical order."
> -  (let ((groups (cdr gnus-newsrc-alist))
> +  (let ((groups (cdr gnus-group-list))
>  	before)
>      (while (and (not before) groups)
> -      (if (string< newgroup (caar groups))
> -	  (setq before (caar groups))
> +      (if (string< newgroup (car groups))
> +	  (setq before (car groups))
>  	(setq groups (cdr groups))))
>      (gnus-subscribe-newsgroup newgroup before)))

I noticed gnus-start.el (already) uses seq.el functions without first
loading the library, so how about the following minor addendum?


--=-=-=
Content-Type: text/x-diff
Content-Disposition: inline; filename=gnus-start.diff

diff --git a/lisp/gnus/gnus-start.el b/lisp/gnus/gnus-start.el
index 16d167613e..c1e55e4e25 100644
--- a/lisp/gnus/gnus-start.el
+++ b/lisp/gnus/gnus-start.el
@@ -31,6 +31,7 @@
 (require 'gnus-range)
 (require 'gnus-util)
 (require 'gnus-cloud)
+(require 'seq)
 (autoload 'message-make-date "message")
 (autoload 'gnus-agent-read-servers-validate "gnus-agent")
 (autoload 'gnus-agent-save-local "gnus-agent")
@@ -583,12 +584,9 @@ gnus-subscribe-randomly
 
 (defun gnus-subscribe-alphabetically (newgroup)
   "Subscribe new NEWGROUP and insert it in alphabetical order."
-  (let ((groups (cdr gnus-group-list))
-	before)
-    (while (and (not before) groups)
-      (if (string< newgroup (car groups))
-	  (setq before (car groups))
-	(setq groups (cdr groups))))
+  (let ((before (seq-find (lambda (group)
+                            (string< newgroup group))
+                          (cdr gnus-group-list))))
     (gnus-subscribe-newsgroup newgroup before)))
 
 (defun gnus-subscribe-hierarchically (newgroup)

--=-=-=
Content-Type: text/plain


Thanks,

-- 
Basil

--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 18 May 2019 20:25:52 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat May 18 16:25:52 2019
Received: from localhost ([127.0.0.1]:33032 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hS5tv-0005r9-Un
	for submit <at> debbugs.gnu.org; Sat, 18 May 2019 16:25:52 -0400
Received: from ericabrahamsen.net ([52.70.2.18]:55666
 helo=mail.ericabrahamsen.net)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eric@HIDDEN>) id 1hS5tu-0005qw-85
 for 35383 <at> debbugs.gnu.org; Sat, 18 May 2019 16:25:51 -0400
Received: from localhost (97-113-32-199.tukw.qwest.net [97.113.32.199])
 (Authenticated sender: eric@HIDDEN)
 by mail.ericabrahamsen.net (Postfix) with ESMTPSA id DD2D8FA625;
 Sat, 18 May 2019 20:25:42 +0000 (UTC)
From: Eric Abrahamsen <eric@HIDDEN>
To: Katsumi Yamaoka <yamaoka@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN> <b4mk1fl16oz.fsf@HIDDEN>
 <87sgu87ayo.fsf@HIDDEN> <b4mzhnrw5w6.fsf@HIDDEN>
 <87woiuf6ya.fsf@HIDDEN>
Date: Sat, 18 May 2019 13:25:41 -0700
In-Reply-To: <87woiuf6ya.fsf@HIDDEN> (Eric Abrahamsen's message of
 "Mon, 13 May 2019 13:14:05 -0700")
Message-ID: <87ef4v4iii.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 35383
Cc: 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

--=-=-=
Content-Type: text/plain

Eric Abrahamsen <eric@HIDDEN> writes:

> Katsumi Yamaoka <yamaoka@HIDDEN> writes:
>
>>> On 04/23/19 17:12 PM, Katsumi Yamaoka wrote:
>>>> Though I'm not quite sure
>>>> yet, the new and the old newsrc.eld files (containing non-ASCII
>>>> nnml and nnrss groups) seem to be compatible with the new and
>>>> the old Gnus mutually.
>>
>> Not mutually but one-way from old Gnus[1] to new Gnus[2] is ok.
>> To activate the groups of the non-ASCII names for the old Gnus,
>> I realized I needed to convert those group names to that of
>>
>> (prin1-to-string (encode-coding-string "Group Name" 'utf-8))
>>
>> one by one in the .newsrc.eld file before starting the old Gnus.
>> No other tweak is necessary to switch back to the old Gnus, and
>> nothing to be done to switch to the new Gnus again.  I verified
>> it with only nnml and nnrss groups as I tried Gnus of the latest
>> git master today for the first time in about a month.
>>
>> [1] currently that of the master and the emacs-26 branches
>> [2] currentlt that of the scratch/gnus-decoded branch
>
> Thanks for the analysis. I think I only had nnimap groups that were
> properly (utf-8) encoded in .newsrc.eld, but still worked with the "old"
> Gnus code (in your sense, above). I guess that was different with
> nnml/nnrss.
>
> I have some more group sorting issues to fix in the current master code,
> then I'll call for testers for the scratch/gnus-decoded branch, then
> hopefully this whole thing can go in.

Before that, I realized that I hadn't updated some of the *Group* buffer
sorting code, for sorting flat groups. The attached patch should go into
master, and then master merged into scratch/gnus-decoded.

Eric


--=-=-=
Content-Type: text/x-patch
Content-Disposition: attachment; filename=gnus-group-sorting.diff

diff --git a/lisp/gnus/gnus-group.el b/lisp/gnus/gnus-group.el
index c757c82fbc..4a14de33b0 100644
--- a/lisp/gnus/gnus-group.el
+++ b/lisp/gnus/gnus-group.el
@@ -3300,21 +3300,31 @@ gnus-group-sort-groups
   (funcall gnus-group-sort-alist-function
 	   (gnus-make-sort-function func) reverse)
   (gnus-group-unmark-all-groups)
+  ;; Redisplay all groups according to the newly-sorted order of
+  ;; `gnus-group-list'.
   (gnus-group-list-groups)
   (gnus-dribble-touch))
 
 (defun gnus-group-sort-flat (func reverse)
-  ;; We peel off the dummy group from the alist.
+  "Sort groups in a flat list using sorting function FUNC.
+If REVERSE is non-nil, reverse the sort order.
+
+This function sets a new value for `gnus-group-list'; its return
+value is disregarded."
   (when func
-    (when (equal (gnus-info-group (car gnus-newsrc-alist)) "dummy.group")
-      (pop gnus-newsrc-alist))
-    ;; Do the sorting.
-    (setq gnus-newsrc-alist
-	  (sort gnus-newsrc-alist func))
-    (when reverse
-      (setq gnus-newsrc-alist (nreverse gnus-newsrc-alist)))
-    ;; Regenerate the hash table.
-    (gnus-make-hashtable-from-newsrc-alist)))
+    (let* ((groups (remove "dummy.group" gnus-group-list))
+	   (sorted-infos
+	    (sort (mapcar (lambda (g)
+			    (gnus-get-info g))
+			  groups)
+		  func)))
+      (setq gnus-group-list
+	    (mapcar (lambda (i)
+		      (gnus-info-group i))
+		    sorted-infos))
+      (when reverse
+	(setq gnus-group-list (nreverse gnus-group-list)))
+      (setq gnus-group-list (cons "dummy.group" gnus-group-list)))))
 
 (defun gnus-group-sort-groups-by-alphabet (&optional reverse)
   "Sort the group buffer alphabetically by group name.
@@ -3377,27 +3387,26 @@ gnus-group-sort-selected-groups
     (gnus-dribble-touch)))
 
 (defun gnus-group-sort-selected-flat (groups func reverse)
-  (let (entries infos)
-    ;; First find all the group entries for these groups.
-    (while groups
-      (push (nthcdr 2 (gnus-group-entry (pop groups)))
-	    entries))
-    ;; Then sort the infos.
-    (setq infos
-	  (sort
-	   (mapcar
-	    (lambda (entry) (car entry))
-	    (setq entries (nreverse entries)))
-	   func))
+  "Sort only the selected GROUPS, using FUNC.
+If REVERSE is non-nil, reverse the sorting."
+  (let ((infos (sort
+		(mapcar (lambda (g)
+			  (gnus-get-info g))
+			groups)
+		func))
+	sorted-groups)
     (when reverse
       (setq infos (nreverse infos)))
-    ;; Go through all the infos and replace the old entries
-    ;; with the new infos.
-    (while infos
-      (setcar (car entries) (pop infos))
-      (pop entries))
-    ;; Update the hashtable.
-    (gnus-make-hashtable-from-newsrc-alist)))
+    (setq sorted-groups (mapcar (lambda (i) (gnus-info-group i)) infos))
+
+    ;; Find the original locations of GROUPS in `gnus-group-list', and
+    ;; replace each one, in order, with a group from SORTED-GROUPS.
+    (dolist (i (sort (mapcar (lambda (g)
+			       (seq-position gnus-group-list g))
+			     groups)
+		     #'<))
+      (setf (nth i gnus-group-list)
+	    (pop sorted-groups)))))
 
 (defun gnus-group-sort-selected-groups-by-alphabet (&optional n reverse)
   "Sort the group buffer alphabetically by group name.
diff --git a/lisp/gnus/gnus-start.el b/lisp/gnus/gnus-start.el
index 2f8a260bf1..16d167613e 100644
--- a/lisp/gnus/gnus-start.el
+++ b/lisp/gnus/gnus-start.el
@@ -583,11 +583,11 @@ gnus-subscribe-randomly
 
 (defun gnus-subscribe-alphabetically (newgroup)
   "Subscribe new NEWGROUP and insert it in alphabetical order."
-  (let ((groups (cdr gnus-newsrc-alist))
+  (let ((groups (cdr gnus-group-list))
 	before)
     (while (and (not before) groups)
-      (if (string< newgroup (caar groups))
-	  (setq before (caar groups))
+      (if (string< newgroup (car groups))
+	  (setq before (car groups))
 	(setq groups (cdr groups))))
     (gnus-subscribe-newsgroup newgroup before)))
 
@@ -618,15 +618,15 @@ gnus-subscribe-interactively
 it is killed."
   (if (gnus-y-or-n-p (format "Subscribe new newsgroup %s? " group))
       (gnus-subscribe-hierarchically group)
-    (push group gnus-killed-list)))
+    (gnus-subscribe-killed group)))
 
 (defun gnus-subscribe-zombies (group)
   "Make the new GROUP into a zombie group."
-  (push group gnus-zombie-list))
+  (cl-pushnew group gnus-zombie-list :test #'equal))
 
 (defun gnus-subscribe-killed (group)
   "Make the new GROUP a killed group."
-  (push group gnus-killed-list))
+  (cl-pushnew group gnus-killed-list :test #'equal))
 
 (defun gnus-subscribe-newsgroup (newsgroup &optional next)
   "Subscribe new NEWSGROUP.

--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 13 May 2019 20:14:14 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon May 13 16:14:14 2019
Received: from localhost ([127.0.0.1]:46391 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hQHKw-0001uM-9W
	for submit <at> debbugs.gnu.org; Mon, 13 May 2019 16:14:14 -0400
Received: from ericabrahamsen.net ([52.70.2.18]:57262
 helo=mail.ericabrahamsen.net)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eric@HIDDEN>) id 1hQHKu-0001u7-Nk
 for 35383 <at> debbugs.gnu.org; Mon, 13 May 2019 16:14:13 -0400
Received: from localhost (50-251-205-17-static.hfc.comcastbusiness.net
 [50.251.205.17]) (Authenticated sender: eric@HIDDEN)
 by mail.ericabrahamsen.net (Postfix) with ESMTPSA id 3F484FA021;
 Mon, 13 May 2019 20:14:06 +0000 (UTC)
From: Eric Abrahamsen <eric@HIDDEN>
To: Katsumi Yamaoka <yamaoka@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN> <b4mk1fl16oz.fsf@HIDDEN>
 <87sgu87ayo.fsf@HIDDEN> <b4mzhnrw5w6.fsf@HIDDEN>
Date: Mon, 13 May 2019 13:14:05 -0700
In-Reply-To: <b4mzhnrw5w6.fsf@HIDDEN> (Katsumi Yamaoka's message of "Mon, 13
 May 2019 09:32:41 +0900")
Message-ID: <87woiuf6ya.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 35383
Cc: 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Katsumi Yamaoka <yamaoka@HIDDEN> writes:

>> On 04/23/19 17:12 PM, Katsumi Yamaoka wrote:
>>> Though I'm not quite sure
>>> yet, the new and the old newsrc.eld files (containing non-ASCII
>>> nnml and nnrss groups) seem to be compatible with the new and
>>> the old Gnus mutually.
>
> Not mutually but one-way from old Gnus[1] to new Gnus[2] is ok.
> To activate the groups of the non-ASCII names for the old Gnus,
> I realized I needed to convert those group names to that of
>
> (prin1-to-string (encode-coding-string "Group Name" 'utf-8))
>
> one by one in the .newsrc.eld file before starting the old Gnus.
> No other tweak is necessary to switch back to the old Gnus, and
> nothing to be done to switch to the new Gnus again.  I verified
> it with only nnml and nnrss groups as I tried Gnus of the latest
> git master today for the first time in about a month.
>
> [1] currently that of the master and the emacs-26 branches
> [2] currentlt that of the scratch/gnus-decoded branch

Thanks for the analysis. I think I only had nnimap groups that were
properly (utf-8) encoded in .newsrc.eld, but still worked with the "old"
Gnus code (in your sense, above). I guess that was different with
nnml/nnrss.

I have some more group sorting issues to fix in the current master code,
then I'll call for testers for the scratch/gnus-decoded branch, then
hopefully this whole thing can go in.

Thanks again,
Eric




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 13 May 2019 00:32:55 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun May 12 20:32:55 2019
Received: from localhost ([127.0.0.1]:43752 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hPytj-0002tA-Ap
	for submit <at> debbugs.gnu.org; Sun, 12 May 2019 20:32:55 -0400
Received: from bonobo.maple.relay.mailchannels.net ([23.83.214.22]:29775)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <yamaoka@HIDDEN>) id 1hPyth-0002sy-Ky
 for 35383 <at> debbugs.gnu.org; Sun, 12 May 2019 20:32:54 -0400
X-Sender-Id: tih5qno0ow|x-authuser|yamaoka@HIDDEN
Received: from relay.mailchannels.net (localhost [127.0.0.1])
 by relay.mailchannels.net (Postfix) with ESMTP id 5EEDF1A07CF;
 Mon, 13 May 2019 00:32:52 +0000 (UTC)
Received: from hampton.hostforweb.net
 (100-96-38-7.trex.outbound.svc.cluster.local [100.96.38.7])
 (Authenticated sender: tih5qno0ow)
 by relay.mailchannels.net (Postfix) with ESMTPA id 91AF81A0A04;
 Mon, 13 May 2019 00:32:51 +0000 (UTC)
X-Sender-Id: tih5qno0ow|x-authuser|yamaoka@HIDDEN
Received: from hampton.hostforweb.net ([TEMPUNAVAIL]. [172.245.115.217])
 (using TLSv1.2 with cipher DHE-RSA-AES256-GCM-SHA384)
 by 0.0.0.0:2500 (trex/5.17.2); Mon, 13 May 2019 00:32:52 +0000
X-MC-Relay: Neutral
X-MailChannels-SenderId: tih5qno0ow|x-authuser|yamaoka@HIDDEN
X-MailChannels-Auth-Id: tih5qno0ow
X-Absorbed-Battle: 1c6e747c16797a71_1557707572182_3639794979
X-MC-Loop-Signature: 1557707572181:577460786
X-MC-Ingress-Time: 1557707572181
Received: from s70.gtokyofl21.vectant.ne.jp ([202.215.75.70]:60000
 helo=localhost) by hampton.hostforweb.net with esmtpsa
 (TLSv1.2:ECDHE-RSA-AES256-GCM-SHA384:256) (Exim 4.89_1)
 (envelope-from <yamaoka@HIDDEN>)
 id 1hPytW-00HFTu-BC; Sun, 12 May 2019 19:32:43 -0500
Date: Mon, 13 May 2019 09:32:41 +0900
Message-ID: <b4mzhnrw5w6.fsf@HIDDEN>
From: Katsumi Yamaoka <yamaoka@HIDDEN>
To: Eric Abrahamsen <eric@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN> <b4mk1fl16oz.fsf@HIDDEN>
 <87sgu87ayo.fsf@HIDDEN>
Organization: Emacsen advocacy group
X-Face: #kKnN,xUnmKia.'[pp`;
 Omh}odZK)?7wQSl"4o04=EixTF+V[""w~iNbM9ZL+.b*_CxUmFk
 B#Fu[*?MZZH@IkN:!"\w%I_zt>[$nm7nQosZ<3eu; B:$Q_:p!',P.c0-_Cy[dz4oIpw0ESA^D*1Lw=
 L&i*6&(
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (x86_64-pc-cygwin)
Cancel-Lock: sha1:BWXMvwozQBALbzHRfurluEO28Hc=
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
X-OutGoing-Spam-Status: No, score=-0.2
X-AuthUser: yamaoka@HIDDEN
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 35383
Cc: 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

> On 04/23/19 17:12 PM, Katsumi Yamaoka wrote:
>> Though I'm not quite sure
>> yet, the new and the old newsrc.eld files (containing non-ASCII
>> nnml and nnrss groups) seem to be compatible with the new and
>> the old Gnus mutually.

Not mutually but one-way from old Gnus[1] to new Gnus[2] is ok.
To activate the groups of the non-ASCII names for the old Gnus,
I realized I needed to convert those group names to that of

(prin1-to-string (encode-coding-string "Group Name" 'utf-8))

one by one in the .newsrc.eld file before starting the old Gnus.
No other tweak is necessary to switch back to the old Gnus, and
nothing to be done to switch to the new Gnus again.  I verified
it with only nnml and nnrss groups as I tried Gnus of the latest
git master today for the first time in about a month.

[1] currently that of the master and the emacs-26 branches
[2] currentlt that of the scratch/gnus-decoded branch

;; I can switch them by adding site-lisp/gnus (new) to load-path.

Regards,




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 30 Apr 2019 18:17:35 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Apr 30 14:17:35 2019
Received: from localhost ([127.0.0.1]:42383 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hLXJv-0008ME-D2
	for submit <at> debbugs.gnu.org; Tue, 30 Apr 2019 14:17:35 -0400
Received: from ericabrahamsen.net ([52.70.2.18]:50828
 helo=mail.ericabrahamsen.net)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eric@HIDDEN>) id 1hLXJs-0008M1-Oz
 for 35383 <at> debbugs.gnu.org; Tue, 30 Apr 2019 14:17:33 -0400
Received: from localhost (97-113-61-17.tukw.qwest.net [97.113.61.17])
 (Authenticated sender: eric@HIDDEN)
 by mail.ericabrahamsen.net (Postfix) with ESMTPSA id 72E4FFA027;
 Tue, 30 Apr 2019 18:17:26 +0000 (UTC)
From: Eric Abrahamsen <eric@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN> <b4mk1fl16oz.fsf@HIDDEN>
 <87sgu87ayo.fsf@HIDDEN> <b4md0lb4ykk.fsf@HIDDEN>
 <87k1fj49o2.fsf@HIDDEN> <b4m5zr3hsn0.fsf@HIDDEN>
 <87bm0uhxqy.fsf@HIDDEN> <b4ma7gd2vg8.fsf@HIDDEN>
 <87d0l5ihgr.fsf@HIDDEN>
 <878svtihdw.fsf@HIDDEN> <835zqwu8cq.fsf@HIDDEN>
 <87sgu0h92o.fsf@HIDDEN> <83wojcrvu3.fsf@HIDDEN>
 <87muk7fmrx.fsf@HIDDEN> <83wojbquz0.fsf@HIDDEN>
 <87ftpzfm2i.fsf@HIDDEN> <83pnp3qtfc.fsf@HIDDEN>
Date: Tue, 30 Apr 2019 11:17:22 -0700
In-Reply-To: <83pnp3qtfc.fsf@HIDDEN> (Eli Zaretskii's message of "Tue, 30 Apr
 2019 20:44:39 +0300")
Message-ID: <87y33re4st.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 35383
Cc: yamaoka@HIDDEN, 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> From: Eric Abrahamsen <eric@HIDDEN>
>> Cc: yamaoka@HIDDEN,  35383 <at> debbugs.gnu.org
>> Date: Tue, 30 Apr 2019 10:19:01 -0700
>>=20
>> > You could give up the cookie.  It is only important if the file is
>> > visited by "C-x C-f" etc., which will be rare.  So having a cookie is
>> > a nicety, not a requirement.
>>=20
>> Right, I think that was the conclusion. But do you have any other advice
>> about making sure that files previously written as 'raw-text are read
>> correctly by the updated code? It works on my machine=E2=84=A2, but is t=
hat just
>> because my locale is unicode?
>
> It depends on whether the buffer saved to that file included raw-bytes
> (it generally shouldn't).  If not, then there will be no problem.  If
> there were raw-bytes, you cannot win, so I wouldn't bother about that
> case.

Good enough for me! I will swap the defaults to 'utf-8-emacs and push to
the branch -- I haven't gotten to the stage of calling for testers yet,
so with any luck we can still flush out some bugs.

Thanks,
Eric




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 30 Apr 2019 17:44:59 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Apr 30 13:44:59 2019
Received: from localhost ([127.0.0.1]:42335 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hLWoN-0007Xr-EN
	for submit <at> debbugs.gnu.org; Tue, 30 Apr 2019 13:44:59 -0400
Received: from eggs.gnu.org ([209.51.188.92]:38088)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1hLWoL-0007Xc-V8
 for 35383 <at> debbugs.gnu.org; Tue, 30 Apr 2019 13:44:58 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:51599)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1hLWoG-0006fz-7V; Tue, 30 Apr 2019 13:44:52 -0400
Received: from [176.228.60.248] (port=1077 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1hLWoE-0004UV-Cm; Tue, 30 Apr 2019 13:44:51 -0400
Date: Tue, 30 Apr 2019 20:44:39 +0300
Message-Id: <83pnp3qtfc.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Eric Abrahamsen <eric@HIDDEN>
In-reply-to: <87ftpzfm2i.fsf@HIDDEN> (message from Eric Abrahamsen
 on Tue, 30 Apr 2019 10:19:01 -0700)
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN> <b4mk1fl16oz.fsf@HIDDEN>
 <87sgu87ayo.fsf@HIDDEN> <b4md0lb4ykk.fsf@HIDDEN>
 <87k1fj49o2.fsf@HIDDEN> <b4m5zr3hsn0.fsf@HIDDEN>
 <87bm0uhxqy.fsf@HIDDEN> <b4ma7gd2vg8.fsf@HIDDEN>
 <87d0l5ihgr.fsf@HIDDEN>
 <878svtihdw.fsf@HIDDEN> <835zqwu8cq.fsf@HIDDEN>
 <87sgu0h92o.fsf@HIDDEN> <83wojcrvu3.fsf@HIDDEN>
 <87muk7fmrx.fsf@HIDDEN> <83wojbquz0.fsf@HIDDEN>
 <87ftpzfm2i.fsf@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 35383
Cc: yamaoka@HIDDEN, 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Eric Abrahamsen <eric@HIDDEN>
> Cc: yamaoka@HIDDEN,  35383 <at> debbugs.gnu.org
> Date: Tue, 30 Apr 2019 10:19:01 -0700
> 
> > You could give up the cookie.  It is only important if the file is
> > visited by "C-x C-f" etc., which will be rare.  So having a cookie is
> > a nicety, not a requirement.
> 
> Right, I think that was the conclusion. But do you have any other advice
> about making sure that files previously written as 'raw-text are read
> correctly by the updated code? It works on my machine™, but is that just
> because my locale is unicode?

It depends on whether the buffer saved to that file included raw-bytes
(it generally shouldn't).  If not, then there will be no problem.  If
there were raw-bytes, you cannot win, so I wouldn't bother about that
case.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 30 Apr 2019 17:19:12 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Apr 30 13:19:12 2019
Received: from localhost ([127.0.0.1]:42320 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hLWPP-0006rj-P8
	for submit <at> debbugs.gnu.org; Tue, 30 Apr 2019 13:19:11 -0400
Received: from ericabrahamsen.net ([52.70.2.18]:49552
 helo=mail.ericabrahamsen.net)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eric@HIDDEN>) id 1hLWPO-0006rX-VC
 for 35383 <at> debbugs.gnu.org; Tue, 30 Apr 2019 13:19:11 -0400
Received: from localhost (97-113-61-17.tukw.qwest.net [97.113.61.17])
 (Authenticated sender: eric@HIDDEN)
 by mail.ericabrahamsen.net (Postfix) with ESMTPSA id 2E28FFA027;
 Tue, 30 Apr 2019 17:19:05 +0000 (UTC)
From: Eric Abrahamsen <eric@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN> <b4mk1fl16oz.fsf@HIDDEN>
 <87sgu87ayo.fsf@HIDDEN> <b4md0lb4ykk.fsf@HIDDEN>
 <87k1fj49o2.fsf@HIDDEN> <b4m5zr3hsn0.fsf@HIDDEN>
 <87bm0uhxqy.fsf@HIDDEN> <b4ma7gd2vg8.fsf@HIDDEN>
 <87d0l5ihgr.fsf@HIDDEN>
 <878svtihdw.fsf@HIDDEN> <835zqwu8cq.fsf@HIDDEN>
 <87sgu0h92o.fsf@HIDDEN> <83wojcrvu3.fsf@HIDDEN>
 <87muk7fmrx.fsf@HIDDEN> <83wojbquz0.fsf@HIDDEN>
Date: Tue, 30 Apr 2019 10:19:01 -0700
In-Reply-To: <83wojbquz0.fsf@HIDDEN> (Eli Zaretskii's message of "Tue, 30 Apr
 2019 20:11:15 +0300")
Message-ID: <87ftpzfm2i.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 35383
Cc: yamaoka@HIDDEN, 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


On 04/30/19 20:11 PM, Eli Zaretskii wrote:
>> From: Eric Abrahamsen <eric@HIDDEN>
>> Cc: yamaoka@HIDDEN,  35383 <at> debbugs.gnu.org
>> Date: Tue, 30 Apr 2019 10:03:46 -0700
>>=20
>> I think that's sufficient. I'm really only looking at two variables:
>> `gnus-agent-file-coding-system', which I'm 100% sure is only used
>> internally by Gnus/Emacs, and `nnmail-active-file-coding-system', which
>> I'm 99% sure is only used internally.
>
> It sounds like utf-8-emacs is TRT in both cases.
>
>> > What other checks and guarantees did you consider?  (Sorry, I didn't
>> > read the entire thread, so maybe just point me to the message where
>> > you described this.)
>>=20
>> That's where the encoding cookie idea came from -- if there's no cookie,
>> read as 'raw-text, otherwise honor the cookie. But as Katsumi Yamaoka
>> pointed out, the way Gnus reads the file will ignore any encoding
>> cookie, so that's no good.
>
> You could give up the cookie.  It is only important if the file is
> visited by "C-x C-f" etc., which will be rare.  So having a cookie is
> a nicety, not a requirement.

Right, I think that was the conclusion. But do you have any other advice
about making sure that files previously written as 'raw-text are read
correctly by the updated code? It works on my machine=E2=84=A2, but is that=
 just
because my locale is unicode?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 30 Apr 2019 17:11:31 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Apr 30 13:11:31 2019
Received: from localhost ([127.0.0.1]:42311 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hLWHy-0006eD-P9
	for submit <at> debbugs.gnu.org; Tue, 30 Apr 2019 13:11:31 -0400
Received: from eggs.gnu.org ([209.51.188.92]:57791)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1hLWHx-0006dx-1I
 for 35383 <at> debbugs.gnu.org; Tue, 30 Apr 2019 13:11:29 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:50944)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1hLWHr-00038E-GA; Tue, 30 Apr 2019 13:11:23 -0400
Received: from [176.228.60.248] (port=2988 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1hLWHq-0005Oz-2g; Tue, 30 Apr 2019 13:11:22 -0400
Date: Tue, 30 Apr 2019 20:11:15 +0300
Message-Id: <83wojbquz0.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Eric Abrahamsen <eric@HIDDEN>
In-reply-to: <87muk7fmrx.fsf@HIDDEN> (message from Eric Abrahamsen
 on Tue, 30 Apr 2019 10:03:46 -0700)
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN> <b4mk1fl16oz.fsf@HIDDEN>
 <87sgu87ayo.fsf@HIDDEN> <b4md0lb4ykk.fsf@HIDDEN>
 <87k1fj49o2.fsf@HIDDEN> <b4m5zr3hsn0.fsf@HIDDEN>
 <87bm0uhxqy.fsf@HIDDEN> <b4ma7gd2vg8.fsf@HIDDEN>
 <87d0l5ihgr.fsf@HIDDEN>
 <878svtihdw.fsf@HIDDEN> <835zqwu8cq.fsf@HIDDEN>
 <87sgu0h92o.fsf@HIDDEN> <83wojcrvu3.fsf@HIDDEN>
 <87muk7fmrx.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 35383
Cc: yamaoka@HIDDEN, 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Eric Abrahamsen <eric@HIDDEN>
> Cc: yamaoka@HIDDEN,  35383 <at> debbugs.gnu.org
> Date: Tue, 30 Apr 2019 10:03:46 -0700
> 
> I think that's sufficient. I'm really only looking at two variables:
> `gnus-agent-file-coding-system', which I'm 100% sure is only used
> internally by Gnus/Emacs, and `nnmail-active-file-coding-system', which
> I'm 99% sure is only used internally.

It sounds like utf-8-emacs is TRT in both cases.

> > What other checks and guarantees did you consider?  (Sorry, I didn't
> > read the entire thread, so maybe just point me to the message where
> > you described this.)
> 
> That's where the encoding cookie idea came from -- if there's no cookie,
> read as 'raw-text, otherwise honor the cookie. But as Katsumi Yamaoka
> pointed out, the way Gnus reads the file will ignore any encoding
> cookie, so that's no good.

You could give up the cookie.  It is only important if the file is
visited by "C-x C-f" etc., which will be rare.  So having a cookie is
a nicety, not a requirement.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 30 Apr 2019 17:03:58 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Apr 30 13:03:58 2019
Received: from localhost ([127.0.0.1]:42298 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hLWAf-0006QB-MX
	for submit <at> debbugs.gnu.org; Tue, 30 Apr 2019 13:03:58 -0400
Received: from ericabrahamsen.net ([52.70.2.18]:49248
 helo=mail.ericabrahamsen.net)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eric@HIDDEN>) id 1hLWAe-0006Px-0X
 for 35383 <at> debbugs.gnu.org; Tue, 30 Apr 2019 13:03:56 -0400
Received: from localhost (97-113-61-17.tukw.qwest.net [97.113.61.17])
 (Authenticated sender: eric@HIDDEN)
 by mail.ericabrahamsen.net (Postfix) with ESMTPSA id DEE5FFA027;
 Tue, 30 Apr 2019 17:03:49 +0000 (UTC)
From: Eric Abrahamsen <eric@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN> <b4mk1fl16oz.fsf@HIDDEN>
 <87sgu87ayo.fsf@HIDDEN> <b4md0lb4ykk.fsf@HIDDEN>
 <87k1fj49o2.fsf@HIDDEN> <b4m5zr3hsn0.fsf@HIDDEN>
 <87bm0uhxqy.fsf@HIDDEN> <b4ma7gd2vg8.fsf@HIDDEN>
 <87d0l5ihgr.fsf@HIDDEN>
 <878svtihdw.fsf@HIDDEN> <835zqwu8cq.fsf@HIDDEN>
 <87sgu0h92o.fsf@HIDDEN> <83wojcrvu3.fsf@HIDDEN>
Date: Tue, 30 Apr 2019 10:03:46 -0700
Message-ID: <87muk7fmrx.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 35383
Cc: yamaoka@HIDDEN, 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> From: Eric Abrahamsen <eric@HIDDEN>
>> Cc: yamaoka@HIDDEN,  35383 <at> debbugs.gnu.org
>> Date: Mon, 29 Apr 2019 13:04:31 -0700
>>
>> >> Actually, maybe that's wrong. We don't care how the files are written,
>> >> only that, after parsing, the group names are successfully _decoded_ to
>> >> 'utf-8-emacs. Maybe I'm trying too hard?
>> >
>> > When you decode _any_ text by _any_ coding-system, the result is
>> > _always_ utf-8-emacs, because utf-8-emacs is the internal
>> > representation of characters and raw bytes in Emacs buffers and
>> > strings.
>>
>> I did know that much! I'm pretty bad at encoding, but not quite that
>> bad.
>
> Sorry, it was not clear to me, since you talked about "decoding to
> utf-8-emacs", which is a kind of tautology.

True!

>> So you think Gnus' various *-file-coding-system options should
>> default to 'utf-8-emacs rather than 'raw-text?
>
> Not sure about all of them, I don't think I have a clear idea of what
> they are used for.  The principle is that we use utf-8-emacs for files
> where Emacs records its internal data, and whose primary role is to
> allow Emacs to restore its internal data with maximum reliability.
> One good example of this is auto-save files, where we use utf-8-emacs
> regardless of the actual encoding of the file whose buffer is
> auto-saved.
>
> If this principle is not enough to make a decision, please point out
> the specific variables you are unsure about, and I will take a look at
> their actual usage.

I think that's sufficient. I'm really only looking at two variables:
`gnus-agent-file-coding-system', which I'm 100% sure is only used
internally by Gnus/Emacs, and `nnmail-active-file-coding-system', which
I'm 99% sure is only used internally.

>> As per your other message, it sounds like active files written as
>> 'raw-text will probably survive being read as 'utf-8-emacs. And if the
>> user has previously customized those options to something else, the
>> change in default value won't matter anyway.
>
> That is true, but good defaults do matter to new users and new files.
>
> And raw-text is almost never appropriate as the default for
> human-readable text.
>
>> What I meant by "trying too hard" is, maybe it's enough to just change
>> the defaults, and not add any other error checking and guarantees?
>
> What other checks and guarantees did you consider?  (Sorry, I didn't
> read the entire thread, so maybe just point me to the message where
> you described this.)

That's where the encoding cookie idea came from -- if there's no cookie,
read as 'raw-text, otherwise honor the cookie. But as Katsumi Yamaoka
pointed out, the way Gnus reads the file will ignore any encoding
cookie, so that's no good.

To be honest, I didn't have any other ideas.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 30 Apr 2019 03:55:19 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Apr 29 23:55:19 2019
Received: from localhost ([127.0.0.1]:40385 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hLJrS-0005Xw-Pl
	for submit <at> debbugs.gnu.org; Mon, 29 Apr 2019 23:55:19 -0400
Received: from eggs.gnu.org ([209.51.188.92]:41315)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1hLJrQ-0005XV-Ek
 for 35383 <at> debbugs.gnu.org; Mon, 29 Apr 2019 23:55:17 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:39279)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1hLJrK-0006X7-Ca; Mon, 29 Apr 2019 23:55:10 -0400
Received: from [176.228.60.248] (port=4954 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1hLJrI-0008EJ-MV; Mon, 29 Apr 2019 23:55:09 -0400
Date: Tue, 30 Apr 2019 06:55:00 +0300
Message-Id: <83wojcrvu3.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Eric Abrahamsen <eric@HIDDEN>
In-reply-to: <87sgu0h92o.fsf@HIDDEN> (message from Eric Abrahamsen
 on Mon, 29 Apr 2019 13:04:31 -0700)
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN> <b4mk1fl16oz.fsf@HIDDEN>
 <87sgu87ayo.fsf@HIDDEN> <b4md0lb4ykk.fsf@HIDDEN>
 <87k1fj49o2.fsf@HIDDEN> <b4m5zr3hsn0.fsf@HIDDEN>
 <87bm0uhxqy.fsf@HIDDEN> <b4ma7gd2vg8.fsf@HIDDEN>
 <87d0l5ihgr.fsf@HIDDEN>
 <878svtihdw.fsf@HIDDEN> <835zqwu8cq.fsf@HIDDEN>
 <87sgu0h92o.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 35383
Cc: yamaoka@HIDDEN, 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Eric Abrahamsen <eric@HIDDEN>
> Cc: yamaoka@HIDDEN,  35383 <at> debbugs.gnu.org
> Date: Mon, 29 Apr 2019 13:04:31 -0700
> 
> >> Actually, maybe that's wrong. We don't care how the files are written,
> >> only that, after parsing, the group names are successfully _decoded_ to
> >> 'utf-8-emacs. Maybe I'm trying too hard?
> >
> > When you decode _any_ text by _any_ coding-system, the result is
> > _always_ utf-8-emacs, because utf-8-emacs is the internal
> > representation of characters and raw bytes in Emacs buffers and
> > strings.
> 
> I did know that much! I'm pretty bad at encoding, but not quite that
> bad.

Sorry, it was not clear to me, since you talked about "decoding to
utf-8-emacs", which is a kind of tautology.

> So you think Gnus' various *-file-coding-system options should
> default to 'utf-8-emacs rather than 'raw-text?

Not sure about all of them, I don't think I have a clear idea of what
they are used for.  The principle is that we use utf-8-emacs for files
where Emacs records its internal data, and whose primary role is to
allow Emacs to restore its internal data with maximum reliability.
One good example of this is auto-save files, where we use utf-8-emacs
regardless of the actual encoding of the file whose buffer is
auto-saved.

If this principle is not enough to make a decision, please point out
the specific variables you are unsure about, and I will take a look at
their actual usage.

> As per your other message, it sounds like active files written as
> 'raw-text will probably survive being read as 'utf-8-emacs. And if the
> user has previously customized those options to something else, the
> change in default value won't matter anyway.

That is true, but good defaults do matter to new users and new files.

And raw-text is almost never appropriate as the default for
human-readable text.

> What I meant by "trying too hard" is, maybe it's enough to just change
> the defaults, and not add any other error checking and guarantees?

What other checks and guarantees did you consider?  (Sorry, I didn't
read the entire thread, so maybe just point me to the message where
you described this.)




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 29 Apr 2019 20:04:44 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Apr 29 16:04:44 2019
Received: from localhost ([127.0.0.1]:39832 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hLCW3-0006gJ-VP
	for submit <at> debbugs.gnu.org; Mon, 29 Apr 2019 16:04:44 -0400
Received: from ericabrahamsen.net ([52.70.2.18]:51976
 helo=mail.ericabrahamsen.net)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eric@HIDDEN>) id 1hLCW1-0006g4-0x
 for 35383 <at> debbugs.gnu.org; Mon, 29 Apr 2019 16:04:42 -0400
Received: from localhost (unknown [205.175.106.8])
 (Authenticated sender: eric@HIDDEN)
 by mail.ericabrahamsen.net (Postfix) with ESMTPSA id F31F3FA023;
 Mon, 29 Apr 2019 20:04:34 +0000 (UTC)
From: Eric Abrahamsen <eric@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN> <b4mk1fl16oz.fsf@HIDDEN>
 <87sgu87ayo.fsf@HIDDEN> <b4md0lb4ykk.fsf@HIDDEN>
 <87k1fj49o2.fsf@HIDDEN> <b4m5zr3hsn0.fsf@HIDDEN>
 <87bm0uhxqy.fsf@HIDDEN> <b4ma7gd2vg8.fsf@HIDDEN>
 <87d0l5ihgr.fsf@HIDDEN>
 <878svtihdw.fsf@HIDDEN> <835zqwu8cq.fsf@HIDDEN>
Date: Mon, 29 Apr 2019 13:04:31 -0700
In-Reply-To: <835zqwu8cq.fsf@HIDDEN> (Eli Zaretskii's message of "Mon, 29 Apr
 2019 18:41:41 +0300")
Message-ID: <87sgu0h92o.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 35383
Cc: yamaoka@HIDDEN, 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


On 04/29/19 18:41 PM, Eli Zaretskii wrote:
>> From: Eric Abrahamsen <eric@HIDDEN>
>> Date: Sun, 28 Apr 2019 21:07:23 -0700
>> Cc: 35383 <at> debbugs.gnu.org
>> 
>> > The goal is to have Gnus default to writing its active files in
>> > 'utf-8-emacs, unless the user has specifically requested otherwise.
>> > `nnmail-active-file-coding-system' governs the "mail" type servers, and
>> > `gnus-agent-file-coding-system' governs the agent. Currently those two
>> > options default to 'raw-text, we'd like them to default to 'utf-8-emacs.
>> 
>> Actually, maybe that's wrong. We don't care how the files are written,
>> only that, after parsing, the group names are successfully _decoded_ to
>> 'utf-8-emacs. Maybe I'm trying too hard?
>
> When you decode _any_ text by _any_ coding-system, the result is
> _always_ utf-8-emacs, because utf-8-emacs is the internal
> representation of characters and raw bytes in Emacs buffers and
> strings.

I did know that much! I'm pretty bad at encoding, but not quite that
bad.

> We write text out as utf-8-emacs when we don't want to risk the danger
> of decoding incorrectly due to local customizations and language
> environments.  Text encoded in utf-8-emacs can by definition represent
> _any_ character and raw byte that Emacs can read, and the "decoding"
> in this case is trivial.
>
> So no, you are not trying too hard, not IMO.

So you think Gnus' various *-file-coding-system options should
default to 'utf-8-emacs rather than 'raw-text?

As per your other message, it sounds like active files written as
'raw-text will probably survive being read as 'utf-8-emacs. And if the
user has previously customized those options to something else, the
change in default value won't matter anyway.

What I meant by "trying too hard" is, maybe it's enough to just change
the defaults, and not add any other error checking and guarantees?

Thanks for looking at this,
Eric




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 29 Apr 2019 15:41:59 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Apr 29 11:41:59 2019
Received: from localhost ([127.0.0.1]:39542 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hL8Pn-0006CQ-1Y
	for submit <at> debbugs.gnu.org; Mon, 29 Apr 2019 11:41:59 -0400
Received: from eggs.gnu.org ([209.51.188.92]:48671)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1hL8Pl-0006CF-Ps
 for 35383 <at> debbugs.gnu.org; Mon, 29 Apr 2019 11:41:58 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:57106)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1hL8Pf-0002PV-Nf; Mon, 29 Apr 2019 11:41:52 -0400
Received: from [176.228.60.248] (port=3195 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1hL8Pe-0007qQ-71; Mon, 29 Apr 2019 11:41:50 -0400
Date: Mon, 29 Apr 2019 18:41:41 +0300
Message-Id: <835zqwu8cq.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Eric Abrahamsen <eric@HIDDEN>
In-reply-to: <878svtihdw.fsf@HIDDEN> (message from Eric Abrahamsen
 on Sun, 28 Apr 2019 21:07:23 -0700)
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN> <b4mk1fl16oz.fsf@HIDDEN>
 <87sgu87ayo.fsf@HIDDEN> <b4md0lb4ykk.fsf@HIDDEN>
 <87k1fj49o2.fsf@HIDDEN> <b4m5zr3hsn0.fsf@HIDDEN>
 <87bm0uhxqy.fsf@HIDDEN> <b4ma7gd2vg8.fsf@HIDDEN>
 <87d0l5ihgr.fsf@HIDDEN> <878svtihdw.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 35383
Cc: yamaoka@HIDDEN, 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Eric Abrahamsen <eric@HIDDEN>
> Date: Sun, 28 Apr 2019 21:07:23 -0700
> Cc: 35383 <at> debbugs.gnu.org
> 
> > The goal is to have Gnus default to writing its active files in
> > 'utf-8-emacs, unless the user has specifically requested otherwise.
> > `nnmail-active-file-coding-system' governs the "mail" type servers, and
> > `gnus-agent-file-coding-system' governs the agent. Currently those two
> > options default to 'raw-text, we'd like them to default to 'utf-8-emacs.
> 
> Actually, maybe that's wrong. We don't care how the files are written,
> only that, after parsing, the group names are successfully _decoded_ to
> 'utf-8-emacs. Maybe I'm trying too hard?

When you decode _any_ text by _any_ coding-system, the result is
_always_ utf-8-emacs, because utf-8-emacs is the internal
representation of characters and raw bytes in Emacs buffers and
strings.

We write text out as utf-8-emacs when we don't want to risk the danger
of decoding incorrectly due to local customizations and language
environments.  Text encoded in utf-8-emacs can by definition represent
_any_ character and raw byte that Emacs can read, and the "decoding"
in this case is trivial.

So no, you are not trying too hard, not IMO.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 29 Apr 2019 15:38:53 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Apr 29 11:38:53 2019
Received: from localhost ([127.0.0.1]:39533 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hL8Mn-00067R-Fb
	for submit <at> debbugs.gnu.org; Mon, 29 Apr 2019 11:38:53 -0400
Received: from eggs.gnu.org ([209.51.188.92]:47961)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1hL8Ml-00067F-Vu
 for 35383 <at> debbugs.gnu.org; Mon, 29 Apr 2019 11:38:52 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:57053)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1hL8Mf-0007le-VW; Mon, 29 Apr 2019 11:38:46 -0400
Received: from [176.228.60.248] (port=3009 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1hL8Mf-0007bE-GA; Mon, 29 Apr 2019 11:38:45 -0400
Date: Mon, 29 Apr 2019 18:38:37 +0300
Message-Id: <837ebcu8hu.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Eric Abrahamsen <eric@HIDDEN>
In-reply-to: <87d0l5ihgr.fsf@HIDDEN> (message from Eric Abrahamsen
 on Sun, 28 Apr 2019 21:05:40 -0700)
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN> <b4mk1fl16oz.fsf@HIDDEN>
 <87sgu87ayo.fsf@HIDDEN> <b4md0lb4ykk.fsf@HIDDEN>
 <87k1fj49o2.fsf@HIDDEN> <b4m5zr3hsn0.fsf@HIDDEN>
 <87bm0uhxqy.fsf@HIDDEN> <b4ma7gd2vg8.fsf@HIDDEN>
 <87d0l5ihgr.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 35383
Cc: yamaoka@HIDDEN, 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Eric Abrahamsen <eric@HIDDEN>
> Date: Sun, 28 Apr 2019 21:05:40 -0700
> Cc: 35383 <at> debbugs.gnu.org
> 
> What I find a little perplexing is that, testing with emacs 26, an nnml
> active file with multibyte group names gets written to a file that my
> terminal recognizes as utf-8, despite the fact that `nnmail-save-active'
> sets 'coding-system-for-write' to 'raw-text, and disables multibyte. But
> maybe, as Eli mentioned, that has to do with my locale...?

If the original was a valid UTF-8 sequence, writing it out as raw-text
will leave the byte sequences alone, and then it will look like a
UTF-8 encoded text.  So this is kinda expected in many situations.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 29 Apr 2019 04:07:34 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Apr 29 00:07:34 2019
Received: from localhost ([127.0.0.1]:38204 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hKxZl-0003TN-Tg
	for submit <at> debbugs.gnu.org; Mon, 29 Apr 2019 00:07:34 -0400
Received: from ericabrahamsen.net ([52.70.2.18]:59168
 helo=mail.ericabrahamsen.net)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eric@HIDDEN>) id 1hKxZk-0003TC-Jd
 for 35383 <at> debbugs.gnu.org; Mon, 29 Apr 2019 00:07:33 -0400
Received: from localhost (97-113-61-17.tukw.qwest.net [97.113.61.17])
 (Authenticated sender: eric@HIDDEN)
 by mail.ericabrahamsen.net (Postfix) with ESMTPSA id D7ABCFA027;
 Mon, 29 Apr 2019 04:07:26 +0000 (UTC)
From: Eric Abrahamsen <eric@HIDDEN>
To: Katsumi Yamaoka <yamaoka@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN> <b4mk1fl16oz.fsf@HIDDEN>
 <87sgu87ayo.fsf@HIDDEN> <b4md0lb4ykk.fsf@HIDDEN>
 <87k1fj49o2.fsf@HIDDEN> <b4m5zr3hsn0.fsf@HIDDEN>
 <87bm0uhxqy.fsf@HIDDEN> <b4ma7gd2vg8.fsf@HIDDEN>
 <87d0l5ihgr.fsf@HIDDEN>
Date: Sun, 28 Apr 2019 21:07:23 -0700
In-Reply-To: <87d0l5ihgr.fsf@HIDDEN> (Eric Abrahamsen's message of
 "Sun, 28 Apr 2019 21:05:40 -0700")
Message-ID: <878svtihdw.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 35383
Cc: 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eric Abrahamsen <eric@HIDDEN> writes:

> Katsumi Yamaoka <yamaoka@HIDDEN> writes:
>
>> On Thu, 25 Apr 2019 09:10:13 -0700, Eric Abrahamsen wrote:
>>> On 04/25/19 08:48 AM, Katsumi Yamaoka wrote:
>>
>>>> Warning: Warning - invalid active:
>>
>>>> for the nnnil method, that is my `gnus-select-method'.  Here are
>>>> the contents of ~/News/agent/nnnil/agent.lib/active:
>>
>>>> --8<---------------cut here---------------start------------->8---
>>>> ;; -*- encoding: utf-8-emacs; -*-
>>
>>>> --8<---------------cut here---------------end--------------->8---
>>
>>>> Why the warning is issued is to run (read (current-buffer)) at
>>>> the beginning of the contents.  This is actually an error but
>>>> `condition-case' conceals it.
>>
>>> Hmm, this is all done in a temp buffer,
>>
>> Yes.  When launching Gnus, the whole contents of the active file
>> are read into the " *nntpd*" buffer, copied into the temp buffer,
>> and parsed (see the flow summary attatched in the bottom of this
>> message for how Gnus behaves when launching).
>>
>>> with
>>> `insert-buffer-substring' -- I wonder if the encoding cookie will even
>>> be honored in this case?
>>
>> No, it's useless of course.  Moreover, --- I changed my idea
>> (patching the `gnus-active-to-gnus-format' function so as to
>> ignore the coding cookie) --- I come to think that the active
>> file should not contain the ones other than the active infos.
>> Gnus indeed ignores the coding cookie when parsing active, but
>> it is due to just a lucky side effect of `read':
>>
>> (read ";; coding cookie\n\nactive_info\n") => active_info
>>
>> I.e., `read' ignores comments in the ELisp style and whitespace.
>> However, in the first place, the active file is neither an ELisp
>> file nor there is no agreement for a comment style in it.  So, I
>> think it is better to bind `coding-system-for-(read|write)' while
>> reading and writing the active file rather than adding a coding
>> cookie.  Though binding `coding-system-for-(read|write)' would
>> probably be unnecessary since `gnus-write-active-file' binds
>> `coding-system-for-write' to `nnmail-active-file-coding-system',
>> and `gnus-agent-save-active' binds `coding-system-for-read' to
>> `gnus-agent-file-coding-system' that defaults to `utf-8-emacs'.
>> Therefore, adding a coding cookie was originally unnecessary,
>> wasn't it?
>>
>> Here are how Gnus reads the active file for the nnnil method
>> observed in my system.  Note that `gnus-agent' is t (the default).
>>
>> (gnus 1)
>>   [...]
>>   (gnus-setup-news nil t nil)
>>     (gnus-get-unread-articles 1 nil)
>>       (require 'gnus-agent)
>>       (with-current-buffer " *nntpd*"
>>         (gnus-read-active-file-1 '(nnnil) nil)
>>           (gnus-active-to-gnus-format '(nnnil) hashtb nil t)
>>             (gnus-agent-save-active '(nnil))
>>               (gnus-agent-write-active "active-file" hashtb)
>>                 ;; Add a coding cookie.
>>                 (gnus-write-active-file "active-file" hashtb nil)
>>               (erase-buffer)
>>               (nnheader-insert-file-contents "active-file")
>>             (_copy to_ " *nntpd*")
>>             (_parse it_)
>
> Hang on, let me slow down here.
>
> The goal is to have Gnus default to writing its active files in
> 'utf-8-emacs, unless the user has specifically requested otherwise.
> `nnmail-active-file-coding-system' governs the "mail" type servers, and
> `gnus-agent-file-coding-system' governs the agent. Currently those two
> options default to 'raw-text, we'd like them to default to 'utf-8-emacs.

Actually, maybe that's wrong. We don't care how the files are written,
only that, after parsing, the group names are successfully _decoded_ to
'utf-8-emacs. Maybe I'm trying too hard?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 29 Apr 2019 04:05:56 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Apr 29 00:05:56 2019
Received: from localhost ([127.0.0.1]:38199 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hKxYC-0003R1-Ac
	for submit <at> debbugs.gnu.org; Mon, 29 Apr 2019 00:05:56 -0400
Received: from ericabrahamsen.net ([52.70.2.18]:59124
 helo=mail.ericabrahamsen.net)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eric@HIDDEN>) id 1hKxY9-0003Qi-Cn
 for 35383 <at> debbugs.gnu.org; Mon, 29 Apr 2019 00:05:54 -0400
Received: from localhost (97-113-61-17.tukw.qwest.net [97.113.61.17])
 (Authenticated sender: eric@HIDDEN)
 by mail.ericabrahamsen.net (Postfix) with ESMTPSA id E5CEDFA027;
 Mon, 29 Apr 2019 04:05:46 +0000 (UTC)
From: Eric Abrahamsen <eric@HIDDEN>
To: Katsumi Yamaoka <yamaoka@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN> <b4mk1fl16oz.fsf@HIDDEN>
 <87sgu87ayo.fsf@HIDDEN> <b4md0lb4ykk.fsf@HIDDEN>
 <87k1fj49o2.fsf@HIDDEN> <b4m5zr3hsn0.fsf@HIDDEN>
 <87bm0uhxqy.fsf@HIDDEN> <b4ma7gd2vg8.fsf@HIDDEN>
Date: Sun, 28 Apr 2019 21:05:40 -0700
In-Reply-To: <b4ma7gd2vg8.fsf@HIDDEN> (Katsumi Yamaoka's message of "Fri, 26
 Apr 2019 14:21:11 +0900")
Message-ID: <87d0l5ihgr.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 35383
Cc: 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Katsumi Yamaoka <yamaoka@HIDDEN> writes:

> On Thu, 25 Apr 2019 09:10:13 -0700, Eric Abrahamsen wrote:
>> On 04/25/19 08:48 AM, Katsumi Yamaoka wrote:
>
>>> Warning: Warning - invalid active:
>
>>> for the nnnil method, that is my `gnus-select-method'.  Here are
>>> the contents of ~/News/agent/nnnil/agent.lib/active:
>
>>> --8<---------------cut here---------------start------------->8---
>>> ;; -*- encoding: utf-8-emacs; -*-
>
>>> --8<---------------cut here---------------end--------------->8---
>
>>> Why the warning is issued is to run (read (current-buffer)) at
>>> the beginning of the contents.  This is actually an error but
>>> `condition-case' conceals it.
>
>> Hmm, this is all done in a temp buffer,
>
> Yes.  When launching Gnus, the whole contents of the active file
> are read into the " *nntpd*" buffer, copied into the temp buffer,
> and parsed (see the flow summary attatched in the bottom of this
> message for how Gnus behaves when launching).
>
>> with
>> `insert-buffer-substring' -- I wonder if the encoding cookie will even
>> be honored in this case?
>
> No, it's useless of course.  Moreover, --- I changed my idea
> (patching the `gnus-active-to-gnus-format' function so as to
> ignore the coding cookie) --- I come to think that the active
> file should not contain the ones other than the active infos.
> Gnus indeed ignores the coding cookie when parsing active, but
> it is due to just a lucky side effect of `read':
>
> (read ";; coding cookie\n\nactive_info\n") => active_info
>
> I.e., `read' ignores comments in the ELisp style and whitespace.
> However, in the first place, the active file is neither an ELisp
> file nor there is no agreement for a comment style in it.  So, I
> think it is better to bind `coding-system-for-(read|write)' while
> reading and writing the active file rather than adding a coding
> cookie.  Though binding `coding-system-for-(read|write)' would
> probably be unnecessary since `gnus-write-active-file' binds
> `coding-system-for-write' to `nnmail-active-file-coding-system',
> and `gnus-agent-save-active' binds `coding-system-for-read' to
> `gnus-agent-file-coding-system' that defaults to `utf-8-emacs'.
> Therefore, adding a coding cookie was originally unnecessary,
> wasn't it?
>
> Here are how Gnus reads the active file for the nnnil method
> observed in my system.  Note that `gnus-agent' is t (the default).
>
> (gnus 1)
>   [...]
>   (gnus-setup-news nil t nil)
>     (gnus-get-unread-articles 1 nil)
>       (require 'gnus-agent)
>       (with-current-buffer " *nntpd*"
>         (gnus-read-active-file-1 '(nnnil) nil)
>           (gnus-active-to-gnus-format '(nnnil) hashtb nil t)
>             (gnus-agent-save-active '(nnil))
>               (gnus-agent-write-active "active-file" hashtb)
>                 ;; Add a coding cookie.
>                 (gnus-write-active-file "active-file" hashtb nil)
>               (erase-buffer)
>               (nnheader-insert-file-contents "active-file")
>             (_copy to_ " *nntpd*")
>             (_parse it_)

Hang on, let me slow down here.

The goal is to have Gnus default to writing its active files in
'utf-8-emacs, unless the user has specifically requested otherwise.
`nnmail-active-file-coding-system' governs the "mail" type servers, and
`gnus-agent-file-coding-system' governs the agent. Currently those two
options default to 'raw-text, we'd like them to default to 'utf-8-emacs.

But the active files have to be read correctly, as well, even by a user
who is loading this new code for the first time. That was my original
idea for the coding cookie, though obviously I was confused. Both those
options are used as the value of `coding-system-for-read' when reading
active files. So far I don't have a good solution for "upgrading" old
active files to 'utf-8.

I also realized that there's a `nnmbox-active-file-coding-system' that
defaults to 'binary.

What I find a little perplexing is that, testing with emacs 26, an nnml
active file with multibyte group names gets written to a file that my
terminal recognizes as utf-8, despite the fact that `nnmail-save-active'
sets 'coding-system-for-write' to 'raw-text, and disables multibyte. But
maybe, as Eli mentioned, that has to do with my locale...?

> P.S.
> I'll be not so active in the net for about ten days because of
> the national holidays assoc with the era name changing in Japan.

Hope it's a happy time in Japan! I'm in no rush over here.

Eric




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 26 Apr 2019 10:55:48 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Apr 26 06:55:48 2019
Received: from localhost ([127.0.0.1]:60150 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hJyWB-0004fh-Uu
	for submit <at> debbugs.gnu.org; Fri, 26 Apr 2019 06:55:48 -0400
Received: from eggs.gnu.org ([209.51.188.92]:33175)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1hJyW9-0004fV-RP
 for 35383 <at> debbugs.gnu.org; Fri, 26 Apr 2019 06:55:46 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:45452)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1hJyW3-0006Us-Hm; Fri, 26 Apr 2019 06:55:39 -0400
Received: from [176.228.60.248] (port=4720 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1hJyW1-0004DC-SW; Fri, 26 Apr 2019 06:55:39 -0400
Date: Fri, 26 Apr 2019 13:55:19 +0300
Message-Id: <8336m5xch4.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Katsumi Yamaoka <yamaoka@HIDDEN>
In-reply-to: <b4m8svxxk7b.fsf@HIDDEN> (message from Katsumi Yamaoka on Fri,
 26 Apr 2019 17:08:24 +0900)
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN> <b4mk1fl16oz.fsf@HIDDEN>
 <87sgu87ayo.fsf@HIDDEN> <b4md0lb4ykk.fsf@HIDDEN>
 <87k1fj49o2.fsf@HIDDEN> <b4m5zr3hsn0.fsf@HIDDEN>
 <87bm0uhxqy.fsf@HIDDEN> <b4ma7gd2vg8.fsf@HIDDEN>
 <83ftq5xnoh.fsf@HIDDEN> <b4m8svxxk7b.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 35383
Cc: eric@HIDDEN, 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Date: Fri, 26 Apr 2019 17:08:24 +0900
> From: Katsumi Yamaoka <yamaoka@HIDDEN>
> Cc: eric@HIDDEN, 35383 <at> debbugs.gnu.org
> 
> > It is not unnecessary, because that file could be visited normally in
> > Emacs.  So even if you have to bind coding-system-for-read for some
> > reason (and I admit I don't understand the reasons very well, and in
> > particular this will not affect 'read' or any other primitive that
> > is supposed to be reading from an already decoded buffer/string),
> > there are still valid reasons to have the cookie in the file.
> 
> Well, I don't know why the active files need a coding cookie, but
> what adds it is `gnus-write-active-file' that only gnus-agent and
> gnus-cache use; `nnmail-save-active' that many mail back ends use
> does not add a coding cookie.  Even so, I have no trouble with my
> nnml active file that contains non-ASCII group names.  The file
> is utf-8 encoded and it is Emacs' default (IIUC), so I cannot
> think any reason why the cookie is required.

You are probably in a UTF-8 locale, so your defaults facilitate
detecting the right encoding.  In non-UTF-8 locales this might not be
that easy, Emacs could guess wrong.

More importantly, utf-8-emacs and utf-8 are not the same, the
differences are subtle, but they do exist.  We use utf-8-emacs for
anything that should support any character representable inside Emacs
buffers and strings, so using it here seems correct.  But if someone
wants to visit this file with "C-x C-f", e.g., to manually fix
something there, they should be able to do that without risking
incorrect decoding.

So I think the cookie should stay, especially as it can never do any
harm in this context, AFAIU.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 26 Apr 2019 08:08:41 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Apr 26 04:08:41 2019
Received: from localhost ([127.0.0.1]:59957 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hJvuT-0000ZU-CX
	for submit <at> debbugs.gnu.org; Fri, 26 Apr 2019 04:08:41 -0400
Received: from bonobo.maple.relay.mailchannels.net ([23.83.214.22]:32116)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <yamaoka@HIDDEN>) id 1hJvuR-0000ZM-V6
 for 35383 <at> debbugs.gnu.org; Fri, 26 Apr 2019 04:08:40 -0400
X-Sender-Id: tih5qno0ow|x-authuser|yamaoka@HIDDEN
Received: from relay.mailchannels.net (localhost [127.0.0.1])
 by relay.mailchannels.net (Postfix) with ESMTP id C9BB56A1AA2;
 Fri, 26 Apr 2019 08:08:37 +0000 (UTC)
Received: from hampton.hostforweb.net
 (100-96-2-149.trex.outbound.svc.cluster.local [100.96.2.149])
 (Authenticated sender: tih5qno0ow)
 by relay.mailchannels.net (Postfix) with ESMTPA id 94A7F6A1F0D;
 Fri, 26 Apr 2019 08:08:36 +0000 (UTC)
X-Sender-Id: tih5qno0ow|x-authuser|yamaoka@HIDDEN
Received: from hampton.hostforweb.net ([TEMPUNAVAIL]. [172.245.115.217])
 (using TLSv1.2 with cipher DHE-RSA-AES256-GCM-SHA384)
 by 0.0.0.0:2500 (trex/5.17.2); Fri, 26 Apr 2019 08:08:37 +0000
X-MC-Relay: Neutral
X-MailChannels-SenderId: tih5qno0ow|x-authuser|yamaoka@HIDDEN
X-MailChannels-Auth-Id: tih5qno0ow
X-Stupid-Cure: 00b65077190587d3_1556266117373_3953510374
X-MC-Loop-Signature: 1556266117373:863393742
X-MC-Ingress-Time: 1556266117373
Received: from s70.gtokyofl21.vectant.ne.jp ([202.215.75.70]:60000
 helo=localhost) by hampton.hostforweb.net with esmtpsa
 (TLSv1.2:ECDHE-RSA-AES256-GCM-SHA384:256) (Exim 4.89_1)
 (envelope-from <yamaoka@HIDDEN>)
 id 1hJvuG-004aKS-FO; Fri, 26 Apr 2019 03:08:30 -0500
Date: Fri, 26 Apr 2019 17:08:24 +0900
Message-ID: <b4m8svxxk7b.fsf@HIDDEN>
From: Katsumi Yamaoka <yamaoka@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN> <b4mk1fl16oz.fsf@HIDDEN>
 <87sgu87ayo.fsf@HIDDEN> <b4md0lb4ykk.fsf@HIDDEN>
 <87k1fj49o2.fsf@HIDDEN> <b4m5zr3hsn0.fsf@HIDDEN>
 <87bm0uhxqy.fsf@HIDDEN> <b4ma7gd2vg8.fsf@HIDDEN>
 <83ftq5xnoh.fsf@HIDDEN>
Organization: Emacsen advocacy group
X-Face: #kKnN,xUnmKia.'[pp`;
 Omh}odZK)?7wQSl"4o04=EixTF+V[""w~iNbM9ZL+.b*_CxUmFk
 B#Fu[*?MZZH@IkN:!"\w%I_zt>[$nm7nQosZ<3eu; B:$Q_:p!',P.c0-_Cy[dz4oIpw0ESA^D*1Lw=
 L&i*6&(
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (x86_64-pc-cygwin)
Cancel-Lock: sha1:xOcCKY9ub2BjDDiCsNCmSNzs4R8=
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
X-OutGoing-Spam-Status: No, score=-0.2
X-AuthUser: yamaoka@HIDDEN
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 35383
Cc: eric@HIDDEN, 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On Fri, 26 Apr 2019 09:53:18 +0300, Eli Zaretskii wrote:
>> Date: Fri, 26 Apr 2019 14:21:11 +0900
>> From: Katsumi Yamaoka <yamaoka@HIDDEN>
>> Cc: 35383 <at> debbugs.gnu.org
[...]
>> Therefore, adding a coding cookie was originally unnecessary,
>> wasn't it?

> It is not unnecessary, because that file could be visited normally in
> Emacs.  So even if you have to bind coding-system-for-read for some
> reason (and I admit I don't understand the reasons very well, and in
> particular this will not affect 'read' or any other primitive that
> is supposed to be reading from an already decoded buffer/string),
> there are still valid reasons to have the cookie in the file.

Well, I don't know why the active files need a coding cookie, but
what adds it is `gnus-write-active-file' that only gnus-agent and
gnus-cache use; `nnmail-save-active' that many mail back ends use
does not add a coding cookie.  Even so, I have no trouble with my
nnml active file that contains non-ASCII group names.  The file
is utf-8 encoded and it is Emacs' default (IIUC), so I cannot
think any reason why the cookie is required.

(Just in case, we're talking about the gnus-decoded branch.)

Anyway, the error that at least the nnnil active file causes
should be fixed in some way.

Regards,




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 26 Apr 2019 06:53:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Apr 26 02:53:49 2019
Received: from localhost ([127.0.0.1]:59853 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hJuk1-00079R-Ff
	for submit <at> debbugs.gnu.org; Fri, 26 Apr 2019 02:53:49 -0400
Received: from eggs.gnu.org ([209.51.188.92]:58111)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1hJujz-00079E-0T
 for 35383 <at> debbugs.gnu.org; Fri, 26 Apr 2019 02:53:47 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:35347)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1hJujs-0001iR-7l; Fri, 26 Apr 2019 02:53:41 -0400
Received: from [176.228.60.248] (port=1314 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1hJujo-0003hE-Rj; Fri, 26 Apr 2019 02:53:37 -0400
Date: Fri, 26 Apr 2019 09:53:18 +0300
Message-Id: <83ftq5xnoh.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Katsumi Yamaoka <yamaoka@HIDDEN>
In-reply-to: <b4ma7gd2vg8.fsf@HIDDEN> (message from Katsumi Yamaoka on Fri,
 26 Apr 2019 14:21:11 +0900)
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN> <b4mk1fl16oz.fsf@HIDDEN>
 <87sgu87ayo.fsf@HIDDEN> <b4md0lb4ykk.fsf@HIDDEN>
 <87k1fj49o2.fsf@HIDDEN> <b4m5zr3hsn0.fsf@HIDDEN>
 <87bm0uhxqy.fsf@HIDDEN> <b4ma7gd2vg8.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 35383
Cc: eric@HIDDEN, 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Date: Fri, 26 Apr 2019 14:21:11 +0900
> From: Katsumi Yamaoka <yamaoka@HIDDEN>
> Cc: 35383 <at> debbugs.gnu.org
> 
> > with
> > `insert-buffer-substring' -- I wonder if the encoding cookie will even
> > be honored in this case?
> 
> No, it's useless of course.  Moreover, --- I changed my idea
> (patching the `gnus-active-to-gnus-format' function so as to
> ignore the coding cookie) --- I come to think that the active
> file should not contain the ones other than the active infos.
> Gnus indeed ignores the coding cookie when parsing active, but
> it is due to just a lucky side effect of `read':
> 
> (read ";; coding cookie\n\nactive_info\n") => active_info
> 
> I.e., `read' ignores comments in the ELisp style and whitespace.
> However, in the first place, the active file is neither an ELisp
> file nor there is no agreement for a comment style in it.  So, I
> think it is better to bind `coding-system-for-(read|write)' while
> reading and writing the active file rather than adding a coding
> cookie.  Though binding `coding-system-for-(read|write)' would
> probably be unnecessary since `gnus-write-active-file' binds
> `coding-system-for-write' to `nnmail-active-file-coding-system',
> and `gnus-agent-save-active' binds `coding-system-for-read' to
> `gnus-agent-file-coding-system' that defaults to `utf-8-emacs'.
> Therefore, adding a coding cookie was originally unnecessary,
> wasn't it?

It is not unnecessary, because that file could be visited normally in
Emacs.  So even if you have to bind coding-system-for-read for some
reason (and I admit I don't understand the reasons very well, and in
particular this will not affect 'read' or any other primitive that
is supposed to be reading from an already decoded buffer/string),
there are still valid reasons to have the cookie in the file.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 26 Apr 2019 05:21:30 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Apr 26 01:21:29 2019
Received: from localhost ([127.0.0.1]:59799 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hJtIf-0004yD-Jq
	for submit <at> debbugs.gnu.org; Fri, 26 Apr 2019 01:21:29 -0400
Received: from orchid.birch.relay.mailchannels.net ([23.83.209.137]:9902)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <yamaoka@HIDDEN>) id 1hJtIe-0004y5-1l
 for 35383 <at> debbugs.gnu.org; Fri, 26 Apr 2019 01:21:28 -0400
X-Sender-Id: tih5qno0ow|x-authuser|yamaoka@HIDDEN
Received: from relay.mailchannels.net (localhost [127.0.0.1])
 by relay.mailchannels.net (Postfix) with ESMTP id A0285141BEA;
 Fri, 26 Apr 2019 05:21:26 +0000 (UTC)
Received: from hampton.hostforweb.net
 (100-96-7-81.trex.outbound.svc.cluster.local [100.96.7.81])
 (Authenticated sender: tih5qno0ow)
 by relay.mailchannels.net (Postfix) with ESMTPA id 93A20141C9E;
 Fri, 26 Apr 2019 05:21:25 +0000 (UTC)
X-Sender-Id: tih5qno0ow|x-authuser|yamaoka@HIDDEN
Received: from hampton.hostforweb.net ([TEMPUNAVAIL]. [172.245.115.217])
 (using TLSv1.2 with cipher DHE-RSA-AES256-GCM-SHA384)
 by 0.0.0.0:2500 (trex/5.17.2); Fri, 26 Apr 2019 05:21:26 +0000
X-MC-Relay: Neutral
X-MailChannels-SenderId: tih5qno0ow|x-authuser|yamaoka@HIDDEN
X-MailChannels-Auth-Id: tih5qno0ow
X-Relation-Slimy: 2e8bffaa2fa9f6f7_1556256086297_3208961440
X-MC-Loop-Signature: 1556256086297:1713373362
X-MC-Ingress-Time: 1556256086297
Received: from s70.gtokyofl21.vectant.ne.jp ([202.215.75.70]:60000
 helo=localhost) by hampton.hostforweb.net with esmtpsa
 (TLSv1.2:ECDHE-RSA-AES256-GCM-SHA384:256) (Exim 4.89_1)
 (envelope-from <yamaoka@HIDDEN>)
 id 1hJtIP-003rqv-MO; Fri, 26 Apr 2019 00:21:15 -0500
Date: Fri, 26 Apr 2019 14:21:11 +0900
Message-ID: <b4ma7gd2vg8.fsf@HIDDEN>
From: Katsumi Yamaoka <yamaoka@HIDDEN>
To: Eric Abrahamsen <eric@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN> <b4mk1fl16oz.fsf@HIDDEN>
 <87sgu87ayo.fsf@HIDDEN> <b4md0lb4ykk.fsf@HIDDEN>
 <87k1fj49o2.fsf@HIDDEN> <b4m5zr3hsn0.fsf@HIDDEN>
 <87bm0uhxqy.fsf@HIDDEN>
Organization: Emacsen advocacy group
X-Face: #kKnN,xUnmKia.'[pp`;
 Omh}odZK)?7wQSl"4o04=EixTF+V[""w~iNbM9ZL+.b*_CxUmFk
 B#Fu[*?MZZH@IkN:!"\w%I_zt>[$nm7nQosZ<3eu; B:$Q_:p!',P.c0-_Cy[dz4oIpw0ESA^D*1Lw=
 L&i*6&(
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (x86_64-pc-cygwin)
Cancel-Lock: sha1:4tvPZm/vVRg8IWjVn0OHNxw20X4=
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
X-OutGoing-Spam-Status: No, score=-0.2
X-AuthUser: yamaoka@HIDDEN
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 35383
Cc: 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On Thu, 25 Apr 2019 09:10:13 -0700, Eric Abrahamsen wrote:
> On 04/25/19 08:48 AM, Katsumi Yamaoka wrote:

>> Warning: Warning - invalid active:

>> for the nnnil method, that is my `gnus-select-method'.  Here are
>> the contents of ~/News/agent/nnnil/agent.lib/active:

>> --8<---------------cut here---------------start------------->8---
>> ;; -*- encoding: utf-8-emacs; -*-

>> --8<---------------cut here---------------end--------------->8---

>> Why the warning is issued is to run (read (current-buffer)) at
>> the beginning of the contents.  This is actually an error but
>> `condition-case' conceals it.

> Hmm, this is all done in a temp buffer,

Yes.  When launching Gnus, the whole contents of the active file
are read into the " *nntpd*" buffer, copied into the temp buffer,
and parsed (see the flow summary attatched in the bottom of this
message for how Gnus behaves when launching).

> with
> `insert-buffer-substring' -- I wonder if the encoding cookie will even
> be honored in this case?

No, it's useless of course.  Moreover, --- I changed my idea
(patching the `gnus-active-to-gnus-format' function so as to
ignore the coding cookie) --- I come to think that the active
file should not contain the ones other than the active infos.
Gnus indeed ignores the coding cookie when parsing active, but
it is due to just a lucky side effect of `read':

(read ";; coding cookie\n\nactive_info\n") => active_info

I.e., `read' ignores comments in the ELisp style and whitespace.
However, in the first place, the active file is neither an ELisp
file nor there is no agreement for a comment style in it.  So, I
think it is better to bind `coding-system-for-(read|write)' while
reading and writing the active file rather than adding a coding
cookie.  Though binding `coding-system-for-(read|write)' would
probably be unnecessary since `gnus-write-active-file' binds
`coding-system-for-write' to `nnmail-active-file-coding-system',
and `gnus-agent-save-active' binds `coding-system-for-read' to
`gnus-agent-file-coding-system' that defaults to `utf-8-emacs'.
Therefore, adding a coding cookie was originally unnecessary,
wasn't it?

Here are how Gnus reads the active file for the nnnil method
observed in my system.  Note that `gnus-agent' is t (the default).

(gnus 1)
  [...]
  (gnus-setup-news nil t nil)
    (gnus-get-unread-articles 1 nil)
      (require 'gnus-agent)
      (with-current-buffer " *nntpd*"
        (gnus-read-active-file-1 '(nnnil) nil)
          (gnus-active-to-gnus-format '(nnnil) hashtb nil t)
            (gnus-agent-save-active '(nnil))
              (gnus-agent-write-active "active-file" hashtb)
                ;; Add a coding cookie.
                (gnus-write-active-file "active-file" hashtb nil)
              (erase-buffer)
              (nnheader-insert-file-contents "active-file")
            (_copy to_ " *nntpd*")
            (_parse it_)

Regards,

P.S.
I'll be not so active in the net for about ten days because of
the national holidays assoc with the era name changing in Japan.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 25 Apr 2019 16:10:23 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Apr 25 12:10:23 2019
Received: from localhost ([127.0.0.1]:59169 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hJgx5-0007Hj-5g
	for submit <at> debbugs.gnu.org; Thu, 25 Apr 2019 12:10:23 -0400
Received: from ericabrahamsen.net ([52.70.2.18]:59902
 helo=mail.ericabrahamsen.net)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eric@HIDDEN>) id 1hJgx3-0007HW-O5
 for 35383 <at> debbugs.gnu.org; Thu, 25 Apr 2019 12:10:22 -0400
Received: from localhost (75-172-115-9.tukw.qwest.net [75.172.115.9])
 (Authenticated sender: eric@HIDDEN)
 by mail.ericabrahamsen.net (Postfix) with ESMTPSA id 7EB2EFA05C;
 Thu, 25 Apr 2019 16:10:15 +0000 (UTC)
From: Eric Abrahamsen <eric@HIDDEN>
To: Katsumi Yamaoka <yamaoka@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN> <b4mk1fl16oz.fsf@HIDDEN>
 <87sgu87ayo.fsf@HIDDEN> <b4md0lb4ykk.fsf@HIDDEN>
 <87k1fj49o2.fsf@HIDDEN> <b4m5zr3hsn0.fsf@HIDDEN>
Date: Thu, 25 Apr 2019 09:10:13 -0700
In-Reply-To: <b4m5zr3hsn0.fsf@HIDDEN> (Katsumi Yamaoka's message of "Thu, 25
 Apr 2019 08:48:19 +0900")
Message-ID: <87bm0uhxqy.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 35383
Cc: 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


On 04/25/19 08:48 AM, Katsumi Yamaoka wrote:
> On Wed, 24 Apr 2019 10:04:13 -0700, Eric Abrahamsen wrote:
>> On 04/24/19 17:06 PM, Katsumi Yamaoka wrote:
>>> The root cause is this:
>>> (defvar nnmail-file-coding-system 'undecided
>>>   "Coding system used in nnmail.")
>>> The default value used to be `raw-text'.
>
>> Oh, that was a misunderstanding on my part, then -- I certainly didn't
>> mean to change anything about article encoding or display, or anything
>> related to MIME. I'll switch that default back again.
>
> Thanks.
>
> I found one more issue, it is harmless though.  An active file
> locally saved now has a coding cookie, so `(not (eobp))' at the
> line 2150 in gnus-start.el is not enough to check if there is no
> more active.  Because of this, when starting Gnus I got
>
> Warning: Warning - invalid active:
>
> for the nnnil method, that is my `gnus-select-method'.  Here are
> the contents of ~/News/agent/nnnil/agent.lib/active:
>
> --8<---------------cut here---------------start------------->8---
> ;; -*- encoding: utf-8-emacs; -*-
>
> --8<---------------cut here---------------end--------------->8---
>
> Why the warning is issued is to run (read (current-buffer)) at
> the beginning of the contents.  This is actually an error but
> `condition-case' conceals it.  A patch:
>
> --- gnus-start.el~	2019-04-23 05:13:52.741025900 +0000
> +++ gnus-start.el	2019-04-24 23:45:37.989239900 +0000
> @@ -2149,2 +2149,3 @@
>        (goto-char (point-min))
> +      (re-search-forward "\\(?:^[\n ]*;.*[\n ]*\\)+" nil t)
>        (while (not (eobp))

Hmm, this is all done in a temp buffer, with
`insert-buffer-substring' -- I wonder if the encoding cookie will even
be honored in this case? I need to do a bit more testing here. Thanks
for flagging this up.

Eric




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 24 Apr 2019 23:48:43 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Apr 24 19:48:43 2019
Received: from localhost ([127.0.0.1]:56822 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hJRd5-0006dI-6J
	for submit <at> debbugs.gnu.org; Wed, 24 Apr 2019 19:48:43 -0400
Received: from insect.birch.relay.mailchannels.net ([23.83.209.93]:5998)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <yamaoka@HIDDEN>) id 1hJRd2-0006d5-2X
 for 35383 <at> debbugs.gnu.org; Wed, 24 Apr 2019 19:48:42 -0400
X-Sender-Id: tih5qno0ow|x-authuser|yamaoka@HIDDEN
Received: from relay.mailchannels.net (localhost [127.0.0.1])
 by relay.mailchannels.net (Postfix) with ESMTP id ADDFC5E06D4;
 Wed, 24 Apr 2019 23:48:38 +0000 (UTC)
Received: from hampton.hostforweb.net
 (100-96-7-81.trex.outbound.svc.cluster.local [100.96.7.81])
 (Authenticated sender: tih5qno0ow)
 by relay.mailchannels.net (Postfix) with ESMTPA id 276285E05E8;
 Wed, 24 Apr 2019 23:48:30 +0000 (UTC)
X-Sender-Id: tih5qno0ow|x-authuser|yamaoka@HIDDEN
Received: from hampton.hostforweb.net ([TEMPUNAVAIL]. [172.245.115.217])
 (using TLSv1.2 with cipher DHE-RSA-AES256-GCM-SHA384)
 by 0.0.0.0:2500 (trex/5.17.2); Wed, 24 Apr 2019 23:48:38 +0000
X-MC-Relay: Neutral
X-MailChannels-SenderId: tih5qno0ow|x-authuser|yamaoka@HIDDEN
X-MailChannels-Auth-Id: tih5qno0ow
X-Grain-Industry: 3721bb1451e74418_1556149718457_1096194702
X-MC-Loop-Signature: 1556149718457:464360274
X-MC-Ingress-Time: 1556149718456
Received: from s70.gtokyofl21.vectant.ne.jp ([202.215.75.70]:60000
 helo=localhost) by hampton.hostforweb.net with esmtpsa
 (TLSv1.2:ECDHE-RSA-AES256-GCM-SHA384:256) (Exim 4.89_1)
 (envelope-from <yamaoka@HIDDEN>)
 id 1hJRcj-00DvVX-D2; Wed, 24 Apr 2019 18:48:22 -0500
Date: Thu, 25 Apr 2019 08:48:19 +0900
Message-ID: <b4m5zr3hsn0.fsf@HIDDEN>
From: Katsumi Yamaoka <yamaoka@HIDDEN>
To: Eric Abrahamsen <eric@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN> <b4mk1fl16oz.fsf@HIDDEN>
 <87sgu87ayo.fsf@HIDDEN> <b4md0lb4ykk.fsf@HIDDEN>
 <87k1fj49o2.fsf@HIDDEN>
Organization: Emacsen advocacy group
X-Face: #kKnN,xUnmKia.'[pp`;
 Omh}odZK)?7wQSl"4o04=EixTF+V[""w~iNbM9ZL+.b*_CxUmFk
 B#Fu[*?MZZH@IkN:!"\w%I_zt>[$nm7nQosZ<3eu; B:$Q_:p!',P.c0-_Cy[dz4oIpw0ESA^D*1Lw=
 L&i*6&(
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (x86_64-pc-cygwin)
Cancel-Lock: sha1:sKYMjKtF7yBwVhGY6DuBm7eFAsc=
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-OutGoing-Spam-Status: No, score=-0.2
X-AuthUser: yamaoka@HIDDEN
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 35383
Cc: 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--=-=-=

On Wed, 24 Apr 2019 10:04:13 -0700, Eric Abrahamsen wrote:
> On 04/24/19 17:06 PM, Katsumi Yamaoka wrote:
>> The root cause is this:
>> (defvar nnmail-file-coding-system 'undecided
>>   "Coding system used in nnmail.")
>> The default value used to be `raw-text'.

> Oh, that was a misunderstanding on my part, then -- I certainly didn't
> mean to change anything about article encoding or display, or anything
> related to MIME. I'll switch that default back again.

Thanks.

I found one more issue, it is harmless though.  An active file
locally saved now has a coding cookie, so `(not (eobp))' at the
line 2150 in gnus-start.el is not enough to check if there is no
more active.  Because of this, when starting Gnus I got

Warning: Warning - invalid active:

for the nnnil method, that is my `gnus-select-method'.  Here are
the contents of ~/News/agent/nnnil/agent.lib/active:

--8<---------------cut here---------------start------------->8---
;; -*- encoding: utf-8-emacs; -*-

--8<---------------cut here---------------end--------------->8---

Why the warning is issued is to run (read (current-buffer)) at
the beginning of the contents.  This is actually an error but
`condition-case' conceals it.  A patch:


--=-=-=
Content-Type: text/x-patch
Content-Disposition: inline

--- gnus-start.el~	2019-04-23 05:13:52.741025900 +0000
+++ gnus-start.el	2019-04-24 23:45:37.989239900 +0000
@@ -2149,2 +2149,3 @@
       (goto-char (point-min))
+      (re-search-forward "\\(?:^[\n ]*;.*[\n ]*\\)+" nil t)
       (while (not (eobp))

--=-=-=


Regards,

--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 24 Apr 2019 17:04:23 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Apr 24 13:04:23 2019
Received: from localhost ([127.0.0.1]:56383 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hJLJm-0001Gj-So
	for submit <at> debbugs.gnu.org; Wed, 24 Apr 2019 13:04:23 -0400
Received: from ericabrahamsen.net ([52.70.2.18]:54180
 helo=mail.ericabrahamsen.net)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eric@HIDDEN>) id 1hJLJl-0001GU-66
 for 35383 <at> debbugs.gnu.org; Wed, 24 Apr 2019 13:04:21 -0400
Received: from localhost (75-172-115-9.tukw.qwest.net [75.172.115.9])
 (Authenticated sender: eric@HIDDEN)
 by mail.ericabrahamsen.net (Postfix) with ESMTPSA id DCF53FA05C;
 Wed, 24 Apr 2019 17:04:14 +0000 (UTC)
From: Eric Abrahamsen <eric@HIDDEN>
To: Katsumi Yamaoka <yamaoka@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN> <b4mk1fl16oz.fsf@HIDDEN>
 <87sgu87ayo.fsf@HIDDEN> <b4md0lb4ykk.fsf@HIDDEN>
Date: Wed, 24 Apr 2019 10:04:13 -0700
In-Reply-To: <b4md0lb4ykk.fsf@HIDDEN> (Katsumi Yamaoka's message of "Wed, 24
 Apr 2019 17:06:19 +0900")
Message-ID: <87k1fj49o2.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 35383
Cc: 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


On 04/24/19 17:06 PM, Katsumi Yamaoka wrote:
> Hi,
>
> I found that certain kinds[1] of Japanese mails (like the
> attached text part) saved in a nnml group get corrupted when
> viewing.  The root cause is this:
>
> (defvar nnmail-file-coding-system 'undecided
>   "Coding system used in nnmail.")
>
> The default value used to be `raw-text'.
> Because `nnml-file-coding-system' inherits it, when viewing
> an article from a file `nnmail-find-file' reads and decodes
> the contents, and then `gnus-display-mime'[1] decodes it again.
> IIUC `gnus-display-mime' expects a raw article, so any back end
> should not decode the first fetched data, I think.  This helps:
>
> (setq nnml-file-coding-system 'raw-text)

Oh, that was a misunderstanding on my part, then -- I certainly didn't
mean to change anything about article encoding or display, or anything
related to MIME. I'll switch that default back again.

Thanks,
Eric




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 24 Apr 2019 08:06:30 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Apr 24 04:06:30 2019
Received: from localhost ([127.0.0.1]:54959 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hJCvG-00075j-3Q
	for submit <at> debbugs.gnu.org; Wed, 24 Apr 2019 04:06:30 -0400
Received: from cichlid.maple.relay.mailchannels.net ([23.83.214.36]:50687)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <yamaoka@HIDDEN>) id 1hJCvD-00075Z-Jz
 for 35383 <at> debbugs.gnu.org; Wed, 24 Apr 2019 04:06:28 -0400
X-Sender-Id: tih5qno0ow|x-authuser|yamaoka@HIDDEN
Received: from relay.mailchannels.net (localhost [127.0.0.1])
 by relay.mailchannels.net (Postfix) with ESMTP id 0E53B5C3BFD;
 Wed, 24 Apr 2019 08:06:26 +0000 (UTC)
Received: from hampton.hostforweb.net (unknown [100.96.11.48])
 (Authenticated sender: tih5qno0ow)
 by relay.mailchannels.net (Postfix) with ESMTPA id 620465C5231;
 Wed, 24 Apr 2019 08:06:25 +0000 (UTC)
X-Sender-Id: tih5qno0ow|x-authuser|yamaoka@HIDDEN
Received: from hampton.hostforweb.net (hampton.hostforweb.net
 [172.245.115.217])
 (using TLSv1.2 with cipher DHE-RSA-AES256-GCM-SHA384)
 by 0.0.0.0:2500 (trex/5.17.2); Wed, 24 Apr 2019 08:06:26 +0000
X-MC-Relay: Neutral
X-MailChannels-SenderId: tih5qno0ow|x-authuser|yamaoka@HIDDEN
X-MailChannels-Auth-Id: tih5qno0ow
X-Power-Vacuous: 0db731ea3e2beb94_1556093185692_1888278995
X-MC-Loop-Signature: 1556093185692:2108943223
X-MC-Ingress-Time: 1556093185692
Received: from s70.gtokyofl21.vectant.ne.jp ([202.215.75.70]:60000
 helo=localhost) by hampton.hostforweb.net with esmtpsa
 (TLSv1.2:ECDHE-RSA-AES256-GCM-SHA384:256) (Exim 4.89_1)
 (envelope-from <yamaoka@HIDDEN>)
 id 1hJCv7-009xTu-R7; Wed, 24 Apr 2019 03:06:23 -0500
Date: Wed, 24 Apr 2019 17:06:19 +0900
Message-ID: <b4md0lb4ykk.fsf@HIDDEN>
From: Katsumi Yamaoka <yamaoka@HIDDEN>
To: Eric Abrahamsen <eric@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN> <b4mk1fl16oz.fsf@HIDDEN>
 <87sgu87ayo.fsf@HIDDEN>
Organization: Emacsen advocacy group
X-Face: #kKnN,xUnmKia.'[pp`;
 Omh}odZK)?7wQSl"4o04=EixTF+V[""w~iNbM9ZL+.b*_CxUmFk
 B#Fu[*?MZZH@IkN:!"\w%I_zt>[$nm7nQosZ<3eu; B:$Q_:p!',P.c0-_Cy[dz4oIpw0ESA^D*1Lw=
 L&i*6&(
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (x86_64-pc-cygwin)
Cancel-Lock: sha1:GGaHRVMdG2CXbM5sMsvKd6BRRRA=
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-OutGoing-Spam-Status: No, score=-0.2
X-AuthUser: yamaoka@HIDDEN
X-Spam-Score: -0.2 (/)
X-Debbugs-Envelope-To: 35383
Cc: 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.2 (-)

--=-=-=

Hi,

I found that certain kinds[1] of Japanese mails (like the
attached text part) saved in a nnml group get corrupted when
viewing.  The root cause is this:

(defvar nnmail-file-coding-system 'undecided
  "Coding system used in nnmail.")

The default value used to be `raw-text'.
Because `nnml-file-coding-system' inherits it, when viewing
an article from a file `nnmail-find-file' reads and decodes
the contents, and then `gnus-display-mime'[1] decodes it again.
IIUC `gnus-display-mime' expects a raw article, so any back end
should not decode the first fetched data, I think.  This helps:

(setq nnml-file-coding-system 'raw-text)

Note that the backlog or the `gnus-original-article-buffer'
keeps an corrupted article, so (setq gnus-keep-backlog nil) and
each time killing the original buffer will make it easy to debug.

[1] a single text/plain part with format=flowed spec, or
    a multipart message containing a text/plain part, etc.
[2] The default value of `gnus-display-mime-function'.

Regards,

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Disposition: inline
Content-Transfer-Encoding: base64

5a+/6ZmQ54Sh5a+/6ZmQ54Sh5LqU5Yqr44Gu5pOm44KK5YiH44KM5rW356CC5Yip5rC06a2a44Gu
5rC06KGM5pyr6Zuy5p2l5pyr6aKo5p2l5pyr6aOf44GG5a+d44KLDQrlh6bjgavkvY/jgoDlh6bj
goTjgbbjgonlsI/ot6/jga7ol6rmn5HlrZDjg5HjgqTjg53jg5HjgqTjg53jg5HjgqTjg53jga7j
grfjg6Xjg7zjg6rjg7Pjgqzjg7MNCuOCt+ODpeODvOODquODs+OCrOODs+OBruOCsOODvOODquOD
s+ODgOOCpOOCsOODvOODquODs+ODgOOCpOOBruODneODs+ODneOCs+ODlOODvOOBruODneODs+OD
neOCsw0K44OK44O844Gu6ZW35LmF5ZG944Gu6ZW35YqpDQo=
--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 23 Apr 2019 23:00:58 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Apr 23 19:00:58 2019
Received: from localhost ([127.0.0.1]:54596 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hJ4PJ-0000Lp-Um
	for submit <at> debbugs.gnu.org; Tue, 23 Apr 2019 19:00:58 -0400
Received: from eggs.gnu.org ([209.51.188.92]:45631)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1hJ4PI-0000LZ-Dm
 for submit <at> debbugs.gnu.org; Tue, 23 Apr 2019 19:00:56 -0400
Received: from lists.gnu.org ([209.51.188.17]:42205)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1hJ4PC-0006ef-2d
 for submit <at> debbugs.gnu.org; Tue, 23 Apr 2019 19:00:51 -0400
Received: from eggs.gnu.org ([209.51.188.92]:59972)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1hJ4PB-0003BX-5H
 for bug-gnu-emacs@HIDDEN; Tue, 23 Apr 2019 19:00:49 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.8 required=5.0 tests=BAYES_40,FREEMAIL_FROM,
 RDNS_NONE autolearn=disabled version=3.3.2
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1hJ4NY-0003tT-Gw
 for bug-gnu-emacs@HIDDEN; Tue, 23 Apr 2019 18:59:10 -0400
Received: from [195.159.176.226] (port=40126 helo=blaine.gmane.org)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1hJ4NX-0003kr-J4
 for bug-gnu-emacs@HIDDEN; Tue, 23 Apr 2019 18:59:08 -0400
Received: from list by blaine.gmane.org with local (Exim 4.89)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1hJ4NN-0001rt-QW
 for bug-gnu-emacs@HIDDEN; Wed, 24 Apr 2019 00:58:57 +0200
X-Injected-Via-Gmane: http://gmane.org/
To: bug-gnu-emacs@HIDDEN
From: Andy Moreton <andrewjmoreton@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
Date: Tue, 23 Apr 2019 23:58:52 +0100
Message-ID: <868sw0cor7.fsf@HIDDEN>
References: <878sw1995f.fsf@HIDDEN> <vz11s1spw36.fsf@HIDDEN>
 <87h8ao760w.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (windows-nt)
Cancel-Lock: sha1:ZvUV5/VgjzB3zOpWzBHixKFkSzw=
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 195.159.176.226
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Spam-Score: -1.1 (-)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.1 (--)

On Tue 23 Apr 2019, Eric Abrahamsen wrote:

> Aha! Good catch. The attached patch fixes things for me. At first I was
> a little hesitant to assume all group names are decodable as
> 'utf-8-emacs, but then I figured that's all that
> `gnus-group-decoded-name' does, and that's worked for years, so I guess
> this is safe.

Yes, the patch fixes things here too.

    AndyM





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 23 Apr 2019 21:42:34 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Apr 23 17:42:34 2019
Received: from localhost ([127.0.0.1]:54510 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hJ3BR-0006qI-Po
	for submit <at> debbugs.gnu.org; Tue, 23 Apr 2019 17:42:34 -0400
Received: from ericabrahamsen.net ([52.70.2.18]:56948
 helo=mail.ericabrahamsen.net)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eric@HIDDEN>) id 1hJ3BP-0006q1-Cf
 for 35383 <at> debbugs.gnu.org; Tue, 23 Apr 2019 17:42:32 -0400
Received: from localhost (75-172-115-9.tukw.qwest.net [75.172.115.9])
 (Authenticated sender: eric@HIDDEN)
 by mail.ericabrahamsen.net (Postfix) with ESMTPSA id 8845BFA05C
 for <35383 <at> debbugs.gnu.org>; Tue, 23 Apr 2019 21:42:24 +0000 (UTC)
From: Eric Abrahamsen <eric@HIDDEN>
To: 35383 <at> debbugs.gnu.org
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN> <vz11s1spw36.fsf@HIDDEN>
Date: Tue, 23 Apr 2019 14:42:23 -0700
In-Reply-To: <vz11s1spw36.fsf@HIDDEN> (Andy Moreton's message of "Tue, 23
 Apr 2019 16:42:05 +0100")
Message-ID: <87h8ao760w.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 35383
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable

Andy Moreton <andrewjmoreton@HIDDEN> writes:

> On Mon 22 Apr 2019, Eric Abrahamsen wrote:
>
>> This is part two and the completion of bug#33653, which changed Gnus's
>> obarrays into hash tables, and group names from symbols to (encoded)
>> strings. The commits in the recently-pushed "scratch/gnus-decoded"
>> branch change group names to decoded strings.
>>
>> Bug 33653 was a mess for a few reasons: I partitioned the changes
>> poorly, didn't call for testers, and it turned out that I was locally
>> testing a mismash of that change plus a couple changes included in this
>> branch, which hid some bugs.
>>
>> This time around I'll keep it cleaner: I'll locally test only this
>> change in isolation, I'm writing a semi-interactive test suite for Gnus,
>> and in a few weeks I'll rope in three or four users to road-test the
>> changes. The upside is that, once these changes are stabilized and put
>> in, it will eliminate a whole class of potential bugs.
>>
>> In the meantime I'm hanging this here as a placeholder. If any brave
>> soul does decide to give it a test-run in the meantime, back up your
>> .newsrc.eld file first!
>
> There don;t seem to bnbe any problems with the .nersrc.eld, as I have
> used the same file in emacs-26, master and scratch/gnus-decoded branches
> without obvious problems.
>
> There is a problem in the server buffer in the scratch/gnus-decoded buffer
> with group names. In my setup:
> 1) Start gnus, and open the server buffer
> 2) Select the feedbase server. This is configured as:
>
>   (gnus-secondary-select-methods
>    '((nntp "feedbase"
>            (nntp-open-connection-function nntp-open-tls-stream)
>            (nntp-port-number 563)
>            (nntp-address "feedbase.org"))
>      ...
>
> 3) Note that some group names are not decoded correctly in the server
> buffer. The group names are decoded properly in the article buffer.
>
> For example, (showing only names with problems):
>
> server buffer (master branch):
>
> K    140: feedbase.blog.k=C3=B8benhavnsskiklub
> K    208: feedbase.news.brk.h=C3=B8ringer
> K   2017: feedbase.news.dr.hovedstadsomr=C3=A5det
>
>
> server buffer (scratch/gnus-decoded branch):
>
> K    140: feedbase.blog.k\303\270benhavnsskiklub
> K    208: feedbase.news.brk.h\303\270ringer
> K   2017: feedbase.news.dr.hovedstadsomr\303\245det
>
> The raw bytes (shown as escapes above) match the UTF-8 for the expected
> characters, so the decoding is not quite right.

Aha! Good catch. The attached patch fixes things for me. At first I was
a little hesitant to assume all group names are decodable as
'utf-8-emacs, but then I figured that's all that
`gnus-group-decoded-name' does, and that's worked for years, so I guess
this is safe.

And thanks for the nntp server with non-ascii group names! I had looked
for one of those with no success, this will be very useful for testing.

Eric



--=-=-=
Content-Type: text/x-patch
Content-Disposition: attachment; filename=gnus-browse-srv-decoded.diff

diff --git a/lisp/gnus/gnus-srvr.el b/lisp/gnus/gnus-srvr.el
index 2328f1da16..da110c8bbf 100644
--- a/lisp/gnus/gnus-srvr.el
+++ b/lisp/gnus/gnus-srvr.el
@@ -784,11 +784,13 @@ gnus-browse-foreign-server
 	      (while (not (eobp))
 		(ignore-errors
 		  (push (cons
-			 (buffer-substring
-			  (point)
-			  (progn
-			    (skip-chars-forward "^ \t")
-			    (point)))
+			 (decode-coding-string
+			  (buffer-substring
+			   (point)
+			   (progn
+			     (skip-chars-forward "^ \t")
+			     (point)))
+			  'utf-8-emacs)
 			 (let ((last (read cur)))
 			   (cons (read cur) last)))
 			groups))
@@ -796,18 +798,20 @@ gnus-browse-foreign-server
 	    (while (not (eobp))
 	      (ignore-errors
 		(push (cons
-		       (if (eq (char-after) ?\")
-			   (read cur)
-			 (let ((p (point)) (name ""))
-			   (skip-chars-forward "^ \t\\\\")
-			   (setq name (buffer-substring p (point)))
-			   (while (eq (char-after) ?\\)
-			     (setq p (1+ (point)))
-			     (forward-char 2)
-			     (skip-chars-forward "^ \t\\\\")
-			     (setq name (concat name (buffer-substring
-						      p (point)))))
-			   name))
+		       (decode-coding-string
+			(if (eq (char-after) ?\")
+			    (read cur)
+			  (let ((p (point)) (name ""))
+			    (skip-chars-forward "^ \t\\\\")
+			    (setq name (buffer-substring p (point)))
+			    (while (eq (char-after) ?\\)
+			      (setq p (1+ (point)))
+			      (forward-char 2)
+			      (skip-chars-forward "^ \t\\\\")
+			      (setq name (concat name (buffer-substring
+						       p (point)))))
+			    name))
+			'utf-8-emacs)
 		       (let ((last (read cur)))
 			 (cons (read cur) last)))
 		      groups))

--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 23 Apr 2019 19:55:57 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Apr 23 15:55:57 2019
Received: from localhost ([127.0.0.1]:54422 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hJ1WH-0008Vk-DV
	for submit <at> debbugs.gnu.org; Tue, 23 Apr 2019 15:55:57 -0400
Received: from ericabrahamsen.net ([52.70.2.18]:54702
 helo=mail.ericabrahamsen.net)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eric@HIDDEN>) id 1hJ1WB-0008VI-GS
 for 35383 <at> debbugs.gnu.org; Tue, 23 Apr 2019 15:55:53 -0400
Received: from localhost (75-172-115-9.tukw.qwest.net [75.172.115.9])
 (Authenticated sender: eric@HIDDEN)
 by mail.ericabrahamsen.net (Postfix) with ESMTPSA id 25950FA027;
 Tue, 23 Apr 2019 19:55:44 +0000 (UTC)
From: Eric Abrahamsen <eric@HIDDEN>
To: Katsumi Yamaoka <yamaoka@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN> <b4mk1fl16oz.fsf@HIDDEN>
Date: Tue, 23 Apr 2019 12:55:43 -0700
In-Reply-To: <b4mk1fl16oz.fsf@HIDDEN> (Katsumi Yamaoka's message of "Tue, 23
 Apr 2019 17:12:12 +0900")
Message-ID: <87sgu87ayo.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 35383
Cc: 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


On 04/23/19 17:12 PM, Katsumi Yamaoka wrote:
> On Mon, 22 Apr 2019 11:39:40 -0700, Eric Abrahamsen wrote:
>> This is part two and the completion of bug#33653, which changed Gnus's
>> obarrays into hash tables, and group names from symbols to (encoded)
>> strings. The commits in the recently-pushed "scratch/gnus-decoded"
>> branch change group names to decoded strings.
>
>> Bug 33653 was a mess for a few reasons: I partitioned the changes
>> poorly, didn't call for testers, and it turned out that I was locally
>> testing a mismash of that change plus a couple changes included in this
>> branch, which hid some bugs.
>
>> This time around I'll keep it cleaner: I'll locally test only this
>> change in isolation, I'm writing a semi-interactive test suite for Gnus,
>> and in a few weeks I'll rope in three or four users to road-test the
>> changes. The upside is that, once these changes are stabilized and put
>> in, it will eliminate a whole class of potential bugs.
>
>> In the meantime I'm hanging this here as a placeholder. If any brave
>> soul does decide to give it a test-run in the meantime, back up your
>> .newsrc.eld file first!
>
> No problem for hours.  Maybe it has been completed already?
> I believe I can live with it anyway.  Though I'm not quite sure
> yet, the new and the old newsrc.eld files (containing non-ASCII
> nnml and nnrss groups) seem to be compatible with the new and
> the old Gnus mutually.  That is, I didn't need to do something
> special on the newsrc.eld file.

Yes, I also noticed that a fully-decoded .newsrc.eld actually seems to
work fine with both the new and the old code. But better to be cautious.

> ;; Where `new' means that of the scratch/gnus-decoded branch,
> ;; and `old' means that of Emacs 26.2.50.
>
> Regards,

Thanks for testing!




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 23 Apr 2019 15:42:23 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Apr 23 11:42:23 2019
Received: from localhost ([127.0.0.1]:54131 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hIxYt-0002PZ-Ef
	for submit <at> debbugs.gnu.org; Tue, 23 Apr 2019 11:42:23 -0400
Received: from eggs.gnu.org ([209.51.188.92]:50282)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1hIxYs-0002PN-Fr
 for submit <at> debbugs.gnu.org; Tue, 23 Apr 2019 11:42:22 -0400
Received: from lists.gnu.org ([209.51.188.17]:48017)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1hIxYn-0008Sz-BC
 for submit <at> debbugs.gnu.org; Tue, 23 Apr 2019 11:42:17 -0400
Received: from eggs.gnu.org ([209.51.188.92]:36431)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1hIxYm-00048T-4X
 for bug-gnu-emacs@HIDDEN; Tue, 23 Apr 2019 11:42:17 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: *
X-Spam-Status: No, score=1.6 required=5.0 tests=BAYES_50,FREEMAIL_FROM,
 RDNS_NONE,URIBL_BLOCKED autolearn=disabled version=3.3.2
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1hIxYk-0008OU-WA
 for bug-gnu-emacs@HIDDEN; Tue, 23 Apr 2019 11:42:16 -0400
Received: from [195.159.176.226] (port=56048 helo=blaine.gmane.org)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <geb-bug-gnu-emacs@HIDDEN>)
 id 1hIxYk-0008O2-Ov
 for bug-gnu-emacs@HIDDEN; Tue, 23 Apr 2019 11:42:14 -0400
Received: from list by blaine.gmane.org with local (Exim 4.89)
 (envelope-from <geb-bug-gnu-emacs@HIDDEN>) id 1hIxYi-000VdJ-HY
 for bug-gnu-emacs@HIDDEN; Tue, 23 Apr 2019 17:42:12 +0200
X-Injected-Via-Gmane: http://gmane.org/
To: bug-gnu-emacs@HIDDEN
From: Andy Moreton <andrewjmoreton@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
Date: Tue, 23 Apr 2019 16:42:05 +0100
Message-ID: <vz11s1spw36.fsf@HIDDEN>
References: <878sw1995f.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (windows-nt)
Cancel-Lock: sha1:Cw9ogP5Ykn1gNjxQCi3Ug6JgQ/g=
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 195.159.176.226
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Spam-Score: -1.1 (-)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.1 (--)

On Mon 22 Apr 2019, Eric Abrahamsen wrote:

> This is part two and the completion of bug#33653, which changed Gnus's
> obarrays into hash tables, and group names from symbols to (encoded)
> strings. The commits in the recently-pushed "scratch/gnus-decoded"
> branch change group names to decoded strings.
>
> Bug 33653 was a mess for a few reasons: I partitioned the changes
> poorly, didn't call for testers, and it turned out that I was locally
> testing a mismash of that change plus a couple changes included in this
> branch, which hid some bugs.
>
> This time around I'll keep it cleaner: I'll locally test only this
> change in isolation, I'm writing a semi-interactive test suite for Gnus,
> and in a few weeks I'll rope in three or four users to road-test the
> changes. The upside is that, once these changes are stabilized and put
> in, it will eliminate a whole class of potential bugs.
>
> In the meantime I'm hanging this here as a placeholder. If any brave
> soul does decide to give it a test-run in the meantime, back up your
> .newsrc.eld file first!

There don;t seem to bnbe any problems with the .nersrc.eld, as I have
used the same file in emacs-26, master and scratch/gnus-decoded branches
without obvious problems.

There is a problem in the server buffer in the scratch/gnus-decoded buffer
with group names. In my setup:
1) Start gnus, and open the server buffer
2) Select the feedbase server. This is configured as:

  (gnus-secondary-select-methods
   '((nntp "feedbase"
           (nntp-open-connection-function nntp-open-tls-stream)
           (nntp-port-number 563)
           (nntp-address "feedbase.org"))
     ...

3) Note that some group names are not decoded correctly in the server
buffer. The group names are decoded properly in the article buffer.

For example, (showing only names with problems):

server buffer (master branch):

K    140: feedbase.blog.københavnsskiklub
K    208: feedbase.news.brk.høringer
K   2017: feedbase.news.dr.hovedstadsområdet


server buffer (scratch/gnus-decoded branch):

K    140: feedbase.blog.k\303\270benhavnsskiklub
K    208: feedbase.news.brk.h\303\270ringer
K   2017: feedbase.news.dr.hovedstadsomr\303\245det

The raw bytes (shown as escapes above) match the UTF-8 for the expected
characters, so the decoding is not quite right.

    AndyM





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at 35383 <at> debbugs.gnu.org:


Received: (at 35383) by debbugs.gnu.org; 23 Apr 2019 08:12:27 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Apr 23 04:12:27 2019
Received: from localhost ([127.0.0.1]:52276 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hIqXT-0003tx-BT
	for submit <at> debbugs.gnu.org; Tue, 23 Apr 2019 04:12:27 -0400
Received: from bonobo.maple.relay.mailchannels.net ([23.83.214.22]:20723)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <yamaoka@HIDDEN>) id 1hIqXR-0003to-Lj
 for 35383 <at> debbugs.gnu.org; Tue, 23 Apr 2019 04:12:26 -0400
X-Sender-Id: tih5qno0ow|x-authuser|yamaoka@HIDDEN
Received: from relay.mailchannels.net (localhost [127.0.0.1])
 by relay.mailchannels.net (Postfix) with ESMTP id 60A798C16A2;
 Tue, 23 Apr 2019 08:12:24 +0000 (UTC)
Received: from hampton.hostforweb.net
 (100-96-2-149.trex.outbound.svc.cluster.local [100.96.2.149])
 (Authenticated sender: tih5qno0ow)
 by relay.mailchannels.net (Postfix) with ESMTPA id 50ED08C179A;
 Tue, 23 Apr 2019 08:12:23 +0000 (UTC)
X-Sender-Id: tih5qno0ow|x-authuser|yamaoka@HIDDEN
Received: from hampton.hostforweb.net ([TEMPUNAVAIL]. [172.245.115.217])
 (using TLSv1.2 with cipher DHE-RSA-AES256-GCM-SHA384)
 by 0.0.0.0:2500 (trex/5.17.2); Tue, 23 Apr 2019 08:12:24 +0000
X-MC-Relay: Neutral
X-MailChannels-SenderId: tih5qno0ow|x-authuser|yamaoka@HIDDEN
X-MailChannels-Auth-Id: tih5qno0ow
X-Befitting-Whispering: 67666fc15f7065f2_1556007144121_2645081903
X-MC-Loop-Signature: 1556007144120:4089807231
X-MC-Ingress-Time: 1556007144120
Received: from s70.gtokyofl21.vectant.ne.jp ([202.215.75.70]:60000
 helo=localhost) by hampton.hostforweb.net with esmtpsa
 (TLSv1.2:ECDHE-RSA-AES256-GCM-SHA384:256) (Exim 4.89_1)
 (envelope-from <yamaoka@HIDDEN>)
 id 1hIqXH-003Xj4-CS; Tue, 23 Apr 2019 03:12:16 -0500
Date: Tue, 23 Apr 2019 17:12:12 +0900
Message-ID: <b4mk1fl16oz.fsf@HIDDEN>
From: Katsumi Yamaoka <yamaoka@HIDDEN>
To: Eric Abrahamsen <eric@HIDDEN>
Subject: Re: bug#35383: 27.0.50; Complete process of decoding Gnus group names
References: <878sw1995f.fsf@HIDDEN>
Organization: Emacsen advocacy group
X-Face: #kKnN,xUnmKia.'[pp`;
 Omh}odZK)?7wQSl"4o04=EixTF+V[""w~iNbM9ZL+.b*_CxUmFk
 B#Fu[*?MZZH@IkN:!"\w%I_zt>[$nm7nQosZ<3eu; B:$Q_:p!',P.c0-_Cy[dz4oIpw0ESA^D*1Lw=
 L&i*6&(
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (x86_64-pc-cygwin)
Cancel-Lock: sha1:/0sv2s460PDB7Dx5HnRegT1oBDk=
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
X-OutGoing-Spam-Status: No, score=-0.2
X-AuthUser: yamaoka@HIDDEN
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 35383
Cc: 35383 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On Mon, 22 Apr 2019 11:39:40 -0700, Eric Abrahamsen wrote:
> This is part two and the completion of bug#33653, which changed Gnus's
> obarrays into hash tables, and group names from symbols to (encoded)
> strings. The commits in the recently-pushed "scratch/gnus-decoded"
> branch change group names to decoded strings.

> Bug 33653 was a mess for a few reasons: I partitioned the changes
> poorly, didn't call for testers, and it turned out that I was locally
> testing a mismash of that change plus a couple changes included in this
> branch, which hid some bugs.

> This time around I'll keep it cleaner: I'll locally test only this
> change in isolation, I'm writing a semi-interactive test suite for Gnus,
> and in a few weeks I'll rope in three or four users to road-test the
> changes. The upside is that, once these changes are stabilized and put
> in, it will eliminate a whole class of potential bugs.

> In the meantime I'm hanging this here as a placeholder. If any brave
> soul does decide to give it a test-run in the meantime, back up your
> .newsrc.eld file first!

No problem for hours.  Maybe it has been completed already?
I believe I can live with it anyway.  Though I'm not quite sure
yet, the new and the old newsrc.eld files (containing non-ASCII
nnml and nnrss groups) seem to be compatible with the new and
the old Gnus mutually.  That is, I didn't need to do something
special on the newsrc.eld file.

;; Where `new' means that of the scratch/gnus-decoded branch,
;; and `old' means that of Emacs 26.2.50.

Regards,




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 22 Apr 2019 18:41:19 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Apr 22 14:41:19 2019
Received: from localhost ([127.0.0.1]:51592 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hIdsV-0002kK-3x
	for submit <at> debbugs.gnu.org; Mon, 22 Apr 2019 14:41:19 -0400
Received: from eggs.gnu.org ([209.51.188.92]:51081)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eric@HIDDEN>) id 1hIdsU-0002k7-AS
 for submit <at> debbugs.gnu.org; Mon, 22 Apr 2019 14:41:18 -0400
Received: from lists.gnu.org ([209.51.188.17]:47908)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <eric@HIDDEN>)
 id 1hIdsP-0002zH-58
 for submit <at> debbugs.gnu.org; Mon, 22 Apr 2019 14:41:13 -0400
Received: from eggs.gnu.org ([209.51.188.92]:37181)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <eric@HIDDEN>) id 1hIdsO-0002dO-8c
 for bug-gnu-emacs@HIDDEN; Mon, 22 Apr 2019 14:41:13 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.8 required=5.0 tests=BAYES_50 autolearn=disabled
 version=3.3.2
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <eric@HIDDEN>) id 1hIdr5-0002M6-AD
 for bug-gnu-emacs@HIDDEN; Mon, 22 Apr 2019 14:39:53 -0400
Received: from ericabrahamsen.net ([52.70.2.18]:60212
 helo=mail.ericabrahamsen.net)
 by eggs.gnu.org with esmtps (TLS1.0:DHE_RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <eric@HIDDEN>)
 id 1hIdr4-0002HZ-Iv
 for bug-gnu-emacs@HIDDEN; Mon, 22 Apr 2019 14:39:51 -0400
Received: from localhost (75-172-115-9.tukw.qwest.net [75.172.115.9])
 (Authenticated sender: eric@HIDDEN)
 by mail.ericabrahamsen.net (Postfix) with ESMTPSA id 6CD5EFA026
 for <bug-gnu-emacs@HIDDEN>; Mon, 22 Apr 2019 18:39:41 +0000 (UTC)
From: Eric Abrahamsen <eric@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Subject: 27.0.50; Complete process of decoding Gnus group names
Date: Mon, 22 Apr 2019 11:39:40 -0700
Message-ID: <878sw1995f.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 52.70.2.18
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Spam-Score: -1.4 (-)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.4 (--)


This is part two and the completion of bug#33653, which changed Gnus's
obarrays into hash tables, and group names from symbols to (encoded)
strings. The commits in the recently-pushed "scratch/gnus-decoded"
branch change group names to decoded strings.

Bug 33653 was a mess for a few reasons: I partitioned the changes
poorly, didn't call for testers, and it turned out that I was locally
testing a mismash of that change plus a couple changes included in this
branch, which hid some bugs.

This time around I'll keep it cleaner: I'll locally test only this
change in isolation, I'm writing a semi-interactive test suite for Gnus,
and in a few weeks I'll rope in three or four users to road-test the
changes. The upside is that, once these changes are stabilized and put
in, it will eliminate a whole class of potential bugs.

In the meantime I'm hanging this here as a placeholder. If any brave
soul does decide to give it a test-run in the meantime, back up your
.newsrc.eld file first!

Eric




Acknowledgement sent to Eric Abrahamsen <eric@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#35383; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Fri, 27 Sep 2019 15:00:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.